<?php
/*********************************************************************************
  ** The contents of this file are subject to the vtiger CRM Public License Version 1.0
   * ("License"); You may not use this file except in compliance with the License
   * The Original Code is:  vtiger CRM Open Source
   * The Initial Developer of the Original Code is crmvillage.biz.
   * Portions created by crmvillage.biz are Copyright (C) crmvillage.biz.
   * All Rights Reserved.
  *
 ********************************************************************************/

require_once('config.inc.php');
/** Verify the script call is from trusted place. */
global $application_unique_key;
if($_REQUEST['app_key'] != $application_unique_key) {
	echo "Access denied!";
	exit;
}

/**
 * Check if instance of this service is already running?
 */
$svcname = $_REQUEST['service'];
// We need to make sure the PIDfile name is unqique
$servicePIDFile = "logs/$svcname-service.pid";

if(file_exists($servicePIDFile)) {
	if (filemtime($servicePIDFile) <= strtotime('-1 hour')) {
		@unlink($servicePIDFile);
		$servicePIDFp = fopen($servicePIDFile, 'a');
	} else {
		echo "Service $svcname already running! Check $servicePIDFile";
		exit;
	}
} else {
	$servicePIDFp = fopen($servicePIDFile, 'a');
}

/**
 * Turn-off PHP error reporting.
 */
try { error_reporting(0); } catch(Exception $e) { }

require_once('include/utils/utils.php');
require_once('include/logging.php');
require_once('modules/SLA/SLA.php');

// Get the list of Invoice for which Recurring is enabled.

global $adb, $log;
$log =& LoggerManager::getLogger('SLA');
$log->debug("invoked SLA");

global $current_user,$table_prefix;
$sla_config_global = SLA::get_config();

foreach ($sla_config_global as $module=>$sla_config){
	$query =  "SELECT tablename,fieldname,columnname FROM ".$table_prefix."_field WHERE tabid=? and presence in (0,2) and tablename <> ?";
	$params = Array(getTabId($module),$table_prefix.'_ticketcomments');
	$res = $adb->pquery($query,$params);
	if ($res){
		while ($row = $adb->fetchByAssoc($res,-1,false)){
			$fields[$row['fieldname']] = $row['tablename'].".".$row['columnname'];
			$fields_select[$row['fieldname']] = $row['columnname'];
		}
	}
	$current_user->id = 1;
	$current_user->date_format = 'yyyy-mm-dd';
	$params = Array();
	$where = "and ended_sla <> ?";
	$params[] = 1;
	$list_query = replaceSelectQuery(getListQuery($module,$where),implode(",",$fields).",{$table_prefix}_crmentity.crmid")." order by {$table_prefix}_crmentity.modifiedtime asc"; //crmv@36796
	//echo $adb->convert2Sql($list_query,$adb->flatten_array($params));
	$list_res = $adb->pquery($list_query,$params);
	if ($list_res && $adb->num_rows($list_res) > 0){
		$lastslacalc = time(); //crmv@36796
		while ($row = $adb->fetchByAssoc($list_res,-1,false)){
			$focus = CRMEntity::getInstance($module);
			$focus->id = $row['crmid'];
			$focus->mode = 'edit';
			$focus->column_fields["record_id"] = $row['crmid'];
			$focus->column_fields["record_module"] = $module;
			foreach ($fields_select as $fieldname=>$columnname){
				$focus->column_fields[$fieldname] = $row[$columnname];
			}
			$focus->save($module);
			//crmv@36796
			if ($lastslacalc < strtotime('-10 seconds')){
				$lastslacalc = time();
				touch($servicePIDFile);
			}
			//crmv@36796 e			
		}
	}
}
$log->debug("end SLA procedure");
/** Close and remove the PID file. */
if($servicePIDFp) {
	fclose($servicePIDFp);
	unlink($servicePIDFile);
}

?>