<?php
//crmv@start
class ChangeLogHandler extends VTEventHandler {
	function handleEvent($eventName, $entityData) {
		global $table_prefix;
		global $log, $adb,$current_user,$record_init,$record_last,$currentModule;
		
		$currentModule_tmp = $currentModule;
		$currentModule = 'ChangeLog';
		$moduleName = $entityData->getModuleName();
		$entityData->date = date('Y-m-d H:i:s');
		$id = $entityData->getId();
		$obj = CRMEntity::getInstance('ChangeLog');
		
		$fields_to_jump_module = array('HelpDesk'=>array('modifiedtime','update_log','time_elapsed','time_remaining','start_sla','end_sla','time_refresh','time_change_status','time_elapsed_change_status','ended_sla','time_elapsed_idle','time_elapsed_out_sla'),'Events'=>array('duration_hours','duration_minutes'),'MorphsuitServer'=>array('morphsuit_key','morphsuit_new_key'));	//fields to jump in relative module
		$fields_to_jump = array();	//fields to jump in each modules
		
		if($moduleName == 'Activity'){
			$moduleName = 'Calendar';
		}
		
		if ($moduleName != 'ChangeLog' && $obj->isEnabled($moduleName) && !$entityData->isNew()){ //crmv@47905
			
			if($moduleName == 'Calendar'){
				if($_REQUEST['activity_mode'] == 'Events'){
					$moduleName = 'Events';
				}
			}
			
			if ($moduleName != 'Users'){
				if($eventName == 'history_first' && empty($record_init) && empty($record_last)) { //se il record  modificato
					$proj = CRMEntity::getInstance($moduleName);
					$proj->mode = 'edit';
					$proj->id = $id;
					$proj->retrieve_entity_info_no_html($id,$moduleName);
					$record_init = $proj->column_fields; //scrivo la column_fields attuale in json nel campo description
				}
				elseif($eventName == 'history_last' && !empty($record_init)){
					$data = array_filter($entityData->getData());
					$data_encoded = Zend_Json::encode($data);
					$id = $entityData->getId();
					$obj = CRMEntity::getInstance('ChangeLog');
					$nr_rev = $this->get_revision_id($id);
					$obj->column_fields['audit_no'] = $nr_rev;//versione record calcolata
					$obj->column_fields['assigned_user_id'] = $current_user->id; //utente corrente
					$obj->column_fields['parent_id'] = $id; //id entit collegata
					$proj = CRMEntity::getInstance($moduleName);
					$proj->mode = 'edit';
					$proj->id = $id;
					$proj->retrieve_entity_info_no_html($id,$moduleName);
					$record_last = $proj->column_fields;
					$result = array_diff_assoc($record_init, $record_last);
					$final_record = Array();
					$campi = array();
					$obj->column_fields['user_name'] = $current_user->column_fields['user_name'];
					$q = "SELECT fieldname, fieldlabel, fieldtype, readonly, {$table_prefix}_field.uitype FROM ".$table_prefix."_field LEFT JOIN ".$table_prefix."_ws_fieldtype ON ".$table_prefix."_field.uitype = ".$table_prefix."_ws_fieldtype.uitype WHERE tabid = (SELECT tabid FROM ".$table_prefix."_tab WHERE name = ?)"; // crmv@31240 crmv@37679
					$ress = $adb->pquery($q, array($moduleName));
					$label = array();
					$types = array();
					while($row = $adb->fetchByAssoc($ress)){
						$label[$row['fieldname']] =  $row['fieldlabel'];
						$types[$row['fieldname']] =  $row['fieldtype'];
						$readonly[$row['fieldname']] =  $row['readonly']; // crmv@31240
						if ($row['uitype'] == '208') $fields_to_jump_module[$moduleName][] = $row['fieldname']; // crmv@37679
					}
						
					foreach ($result as $key=>$value){

						if($readonly[$key] == '100') continue; // crmv@31240

						$previous_value = $record_init[$key];
						$current_value = $record_last[$key];

						if($types[$key] == 'owner'){
							$group_name = getGroupName($previous_value);
							if($group_name['0'] !=''){
								$previous_value = $group_name['0'];
								$group_name = array();
							}else{
								$previous_value = getUserName($previous_value);
							}
								
							$group_name = getGroupName($current_value);
							if($group_name['0'] !=''){
								$current_value = $group_name['0'];
								$group_name = array();
							}else{
								$current_value = getUserName($current_value);
							}
						}
						if (strtolower($key) == 'modifiedtime') {
							$obj->column_fields['modified_date'] = $proj->column_fields[$key]; 
						} elseif(in_array($key, $fields_to_jump) || (isset($fields_to_jump_module[$moduleName]) && in_array($key,$fields_to_jump_module[$moduleName]))) {
						} else {
							$campi[] = array($label[$key], $previous_value, $current_value, $key, $types[$key]);
						}
					}
					$record_init = '';
					$record_last = '';
					if (!empty($campi)) {	//se non c' nessuna differenza non creo il ChangeLog
						$obj->column_fields['description'] = Zend_Json::encode($campi);
						$obj->save('ChangeLog',false,false,false); //crmv@47905
					}
				}
			}
		}
		
		$currentModule = $currentModule_tmp;
	}
	function get_revision_id($id){
		global $adb,$current_user;
		global $table_prefix;
		$current_user_backup = $current_user->id;
		$current_user->id = 1;
		$last_autid_no = 1.0;
		$sql = "SELECT audit_no FROM ".$table_prefix."_changelog 
			INNER JOIN ".$table_prefix."_crmentity ON ".$table_prefix."_crmentity.crmid = ".$table_prefix."_changelog.changelogid 
			INNER JOIN ".$table_prefix."_changelogcf ON ".$table_prefix."_changelogcf.changelogid = ".$table_prefix."_changelog.changelogid 
			LEFT JOIN ".$table_prefix."_users ON ".$table_prefix."_users.id = ".$table_prefix."_crmentity.smownerid 
			LEFT JOIN ".$table_prefix."_groups ON ".$table_prefix."_groups.groupid = ".$table_prefix."_crmentity.smownerid 
			WHERE ".$table_prefix."_changelog.changelogid > 0 AND ".$table_prefix."_crmentity.deleted = 0 AND ".$table_prefix."_changelog.parent_id= ? ORDER BY audit_no DESC";
		$res = $adb->pquery($sql,Array($id));
		if ($res && $adb->num_rows($res) > 0){
			$last_autid_no = (float)$adb->query_result_no_html($res,0,'audit_no')+0.1;
		}
		$current_user->id = $current_user_backup;
		return $last_autid_no;
	}
}
//crmv@end
?>