<?php
/*+**********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ************************************************************************************/
global $currentModule;
$modObj = CRMEntity::getInstance($currentModule);

$ajaxaction = $_REQUEST["ajxaction"];

if($ajaxaction == 'WIDGETADDCOMMENT') {
	global $current_user;
	if (isPermitted($currentModule, 'EditView', '') == 'yes') {
		$modObj->column_fields['commentcontent'] = vtlib_purify(strip_tags($_REQUEST['comment']));
		$modObj->column_fields['related_to'] = vtlib_purify($_REQUEST['parentid']);
		$modObj->column_fields['visibility_comm'] = vtlib_purify($_REQUEST['visibility']);
		$modObj->column_fields['assigned_user_id'] = $current_user->id;
		$modObj->save($currentModule);
	
		if(empty($modObj->column_fields['smcreatorid'])) $modObj->column_fields['smcreatorid'] = $current_user->id;
		if(empty($modObj->column_fields['modifiedtime'])) $modObj->column_fields['modifiedtime']= date('Y-m-d H:i:s');
		$modObj->column_fields['crmid'] = $modObj->id;
		
		$widgetInstance = $modObj->getWidget('DetailViewBlockCommentWidget');
		echo ':#:SUCCESS'. $widgetInstance->processItem($modObj->getAsCommentModel($modObj->column_fields));
	} else {
		echo ':#:FAILURE';
	}
} elseif($ajaxaction == 'WIDGETADDREPLY') {
	global $current_user;
	if (isPermitted($currentModule, 'EditView', '') == 'yes') {
		$modObj->column_fields['commentcontent'] = vtlib_purify(strip_tags($_REQUEST['comment']));
		$modObj->column_fields['related_to'] = vtlib_purify($_REQUEST['parentid']);
		$modObj->column_fields['assigned_user_id'] = $current_user->id;
		if (vtlib_purify($_REQUEST['parent_comment']) != '') {
			$modObj->column_fields['parent_comments'] = vtlib_purify($_REQUEST['parent_comment']);
		}
		$modObj->save($currentModule);
	
		if(empty($modObj->column_fields['smcreatorid'])) $modObj->column_fields['smcreatorid'] = $current_user->id;
		if(empty($modObj->column_fields['modifiedtime'])) $modObj->column_fields['modifiedtime']= date('Y-m-d H:i:s');
		$modObj->column_fields['crmid'] = $modObj->id;
		
		$widgetInstance = $modObj->getWidget('DetailViewBlockCommentWidget');
		echo ':#:SUCCESS'. $widgetInstance->processItemReply(new ModComments_ReplyModel($modObj->column_fields));
	} else {
		echo ':#:FAILURE';
	}
} elseif($ajaxaction == 'WIDGETDELETECOMMENT') {
	if ($modObj->trash($currentModule, vtlib_purify($_REQUEST['id'])) === false) {
		echo ':#:FAILURE';
	} else {
		echo ':#:SUCCESS';
	}
// crmv@43050
} elseif($ajaxaction == 'WIDGETADDUSERS') {
	$commentid = intval($_REQUEST['commentid']);
	$userlist = array_filter(array_map('intval', explode('|', $_REQUEST['users_comm'])));

	if ($commentid > 0 && count($userlist) > 0 && isPermitted($currentModule, 'EditView', $commentid) == 'yes') {
		$modObj->retrieve_entity_info($commentid, $currentModule);
		$modObj->id = $commentid;

		$modObj->column_fields['crmid'] = $modObj->id;
		if(empty($modObj->column_fields['smcreatorid'])) $modObj->column_fields['smcreatorid'] = $modObj->column_fields['assigned_user_id'];

		$modObj->addUsers($userlist);

		$widgetInstance = $modObj->getWidget('DetailViewBlockCommentWidget');
		echo ':#:SUCCESS'.$widgetInstance->processItem($modObj->getAsCommentModel($modObj->column_fields));
	} else {
		echo ':#:FAILURE';
	}
} elseif($ajaxaction == 'WIDGETGETCOMMENT') {
	$commentid = intval($_REQUEST['commentid']);

	if ($commentid > 0 && isPermitted($currentModule, 'DetailView', $commentid) == 'yes') {
		$modObj->retrieve_entity_info($commentid, $currentModule);
		$modObj->id = $commentid;

		$modObj->column_fields['crmid'] = $modObj->id;
		if(empty($modObj->column_fields['smcreatorid'])) $modObj->column_fields['smcreatorid'] = $modObj->column_fields['assigned_user_id'];

		$widgetInstance = $modObj->getWidget('DetailViewBlockCommentWidget');
		echo ':#:SUCCESS'.$widgetInstance->processItem($modObj->getAsCommentModel($modObj->column_fields));
	} else {
		echo ':#:FAILURE';
	}
// crmv@43050e
} elseif($ajaxaction == 'DETAILVIEW') {
	$crmid = $_REQUEST['recordid'];
	$tablename = $_REQUEST['tableName'];
	$fieldname = $_REQUEST['fldName'];
	$fieldvalue = utf8RawUrlDecode($_REQUEST['fieldValue']); 
	if($crmid != '')
	{
		$modObj->retrieve_entity_info($crmid, $currentModule);
		$modObj->column_fields[$fieldname] = $fieldvalue;
		$modObj->id = $crmid;
		$modObj->mode = 'edit';
		$modObj->save($currentModule);
		if($modObj->id != '')
		{
			echo ':#:SUCCESS';
		}else
		{
			echo ':#:FAILURE';
		}   
	}else
	{
		echo ':#:FAILURE';
	}
} elseif($ajaxaction == "LOADRELATEDLIST" || $ajaxaction == "DISABLEMODULE"){
	require_once 'include/ListView/RelatedListViewContents.php';
}
?>
