<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/
//crmv@35153
$installation_mode = false;
if (empty($_SESSION)) {
	session_start();
}
if ($_SESSION['morph_mode'] == 'installation') {
	$installation_mode = true;
	if (!isset($root_directory)) {
		require_once('../../config.inc.php');
	}
	chdir($root_directory);
	require_once('include/utils/utils.php');
}
//crmv@35153e

global $adb;
//crmv@35153
if (!empty($_REQUEST['vte_user_info'])) {
	$vte_user_info = Zend_Json::decode($_REQUEST['vte_user_info']);
	$email = $vte_user_info['email'];
} elseif (!empty($_REQUEST['email'])) {
	$email = $_REQUEST['email'];
}
$update_mode = false;
if (file_exists('modules/Update/free_changes') && getUserName(1) == 'admin') {
	$update_mode = true;
}
//crmv@35153e
$tipo_installazione = strval($_REQUEST['tipo_installazione']);
$durata_installazione = strval($_REQUEST['durata_installazione']);
$numero_utenti = strval($_REQUEST['numero_utenti']);
$params = array('email'=>$email,
				'tipo_installazione'=>$tipo_installazione,
				'durata_installazione'=>$durata_installazione,
				'numero_utenti'=>$numero_utenti,
				);
$chiave = getChiave($params);

function getChiave($params) {

	global $application_unique_key,$root_directory,$adb,$table_prefix;
	$params['application_unique_key'] = $application_unique_key;
	$params['root_directory'] = $root_directory;
	$params['data_installazione'] = date('Y-m-d');
	
	include_once('include/padl/class.license.lib.php');
	include_once('include/padl/class.license.app.php');
	$application = new license_application('', false, true, true, true);
	$mac_address = $application->_get_mac_address();
	$params['mac_address'] = $mac_address;
	
	if ($params['tipo_installazione'] == 'Free') {
		$params['numero_utenti'] = 0;
		$params['roles'] = 3;	//Organisation + 2
		$params['profiles'] = 2;
		$params['pdf'] = 1;
		$params['adv_sharing_rules'] = 1;
		$params['sharing_rules_user'] = 1;
		
		$result = $adb->query("select * from {$table_prefix}_role");
		if ($result && $adb->num_rows($result) > 0) {
			if ($adb->num_rows($result) > $params['roles']) {
				$params['roles'] = $adb->num_rows($result);
			}
		}
		
		$result = $adb->query("select * from {$table_prefix}_profile");
		if ($result && $adb->num_rows($result) > 0) {
			if ($adb->num_rows($result) > $params['profiles']) {
				$params['profiles'] = $adb->num_rows($result);
			}
		}
		
		$result = $adb->query("SELECT COUNT(*) as count FROM {$table_prefix}_pdfmaker GROUP BY module");
		if ($result && $adb->num_rows($result) > 0) {
			$count = array();
			while($row=$adb->fetchByAssoc($result)) {
				$count[] = $row['count'];
			}
			if (!empty($count) && max($count) > $params['pdf']) {
				$params['pdf'] = max($count);
			}
		}
		
		$othermodules = getSharingModuleList();
		if(!empty($othermodules)) {
			$count = array();
			foreach($othermodules as $moduleresname) {
				$tmp = getAdvSharingRuleList($moduleresname);
				$count[] = count($tmp);
			}
			if (!empty($count) && max($count) > $params['adv_sharing_rules']) {
				$params['adv_sharing_rules'] = max($count);
			}
		}
					
		$othermodules = getSharingModuleList(Array('Contacts'));
		if(!empty($othermodules)) {
			$result = $adb->query("SELECT id FROM {$table_prefix}_users WHERE status = 'Active' AND user_name <> 'admin'");
			if ($result) {
				$count = array();
				while($row=$adb->fetchByAssoc($result)) {
					foreach($othermodules as $moduleresname) {
						$tmp = getSharingRuleListUser($moduleresname,$row['id']);
						$count[] = count($tmp);
					}
				}
				if (!empty($count) && max($count) > $params['sharing_rules_user']) {
					$params['sharing_rules_user'] = max($count);
				}
			}
		}
	}

	$key = generate_key_pair_morphsuit();
	$chiave = encrypt_morphsuit($key['public_key'],Zend_Json::encode($params));

	return urlencode($key['private_key'].'-----'.$chiave);
}

if ($_REQUEST['type'] == 'time_expired') {
	$saved_morphsuit = getSavedMorphsuit();
	$saved_morphsuit = urldecode(trim($saved_morphsuit));
	$private_key = substr($saved_morphsuit,0,strpos($saved_morphsuit,'-----'));
	$enc_text = substr($saved_morphsuit,strpos($saved_morphsuit,'-----')+5);
	$saved_morphsuit = @decrypt_morphsuit($private_key,$enc_text);
	$saved_morphsuit = Zend_Json::decode($saved_morphsuit);
	$saved_morphsuit_id = $saved_morphsuit['id'];
}

if ($tipo_installazione == 'Free') {
	$saved_morphsuit = getSavedMorphsuit();
	if (empty($saved_morphsuit)) {	// first activation
		include_once("modules/Users/Users.php");
		$user = CRMEntity::getInstance('Users');
		$user->retrieve_entity_info(1,'Users');
		$user->createAccessKey();
	}
	echo $chiave;
	exit;
}

include('modules/Morphsuit/HeaderMorphsuit.php');
?>
<body class="morphsuitactivationbody">
<div align="center">
<div class="small" style="width:500px;padding-top:5px;">
<?php if ($chiave != '') { ?>
	<form action="index.php" method="post" id="MorphsuitForm">
	<input type="hidden" name="module" value="Morphsuit">
	<input type="hidden" name="action" value="MorphsuitAjax">
	<input type="hidden" name="file" value="">
	<input type="hidden" name="type" value="">
	<input type="hidden" name="vte_user_info" value='<?php echo $_REQUEST['vte_user_info']; ?>'>
	<?php if ($installation_mode) { ?>
	<input type="hidden" name="mode" value="installation">
	<?php } ?>
	
	<div class="small" style="width:500px; padding-top:5px;">
	    <!-- aggiunge header -->
	    <table class="small morphsuittab" width="100%" cellspacing="0" cellpadding="10">
			<tr>
				<td></td>
			</tr>
		</table>
        <!-- end header -->
		<table class="small morphsuittable" align="center" width="100%">
			<tr><td class="dvHeaderText" align="center" width="400" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATION']." $enterprise_mode $enterprise_current_version"; ?>
			</td></tr>
			<tr><td class="small" align="center" width="400" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_DESCRIPTION']; ?>
			</td></tr>
			<tr height="20px"><td align="center" width="400" colspan="2"></td></tr>
			<?php if ($_REQUEST['type'] == 'time_expired') { ?>
			<tr><td align="center" width="400" colspan="2">
				<?php echo $mod_strings['LICENSE_ID'].': <b>'.$saved_morphsuit_id.'</b>'; ?>
			</td></tr>
			<tr height="20px"><td align="center" width="400" colspan="2"></td></tr>
			<?php } ?>
			<tr><td align="center" width="400" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_KEY']; ?><br />
				<textarea class="small" id="chiave" name="chiave" readonly><?php echo $chiave; ?></textarea>
			</td></tr>
			<tr><td align="center" width="400" colspan="2">
				<input type="submit" onclick="getObj('file').value='MailMorphsuit';getObj('type').value='SendMorphsuit';" class="crmbutton small edit" value="<?php echo $mod_strings['LBL_MORPHSUIT_SEND_REQUEST']; ?>" />
			</td></tr>
			<tr height="20px"><td align="center" width="400" colspan="2"></td></tr>
			<tr><td align="center" width="400" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_CODE']; ?><br />
				<textarea class="small" id="valida_chiave" name="valida_chiave"></textarea>
			</td></tr>
			<?php if ($installation_mode && !$update_mode) { ?>
				<tr height="20px"><td align="center" width="400" colspan="2"></td></tr>
				<tr><td align="center" width="400" colspan="2">
					<?php echo $mod_strings['LBL_MORPHSUIT_ADMIN_CONFIG']; ?><br />
				</td></tr>
				<tr>
					<td align="right" width="50%"><?php echo getTranslatedString('User Name','Users'); ?>: </td>
					<td align="left" width="50%"><input id="user_name" name="user_name" class="small" value="" size="23" type="text" /></td>
				</tr>
				<tr>
					<td align="right"><?php echo getTranslatedString('Password','Users'); ?>: </td>
					<td align="left"><input id="user_password" name="user_password" class="small" value="" size="23" type="password" /></td>
				</tr>
				<tr>
					<td align="right"><?php echo getTranslatedString('Confirm Password','Users'); ?>: </td>
					<td align="left"><input id="confirm_password" name="confirm_password" class="small" value="" size="23" type="password" /></td>
				</tr>
				<tr>
					<td align="right"><?php echo getTranslatedString('First Name','Users'); ?>: </td>
					<td align="left"><input id="first_name" name="first_name" class="small" value="" size="23" type="text" /></td>
				</tr>
				<tr>
					<td align="right"><?php echo getTranslatedString('Last Name','Users'); ?>: </td>
					<td align="left"><input id="last_name" name="last_name" class="small" value="" size="23" type="text" /></td>
				</tr>
				<tr>
					<td align="right"><?php echo getTranslatedString('Email','Users'); ?>: </td>
					<td align="left"><input id="email1" name="email1" class="small" value="" size="23" type="text" /></td>
				</tr>
			<?php } ?>
			<tr height="20px"><td align="center" width="400" colspan="2"></td></tr>			
			<tr><td align="center" width="400" colspan="2">
				<input type="button" onclick="<?php if ($installation_mode || $_REQUEST['type'] == 'time_expired') { ?>history.back();<?php } else { ?>getObj('file').value='RequestMorphsuit';this.form.submit();<?php } ?>" class="crmbutton small delete" value="<?php echo $mod_strings['LBL_MORPHSUIT_PREVIOUS']; ?>" />
				<input type="submit" onclick="getObj('file').value='CheckMorphsuit';" class="crmbutton small edit" value="<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATE']; ?>" />
			</td></tr>
		</table>
	</div>
	</form>
<?php } ?>
</div></div>

<div id="divId" class="veil_new" style="position:absolute;width:100%;display:none;top:0px;left:0px;">
<table border="5" cellpadding="0" cellspacing="0" align="center" style="vertical-align:middle;width:100%;height:100%;">
<tbody><tr>
		<td class="big" align="center">
		    <img src="<?php echo $path.vtiger_imageurl('plsWaitAnimated.gif',$theme); ?>">
		</td>
	</tr>
</tbody>
</table>
</div>

<script type="text/javascript">
function validateChiave() {
	if (jQuery('#chiave').val() == '') {
		alert('<?php echo $mod_strings['LBL_MORPHSUIT_KEY_EMPTY']; ?>');
		return false;
	}
	<?php if ($installation_mode && !$update_mode) { ?>
		if (getObj('file').value != 'MailMorphsuit') {
			if (!emptyCheck('user_name','<?php echo getTranslatedString('User Name','Users'); ?>',getObj('user_name').type))
				return false;
			if (!emptyCheck('user_password','<?php echo getTranslatedString('Password','Users'); ?>',getObj('user_password').type))
				return false;
			if (!emptyCheck('confirm_password','<?php echo getTranslatedString('Confirm Password','Users'); ?>',getObj('confirm_password').type))
				return false;
			if (!emptyCheck('last_name','<?php echo getTranslatedString('Last Name','Users'); ?>',getObj('last_name').type))
				return false;
			if (!emptyCheck('email1','<?php echo getTranslatedString('Email','Users'); ?>',getObj('email1').type))
				return false;
			if (trim(getObj('user_password').value) == trim(getObj('confirm_password').value)) {
				var values = {};
				values['user_name'] = trim(getObj('user_name').value);
				values['first_name'] = trim(getObj('first_name').value);
				values['last_name'] = trim(getObj('last_name').value);
				res = getFile('<?php echo $path; ?>modules/Users/CheckPasswordCriteria.php?record=&password='+getObj('user_password').value+'&row='+encodeURIComponent(JSON.stringify(values)));
				if (res == "no") {
					alert('<?php $focus = CRMEntity::getInstance('Users'); echo sprintf(getTranslatedString('LBL_NOT_SAFETY_PASSWORD','Users'),$focus->password_length_min); ?>');
					return false;
				}
			} else {
				alert("<?php echo getTranslatedString('ERR_REENTER_PASSWORDS','Users'); ?>");
				return false;
			}
		}
	<?php } ?>
	if (getObj('file').value != 'MailMorphsuit') {
		if (jQuery('#valida_chiave').val() == '') {
			alert('<?php echo $mod_strings['LBL_MORPHSUIT_CODE_EMPTY']; ?>');
			return false;
		}
	}
	pleaseWait('enable');
	return true;
}

function checkMorphsuit(res) {
	if (getObj('file').value == 'MailMorphsuit') {
		if (res != '') {
			alert(res+'\n\n<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATION_MAIL_ERROR']; ?>');
			pleaseWait('disable');
			return false;
		}
		else {
			alert('<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATION_MAIL_OK']; ?>');
			pleaseWait('disable');
			return true;
		}
	} else {
		if (res == 'yes') {
			alert('<?php echo $mod_strings['LBL_MORPHSUIT_CODE_RIGHT']; ?>');
			var res1 = getFile('<?php echo $path; ?>index.php?module=Morphsuit&action=MorphsuitAjax&file=CheckSMTP');
			if (res1 != 'ok') {
				if(confirm("<?php echo $mod_strings['LBL_ERROR_SMTP']; ?>")) {
					window.location.href = "<?php echo $path; ?>index.php?module=Settings&action=EmailConfig&parenttab=Settings";
					return true;
				}
			}
			window.location.href = "<?php echo $path; ?>index.php";
		}
		else {
			alert('<?php echo $mod_strings['LBL_MORPHSUIT_CODE_WRONG']; ?>');
			pleaseWait('disable');
		}
	}
}

function pleaseWait(status) {
	if (status == 'enable') {
		var oDivfreeze = $('divId');
		oDivfreeze.style.height = jQuery(document).height() + 'px';
		$('divId').style.display = 'block';
	} else {
		$('divId').style.display = 'none';
	}
}

jQuery('#tipo_installazione').val('<?php echo $tipo_installazione; ?>');
jQuery('#durata_installazione').val('<?php echo $durata_installazione; ?>');

var options = {
	beforeSubmit:	validateChiave,  	// pre-submit callback 
    success:		checkMorphsuit,  	// post-submit callback 
    dataType:		'script'			// 'xml', 'script', or 'json' (expected server response type) 
};
jQuery('#MorphsuitForm').ajaxForm(options);
</script>
</body>
</html>
<?php die; ?>