<?php
/*
 * Funzioni di utilità per Touch
 */

/* crmv@33097 */
/* crmv@33311 */
/* crmv@33545 - filtri */
/* crmv@34559 - preferiti,filtri */

require_once('modules/CustomView/CustomView.php');
require_once('modules/SDK/src/Favorites/Utils.php');

// restituisce la lista dei campi presenti in una related
// TODO: rimuovere dipendenza da recordid
function getRelatedFields($userid, $module, $relmodule, $relationId, $recordid) {
	global $adb, $table_prefix;
	static $instanceCache = array();

	// creo le istanze delle classi
	if (!array_key_exists($module, $instanceCache)) {
		$instanceCache[$module] = CRMEntity::getInstance($module);
		vtlib_setup_modulevars($module, $instanceCache[$module]);
	}
	if (!array_key_exists($relmodule, $instanceCache)) {
		$instanceCache[$relmodule] = CRMEntity::getInstance($relmodule);
		vtlib_setup_modulevars($relmodule, $instanceCache[$relmodule]);
	}
	if (empty($instanceCache[$module]) || empty($instanceCache[$relmodule])) return array();

	/*$relationInfo = getRelatedListInfoById($relationId);
	 $function_name = $relationInfo['functionName'];
	if (empty($function_name)) return array();
	$relatedListData = $instanceCache[$module]->$function_name(1, getTabid($module), $relationInfo['relatedTabId'], $relationInfo['actions']);
	*/

	// prendo tutti i campi del modulo

	$relmoduleWs = $relmodule;
	$response = wsRequest($userid,'describe', array('elementType'=> $relmoduleWs));
	$relfields = array();
	if (is_array($response['result']['fields'])) {
		foreach ($response['result']['fields'] as $k => $f) {
			$f['editable'] = false; // forzo in sola lettura
			$relfields[$f['name']] = $f;
		}
	}

	// prendo i campi related
	$relatedListData = getListViewHeader($instanceCache[$relmodule],$relmodule,'',$instanceCache[$relmodule]->default_sort_order,$instanceCache[$relmodule]->default_order_by,$recordid,'',$module,true,true);

	// unisco le informazioni
	$outfields = array();
	foreach ($relatedListData as $k=>$v) {
		$fname = $v['fieldname'];
		if (array_key_exists($fname, $relfields)) $outfields[] = $relfields[$fname];
	}

	return $outfields;
}

// restituisce il linkid se il modulo ha il blocco per i commenti, falso altrimenti
function hasCommentsBlock($module) {
	global $adb, $table_prefix, $current_user;

	$query = "select linkid from {$table_prefix}_links where tabid = ? and linktype = ? and linklabel = ?";
	$params = array(getTabid($module), 'DETAILVIEWWIDGET', 'DetailViewBlockCommentWidget');
	$res = $adb->pquery($query, $params);
	if ($res && $adb->num_rows($res) > 0) {
		return $adb->query_result($res, 0, 'linkid');
	}
	return false;
}

function hasPDFMaker($module) {
	global $adb, $table_prefix, $current_user;
	if (vtlib_isModuleActive('PDFMaker') && isPermitted('PDFMaker', 'DetailView') == 'yes') {
		$res = $adb->pquery(
			"select p.templateid
			from {$table_prefix}_pdfmaker p
			left join {$table_prefix}_pdfmaker_userstatus u on u.templateid = p.templateid and u.userid = ?
			where p.module = ? and (u.is_active is null or u.is_active = 1)",
			array($current_user->id, $module)
		);
		return ($res && $adb->num_rows($res) > 0);
	}
	return false;
}

function touchFindEmailRecipients($module, $record) {
	global $adb, $table_prefix, $current_user;

	$reclist = array();
	$modInst = CRMEntity::getInstance($module);
	// email fields
	$res = $adb->pquery("select tablename,columnname,fieldname from {$table_prefix}_field where tabid = ? and uitype = ?", array(getTabid($module), 13));
	if ($res) {
		while ($row = $adb->FetchByAssoc($res, -1, false)) {
			$idx = $modInst->tab_name_index[$row['tablename']];
			if ($idx) {
				$emvalue = getSingleFieldValue($row['tablename'], $row['columnname'], $idx, $record);
				if (!empty($emvalue)) {
					// split it
					$ename = getEntityName($module, $record);
					$ename = $ename[$record];
					$emlist = preg_split('/[,; ]/', $emvalue, -1, PREG_SPLIT_NO_EMPTY);
					foreach ($emlist as $email) {
						$reclist[] = array(
							'email' => $email,
							'entityname' => $ename,
							'module' => $module,
							'crmid' => intval($record),
						);
					}
				}
			}
		}
	}
	return $reclist;
}

// details for the pdf maker
// list of templates, list of available email addresses
function touchPDFMakerDetails($module, $record) {
	global $adb, $table_prefix, $current_user;

	$ret = array();
	$res = $adb->pquery(
		"select p.templateid, p.filename as templatename, p.module
		from {$table_prefix}_pdfmaker p
		left join {$table_prefix}_pdfmaker_userstatus u on u.templateid = p.templateid and u.userid = ?
		where p.module = ? and (u.is_active is null or u.is_active = 1)
		order by p.filename",
		array($current_user->id, $module)
	);
	if ($res) {
		// templates list
		$pdflist = array();
		while ($row = $adb->FetchByAssoc($res, -1, false)) {
			 $pdflist[] = $row;
		}
		$ret['templates'] = $pdflist;
		$ret['actions'] = array('sendemail');
		if (isPermitted('Documents', 'EditView') == 'yes') $ret['actions'][] = 'savedoc';
	}

	return $ret;
}

function touch_ws_login($username, $password) {
	$user = CRMEntity::getInstance('Users');
	$user->column_fields['user_name'] = $username;
	if(!$user->doLogin($password)) {
		throw new WebServiceException(WebServiceErrorCode::$INVALIDUSERPWD, "Invalid username or password");
	}
	$userId = $user->retrieve_user_id($username);
	$user = $user->retrieveCurrentUserInfoFromFile($userId);
	if($user->status != 'Inactive'){
		//crmv@37463
		global $current_user;
		$current_user = $user;
		if (isPermitted('Touch', 'DetailView') != 'yes') return '';
		//crmv@37463e
		return $user->column_fields['accesskey'];
	}
	throw new WebServiceException(WebServiceErrorCode::$AUTHREQUIRED, 'Given user is inactive');
}

// cerca in un array usando una funziona di callback
function array_usearch($arr, $callback) {
	foreach ($arr as $key => $item) {
		if ($callback($item)) {
			return $key;
		}
	}
	return false;
}

// restituisce l'array con la lista dei moduli
function touchModulesList() {
	global $touchInst;
	global $table_prefix, $current_user;

	if (!empty($current_user->column_fields['default_language'])) {
		$default_language = $current_language = $current_user->column_fields['default_language'];
	}

	$resultdata = wsRequest($current_user->id,'listtypes', array('fieldTypeList'=>'' ));

	$modulenames = $resultdata['result']['types'];
	$modulelabel = $resultdata['result']['information'];
	$recordList = Array();
	foreach($modulenames as $modulename) {
		$recordList[$modulename] = Array (
			'name' => $modulename,
			'label' => $resultdata['result']['information'][$modulename]['label']
		);
	}
	$recordList['Calendar'] = Array (
		'name' => 'Calendar',	//crmv@017
		'label' => getTranslatedString('Tasks', 'APP_STRINGS'),
	);

	$recordReturn = array();
	$id = 1;
	foreach ($recordList as $name) {
		if (!isModuleInstalled($name['name']) || in_array($name['name'], $touchInst->excluded_modules) || in_array($name['name'], $touchInst->excluded_modules_list)) continue;

		$tabid = getTabid($name['name']);
		if (empty($tabid)) continue;

		$isentity = getSingleFieldValue($table_prefix.'_tab', 'isentitytype', 'tabid', $tabid);
		if (!$isentity) continue;

		// single string
		$singlelabel = getTranslatedString('SINGLE_'.$name['name'], 'APP_STRINGS');
		if ($singlelabel == 'SINGLE_'.$name['name']) $singlelabel = getTranslatedString('SINGLE_'.$name['name'], $name['name']);

		// filtri
		$filters = touchFilterList($name['name']);

		// cartelle
		$folders = touchFoldersList($name['name']);

		// altre impostazioni di default
		$defaults = touchGetModuleDefaults($name['name']);

		$modinst = CRMEntity::getInstance($name['name']);
		array_push($recordReturn,array(
			'id'=>$id++, // i records sono in ordine di id
			'text'=>$name['label'], // testo da visualizzare
			'label'=>$name['label'], // testo da visualizzare (che differenza c'è da text??)
			'single_label' => $singlelabel,
			'view'=>$name['name'],  // nomefile della view (es Accounts)
			'leaf'=>'true', // lancia il js con nomefile in view (es Accounts.js)
			'tabid'=>$tabid,
			'idfield'=> $modinst->table_index,
			'orderfield'=> $modinst->default_order_by, // TODO: verifica se vuoto
			// permessi
			'perm_create' => (strcasecmp(isPermitted($name['name'],'EditView'),'yes') === 0),
			'perm_write' => (strcasecmp(isPermitted($name['name'],'EditView'),'yes') === 0),
			'perm_delete' => (strcasecmp(isPermitted($name['name'],'Delete'),'yes') === 0),
			// filtri
			'filters' => $filters,
			'folders' => $folders,
			'defaults' => $defaults,
		)
		);
	}
	return $recordReturn;
}

function touchGetModuleDefaults($module) {
	global $adb, $table_prefix, $current_user;
	$ret = array();

	$tabid = getTabid($module);

	// to get $current_user_profiles
	require('user_privileges/requireUserPrivileges.php');
	require_once('modules/CustomView/CustomView.php');
	if (count($current_user_profiles) > 0) {
		$res = $adb->pquery("select * from {$table_prefix}_profile2mobile where profileid = ? and tabid = ?", array($current_user_profiles[0], $tabid));
		if ($res && $adb->num_rows($res) > 0) {
			$row = $adb->FetchByAssoc($res, -1, false);
			if ($row['cvid'] > 0) {
				$cv = CRMEntity::getInstance('CustomView');
				$cvid = $row['cvid'];
				$cvinfo = $cv->getCustomViewByCvid($cvid);
				$cvname = $cvinfo['viewname'];
			}
			$extrafields = array_map('trim', array_filter(explode(',',$row['extrafields'])));
			foreach ($extrafields as $k=>$f) {
				$res2 = $adb->pquery("select fieldlabel from {$table_prefix}_field where tabid = ? and fieldname = ?", array($tabid, $f));
				$fieldlabel = $adb->query_result_no_html($res2, 0, 'fieldlabel');
				if (empty($fieldlabel)) continue;
				$extrafields[$k] = array(
					'name' => $f,
					'label' => getTranslatedString($fieldlabel, $module),
				);
			}
			$ret = array(
				'cvid' => $cvid,
				'cvname' => $cvname,
				'sortfield' => $row['sortfield'],
				'sortorder' => $row['sortorder'],
				// todo con nomi
				'extrafields' => $extrafields,
				'mobiletab' => $row['mobiletab'],
			);
		}
	}
	return $ret;
}

// ritorna i filtri (id, nome) per il modulo
function touchFilterList($module) {
	global $adb, $table_prefix;
	$cv = new CustomView($module);
	$query = $cv->getCustomViewQuery($module, $params);

	$ret = array();
	$res = $adb->pquery($query, $params);
	if ($res && $adb->num_rows($res) > 0) {
		while ($row = $adb->fetchByAssoc($res, -1, false)) {
			if ($module == 'Calendar' && $row['viewname'] == 'Events') continue;
			$isall = false;
			if ($row['viewname'] == 'All') {
				$row['viewname'] = getTranslatedString('COMBO_ALL', 'APP_STRINGS');
				$isall = true;
			}
			//TODO: campi disponibili
			//$cvinfo = $cv->getColumnsListByCvid($row['cvid']);
			// campo ordinamento
			$sortfield = '';
			$sortorder = 'ASC';
			$cvord = $cv->getOrderByFilterByCvid($row['cvid']);
			if (is_array($cvord) && is_array($cvord[0])) {
				$sortfield = explode(':', $cvord[0]['columnname']);
				$sortfield = $sortfield[2];
				$sortorder = $cvord[0]['ordertype'];
			}
			$ret[] = array(
				'cvid' => $row['cvid'],
				'viewname' => $row['viewname'],
				'all' => $isall,
				'sortfield' => $sortfield,
				'sortorder' => $sortorder,
			);
		}
	}
	return $ret;
}

function touchFoldersList($module) {
	$ret = array();

	$focus = CRMEntity::getInstance($module);

	if (method_exists($focus, 'getFolderList')) {
		$flist = $focus->getFolderList();
	} else {
		$flist = getEntityFoldersByName(null, $module);
	}

	foreach ($flist as $finfo) {
		$ret[] = array(
			'folderid' => $finfo['folderid'],
			'foldername' => $finfo['foldername'],
			'description' => $finfo['description'],
		);
	}

	return $ret;
}

function touchGetRecord($module, $recordid, $prodblock = 0) {
	global $touchInst;
	global $adb, $table_prefix, $current_user;

	// crmv@37794
	// read permission check
	if (isPermitted($module, 'DetailView', $recordid) != 'yes') {
		$record['vtecrm_permissions'] = array(
			'perm_read' => false,
			'perm_write' => (isPermitted($module, 'EditView', $recordid) == 'yes'),
			'perm_delete' => (isPermitted($module, 'Delete', $recordid) == 'yes'),
		);
		return $record;
	}
	// crmv@37794e

	$focus = CRMEntity::getInstance($module);
	$focus->retrieve_entity_info_no_html($recordid, $module);

	$record = $focus->column_fields;

	foreach ($record as $fldname=>$fldvalue) {
		$record[$fldname] = $touchInst->field2Touch($module, $fldname, $fldvalue, false, $focus);
	}

	// aggiungo i campi per il blocco prodotti
	if ($prodblock == 1 && $module == 'Products') {
		$record['crmid'] = $recordid;
		$record['entityType'] = $module;
		$record['entityname'] = $record['productname'];
		$record['comment'] = '';
		$record['productDescription'] = $record['description'];
		$record['productName'] = $record['productname'];
		$record['hdnProductId'] = array('crmid' => $recordid, 'display'=>$record['productname']);
		$record['hdnProductcode'] = $record['productcode'];

		// calcolo id della riga
		$res = $adb->query("select max(lineitem_id) as maxid from {$table_prefix}_inventoryproductrel");
		if ($res && $adb->num_rows($res) > 0) {
			$lineitemid = intval($adb->query_result($res, 0, 'maxid'))+1;
		} else {
			$lineitemid = 1;
		}
		$record['lineItemId'] = $lineitemid;

		$record['qty'] = 1;
		$record['qtyInStock'] = $record['qtyinstock'];
		$record['discountTotal'] = 0;
		$record['discount_amount'] = 0;
		$record['discount_percent'] = 0;
		$record['discount_type'] = 0;
		$record['taxTotal'] = 0;
		$record['unitPrice'] = $record['unit_price'];
		$record['totalAfterdiscount'] = $record['unit_price'];
		$record['lineTotal'] = $record['unit_price'];
		$record['listPrice'] = $record['unit_price'];
		$record['netPrice'] = $record['unit_price'];
		$record['productTotal'] = $record['unit_price'];
	}

	// pdfmaker
	if (hasPDFMaker($module)) {
		$pddet = touchPDFMakerDetails($module, $recordid);
		if (empty($pddet['templates'])) {
			$pddet['actions'] = array();
			// no templates -> no actions available
		}
		// clear everything if there are no actions available
		if (empty($pddet['actions'])) $pddet = array();
		$record['vtecrm_pdfmaker'] = $pddet;
	}

	// aggiungo campo fittizio per preferiti
	if (!isset($record['vtecrm_favourite'])) {
		$favimg = getFavorite($recordid);
		$record['vtecrm_favourite'] = (preg_match('/_on/', $favimg) ? true : false);
	}

	// aggiungo campi fittizi per permessi
	if (!isset($record['vtecrm_permissions'])) {
		$record['vtecrm_permissions'] = array(
			'perm_write' => (isPermitted($module, 'EditView', $recordid) == 'yes'),
			'perm_delete' => (isPermitted($module, 'Delete', $recordid) == 'yes'),
		);
	}

	return $record;
}

// ritorna il nome della colonna per un certo campo
function getFieldColumn($module, $fieldname) {
	global $adb, $table_prefix;

	$ret = false;
	$q = "
		select columnname
		from {$table_prefix}_field f
			inner join {$table_prefix}_tab t on t.tabid = f.tabid
		where t.name = ? and f.fieldname = ?";

	$res = $adb->pquery($q, array($module, $fieldname));
	if ($res && $adb->num_rows($res) > 0) {
		$ret = $adb->query_result_no_html($res, 0, 'columnname');
	}
	return $ret;
}

function getFieldNameFromColumn($module, $fieldcol) {
	global $adb, $table_prefix;

	$ret = false;
	$q = "
	select fieldname
	from {$table_prefix}_field f
	inner join {$table_prefix}_tab t on t.tabid = f.tabid
	where t.name = ? and f.columnname = ?";

	$res = $adb->pquery($q, array($module, $fieldcol));
	if ($res && $adb->num_rows($res) > 0) {
		$ret = $adb->query_result_no_html($res, 0, 'fieldname');
	}
	return $ret;
}

?>