<?php
/* crmv@31780 - restituisce la struttura (blocchi, campi, related) di un modulo*/
/* crmv@33097 - gestione multi-modulo per offline */
/* crmv@33311 - conversazioni nei moduli, altri fix */
global $login, $userId, $current_user, $currentModule;
global $adb, $table_prefix;

// parametri
$module = $_REQUEST['module'];
$recordid = intval($_REQUEST['recordid']);

if (!$login || empty($userId)) {
	echo 'Login Failed';
} elseif ($module != 'ALL' && in_array($module, $touchInst->excluded_modules)) {
	echo "Module not permitted";
} else {

	$moduleslist = array();
	if ($module == 'ALL') {
		$moduleslist = touchModulesList();
	} else {
		$moduleslist[] = array('view'=>$module);
	}

	$InventoryUtils = InventoryUtils::getInstance(); // crmv@42024

	$allblocks = array();
	foreach ($moduleslist as $moduleinfo) {
		$module = $currentModule = $moduleinfo['view'];

		$response = wsRequest($userId,'describe', array('elementType'=> $module));

		if (!is_array($response) || !$response['success'] || !is_array($response['result']['fields'])) {
			continue;
		}
		$response = $response['result'];

		// CALENDARIO --- prendo gli id dei blocchi custom e il blocco task
		$cal_customblocks = array();
		$res = $adb->pquery("select blockid from {$table_prefix}_blocks where tabid in (9,16) and blocklabel like ?", array('LBL_CUSTOM_INFORMATION'));
		if ($res) {
		 	while ($row = $adb->FetchByAssoc($res, -1, false)) {
		 		$cal_customblocks[] = $row['blockid'];
		 	}
		}
		$cal_taskblock = 19;
		$res = $adb->pquery("select blockid from {$table_prefix}_blocks where tabid = '9' and blocklabel like ?", array('LBL_TASK_INFORMATION'));
		if ($res && $adb->num_rows($res) > 0) {
			$cal_taskblock = $adb->query_result_no_html($res, 0, 'blockid');
		}
		// CALENDARIO END ---------

		// riordino la risposta
		$blocks = array();
		foreach ($response['fields'] as $fld) {

			// nascondo alcuni campi
			if (in_array($module, array('Quotes', 'Invoice', 'PurchaseOrder', 'SalesOrder', 'Ddt'))) {
				if (in_array($fld['name'], array('txtAdjustment', 'subtotal', 'total', 'conversion_rate'))) continue;
				if (substr($fld['name'], 0, 3) == 'hdn') continue;
			}

			if ($module == 'Calendar') {
				// rimozione campi degli eventi
				if (in_array($fld['name'], array('reminder_time', 'recurringtype', 'eventstatus', 'time_end', 'activitytype', 'duration_hours', 'duration_minutes', 'visibility', 'location', 'notime', 'id'))) continue;
				// sposto tutti i campi non custom nel primo blocco
				if (!in_array($fld['blockid'], $cal_customblocks)) $fld['blockid'] = $cal_taskblock;
				// il soggetto è deve essere il primo campo
				if ($fld['name'] == 'subject') $fld['sequence'] = 0;
			}

			if ($module == 'HelpDesk') {
				if (in_array($fld['name'], array('update_log'))) continue;
			}

			// Documenti
			if ($module == 'Documents') {
				if ($fld['name'] == 'folderid') {
					$folders = getEntityFoldersByName(null, $module);
					if (is_array($folders)) {
						foreach ($folders as $k=>$f) {
							$folders[$k] = array('value'=>$f['folderid'], 'label'=>$f['foldername']);
						}
					} else {
						$folders = array();
					}
					$fld['type'] = array(
						'name' => 'picklist',
						'defaultValue' => '',
						'picklistValues' => $folders,
					);
					$fld['uitype'] = 15;
				} elseif ($fld['name'] == 'filelocationtype') {
					$fld['editable'] = false;
					$fld['type'] = array(
						'name' => 'picklist',
						'defaultValue' => '',
						'picklistValues' => array(
							0 => array('value'=>'E', 'label'=>getTranslatedString('LBL_EXTERNAL', $module)),
							1 => array('value'=>'I', 'label'=>getTranslatedString('LBL_INTERNAL', $module)),
						),
					);
					$fld['uitype'] = 15;
				} elseif (in_array($fld['name'], array('filename', 'filesize', 'filetype', 'filedownloadcount'))) {
					$fld['editable'] = false;
				}
			}

			// campi cifrati
			if ($fld['uitype'] == 208) {
				$fld['editable'] = false;
			}

			// campi testo html
			if ($fld['uitype'] == 210) {
				$fld['editable'] = false;
			}

			// campi currency
			if ($fld['type']['name'] == 'reference' && $fld['type']['refersTo'][0] == 'Currency') {
				$currinfo = $InventoryUtils->getAllCurrencies();
				$currpicklist = array();
				foreach ($currinfo as $c) {
					$currpicklist[] = array('value' => $c['curid'], 'label' => $c['currencylabel']);
				}
				$fld['type'] = array(
					'name' => 'picklist',
					'defaultValue' => '',
					'picklistValues' => $currpicklist,
				);
				$fld['uitype'] = 15;
			}

			$blockid = $fld['blockid'];
			if ($blockid > 0) {
				if (!is_array($blocks[$blockid])) {
					$res = $adb->pquery("select * from {$table_prefix}_blocks where blockid = ?", array($blockid));
					if ($res && $adb->num_rows($res) > 0) {
						$row = $adb->fetchByAssoc($res, -1, false);
						if ($module == 'Calendar' && in_array($blockid, array(20,40))) $row['blocklabel'] = 'Description';
						$block = array(
							'blockid' => $blockid,
							'type' => 'BLOCK',
							'module' => $module,
							'tabid' => getTabid($module),
							//'name' => $row['blocklabel'],
							'label' => getTranslatedString($row['blocklabel'], $module),
							'sequence' => $row['sequence'],
						);
						$blocks[$blockid] = $block;
					}
				}
				$blocks[$blockid]['fields'][] = $fld;
			}
		}

		// ordino i campi nei blocchi
		foreach ($blocks as $blockid => $binfo) {
			usort($blocks[$blockid]['fields'], create_function('$v1,$v2', 'return ($v1["sequence"] > $v2["sequence"] ? +1 : ($v1["sequence"] < $v2["sequence"] ? -1 : 0));'));
			$blocks[$blockid]['fields'] = Zend_Json::encode($blocks[$blockid]['fields']); // double encode
		}

		// riordina indici
		$blocks = array_values($blocks);

		// ordino i blocchi
		usort($blocks, create_function('$v1,$v2', 'return ($v1["sequence"] > $v2["sequence"] ? +1 : ($v1["sequence"] < $v2["sequence"] ? -1 : 0));'));


		// PRODOTTI - simulo una related
		if (isInventoryModule($module)) {

			$blockid = 1000000; // 1 milione
			$totalFields = array(
				array(
					'name' => 'hdnSubTotal',
					'label' => getTranslatedString('LBL_NET_TOTAL', 'APP_STRINGS'),
					'mandatory' => true,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => false,
					'editable' => false,
					'uitype' => 7,
				),
				array(
					'name' => 'discount_type_final',
					'label' => getTranslatedString('Discount', 'APP_STRINGS'),
					'mandatory' => false,
					'type' => array(
						'name' => 'picklist',
						'picklistValues' => array(
							array('value' => 'percentage', 'label' => '% '.getTranslatedString('LBL_OF_PRICE', 'APP_STRINGS')),
							array('value' => 'amount', 'label' => getTranslatedString('LBL_DIRECT_PRICE_REDUCTION', 'APP_STRINGS')),
						),
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 15,
				),
				array(
					'name' => 'discount_value',
					'label' => getTranslatedString('Discount Amount', 'Quotes'),
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 7,
				),
				array(
					'name' => 'shipping_handling_charge',
					'label' => getTranslatedString('LBL_SHIPPING_AND_HANDLING_CHARGES', 'APP_STRINGS'),
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 7,
				),
			);
			// tasse per la spedizione
			$taxes = $InventoryUtils->getAllTaxes('available','sh');
			foreach ($taxes as $taxinfo) {
				if ($taxinfo['deleted'] != 0) continue;
				$field = array(
					'name' => $taxinfo['taxname'],
					'label' => " - ".$taxinfo['taxlabel']." %",
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 7,
				);
				$totalFields[] = $field;
			}
			$totalFields[] = array(
				'name' => 'shtax_totalamount',
				'label' => getTranslatedString('LBL_TAX_FOR_SHIPPING_AND_HANDLING', 'APP_STRINGS'),
				'mandatory' => false,
				'type' => array(
					'name' => 'double',
				),
				'nullable' => true,
				'editable' => false,
				'uitype' => 7,
			);
			$totalFields[] = array(
				'name' => 'adjustmentType',
				'label' => getTranslatedString('LBL_ADJUSTMENT', 'APP_STRINGS'),
				'mandatory' => false,
				'type' => array(
					'name' => 'picklist',
					'picklistValues' => array(
						array('value' => '+', 'label' => getTranslatedString('LBL_ADD_ITEM', 'APP_STRINGS')),
						array('value' => '-', 'label' => getTranslatedString('LBL_DEDUCT', 'APP_STRINGS')),
					),
				),
				'nullable' => true,
				'editable' => true,
				'uitype' => 7,
			);
			$totalFields[] = array(
				'name' => 'adjustment',
				'label' => ' ', // getTranslatedString('LBL_ADJUSTMENT', 'APP_STRINGS'),
				'mandatory' => false,
				'type' => array(
					'name' => 'double',
				),
				'nullable' => true,
				'editable' => true,
				'uitype' => 7,
			);
			$totalFields[] = array(
				'name' => 'grandTotal',
				'label' => getTranslatedString('LBL_TOTAL', 'APP_STRINGS'),
				'mandatory' => false,
				'type' => array(
					'name' => 'double',
				),
				'nullable' => false,
				'editable' => false,
				'uitype' => 7,
			);

			$prodFields = array(
				// campi per il totale - dentro ad un campo fittizio
				array(
					'name' => 'TOTALS',
					'fields' => $totalFields,
				),
				// campi per singoli prodotti
				array(
					'name' => 'hdnProductId',
					'label' => getTranslatedString('Product', 'Products'),
					'mandatory' => true,
					'type' => array(
						'name' => 'reference',
						'refersTo' => array('Products'),
					),
					'nullable' => false,
					'editable' => false,
					'uitype' => 10,
				),
				array(
					'name' => 'productDescription',
					'label' => getTranslatedString('Description', 'Products'),
					'mandatory' => false,
					'type' => array(
						'name' => 'text',
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 21,
				),
				array(
					'name' => 'comment',
					'label' => getTranslatedString('Comment', 'Products'), // TODO: aggiungi a prodotti
					'mandatory' => false,
					'type' => array(
						'name' => 'text',
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 21,
				),
				array(
					'name' => 'qtyInStock',
					'label' => getTranslatedString('Qty In Stock', 'Products'),
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => true,
					'editable' => false,
					'uitype' => 7,
				),
				array(
					'name' => 'qty',
					'label' => getTranslatedString('Quantity', 'Products'),
					'mandatory' => true,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => false,
					'editable' => true,
					'uitype' => 7,
				),
				array(
					'name' => 'listPrice',
					'label' => getTranslatedString('LBL_LIST_PRICE', 'APP_STRINGS'),
					'mandatory' => true,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => false,
					'editable' => true,
					'uitype' => 7,
				),
				array(
					'name' => 'productTotal',
					'label' => getTranslatedString('Total', 'APP_STRINGS'),
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => false,
					'editable' => false,
					'uitype' => 7,
				),
				array(
					'name' => 'discount_type',
					'label' => getTranslatedString('Discount', 'APP_STRINGS'),
					'mandatory' => false,
					'type' => array(
						'name' => 'picklist',
						'picklistValues' => array(
							array('value' => 'zero', 'label' => getTranslatedString('LBL_ZERO_DISCOUNT', 'APP_STRINGS')),
							array('value' => 'percentage', 'label' => '% '.getTranslatedString('LBL_OF_PRICE', 'APP_STRINGS')),
							array('value' => 'amount', 'label' => getTranslatedString('LBL_DIRECT_PRICE_REDUCTION', 'APP_STRINGS')),
						),
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 15,
				),
				array(
					'name' => 'discount_amount',
					'label' => getTranslatedString('Discount Amount', 'Quotes'),
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 7,
				),
				array(
					'name' => 'totalAfterDiscount',
					'label' => getTranslatedString('LBL_TOTAL_AFTER_DISCOUNT', 'APP_STRINGS'),
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
					),
					'nullable' => false,
					'editable' => false,
					'uitype' => 7,
				),
			);
			// campi per le tasse (li prendo tutti per ora)
			// TODO: segnare in qualche modo
			$taxes = $InventoryUtils->getAllTaxes();
			foreach ($taxes as $taxinfo) {
				if ($taxinfo['deleted'] != 0) continue;
				$field = array(
					'name' => $taxinfo['taxname'],
					'label' => " - ".$taxinfo['taxlabel']." %",
					'mandatory' => false,
					'type' => array(
						'name' => 'double',
						'istax' => true, // non standard
					),
					'nullable' => true,
					'editable' => true,
					'uitype' => 7,
				);
				$prodFields[] = $field;
			}

			$prodFields[] = array(
				'name' => 'taxTotal',
				'label' => getTranslatedString('LBL_TAX', 'APP_STRINGS'),
				'mandatory' => false,
				'type' => array(
					'name' => 'double',
				),
				'nullable' => false,
				'editable' => false,
				'uitype' => 7,
			);
			$prodFields[] = array(
				'name' => 'netPrice',
				'label' => getTranslatedString('LBL_NET_PRICE', 'APP_STRINGS'),
				'mandatory' => false,
				'type' => array(
					'name' => 'double',
				),
				'nullable' => false,
				'editable' => false,
				'uitype' => 7,
			);

			$i = $blockid + 1;
			foreach ($prodFields as $k => $v) {
				$prodFields[$k]['blockid'] = $blockid;
				$prodFields[$k]['fieldid'] = $i;
				$prodFields[$k]['sequence'] = $i++;
			}
			$blocks[] = array(
				'blockid' => $blockid, // 1 milione
				'type' => 'PRODUCTS',
				'module' => $module,
				'related_module' => 'Products',
				'tabid' => getTabId($module),
				'label' => getTranslatedString('Products', 'APP_STRINGS'), // uso traduzione da modulo collegato
				'fields' => Zend_Json::encode($prodFields),
				'actions' => '',
			);
		}

		// crmv@34559
		// COMMENTI TICKET
		if ($module == 'HelpDesk') {
			$relmod = 'ModComments';
			$rblock = array(
				'blockid' => intval($linkid)+1500000, // id che parte da 1.5 milioni
				'type' => 'TICKETCOMMENTS',
				'module' => $module,
				'related_module' => $relmod ,
				'tabid' => getTabId($module),
				'label' => getTranslatedString('LBL_COMMENT_INFORMATION', $module),
			);
			$blocks[] = $rblock;
		}
		// crmv@34559e

		// COMMENTI
		if (!in_array('ModComments', $touchInst->excluded_modules) && ($linkid = hasCommentsBlock($module))) {
			$relmod = 'ModComments';
			$rblock = array(
				'blockid' => intval($linkid)+2000000, // id che parte da 2 milioni
				'type' => 'COMMENTS',
				'module' => $module,
				'related_module' => $relmod ,
				'tabid' => getTabId($module),
				'label' => getTranslatedString('Comments', $relmod), // uso traduzione da modulo collegato
			);
			$blocks[] = $rblock;
		}

		// PDFMaker
		if (!in_array('PDFMaker', $touchInst->excluded_modules) && ($linkid = hasPDFMaker($module))) {
			$relmod = 'PDFMaker';
			$rblock = array(
				'blockid' => 2500000,
				'type' => 'PDFMAKER',
				'module' => $module,
				'related_module' => $relmod ,
				'tabid' => getTabId($module),
				'label' => getTranslatedString('PDFMaker', $relmod), // uso traduzione da modulo collegato
			);
			$blocks[] = $rblock;
		}

		// RELATED
		$related_array = getRelatedLists($module,'');

		foreach ($related_array as $key => $value) {
			if (empty($value['related_tabid'])) continue;

			$relmod = vtlib_getModuleNameById($value['related_tabid']);
			if (in_array($relmod, $touchInst->excluded_modules)) continue;

			// ignoro azioni per get_history
			if ($value['name'] == 'get_history') {
				$actions = array();
			} else {
				$actions = array_filter(explode(',',strtoupper($value['actions'])));
			}

			// rimuovo select per get_dependents_list
			if ($value['name'] == 'get_dependents_list' && in_array('SELECT', $actions)) {
				$k = array_search('SELECT', $actions);
				unset($actions[$k]);
			}

			$actions = array_values($actions);

			$relatedFields = getRelatedFields($userId, $module, $relmod, $value['relationId'], $recordid);

			$rblock = array(
				'blockid' => intval($value['relationId'])+3000000, // id che parte da 3 milioni
				'type' => 'RELATED',
				'module' => $module,
				'related_module' => $relmod,
				'tabid' => getTabId($module),
				'label' => getTranslatedString($key, $relmod), // uso traduzione da modulo collegato
				'fields' => Zend_Json::encode($relatedFields),
				'actions' => $actions,
				'related_tabid' => $value['related_tabid'],
				'perm_delete' => true,
			);

			// calendar fix
			/*if ($relmod == 'Calendar') {
				if (preg_match('/history/i', $key)) {
					$rblock['label'] = getTranslatedString('Tasks', 'APP_STRINGS');
				} else {
					$rblock['label'] = getTranslatedString('Tasks', 'APP_STRINGS');
				}

			}*/
			$blocks[] = $rblock;
		}

		$allblocks = array_merge($allblocks, $blocks);
	}

	// output
	echo Zend_Json::encode($allblocks);
}
?>
