<?php

class TouchGetList extends TouchWSClass {


	function process(&$request) {
		global $adb, $table_prefix;
		global $current_user, $currentModule, $touchInst;
		global $current_folder, $current_account; // for Messages

		$module = $request['module'];
		$searchstr = $request['search'];
		$viewid = intval($request['viewid']);
		$folderid = intval($request['folderid']); // automatically used by modules
		if ($folderid <= 0) unset($request['folderid']);
		$req_sorder = $request['sorder'];
		$req_sortby = vtlib_purify($request['sfield']);
		$extraFields = Zend_Json::decode($request['extrafields']);
		$extraFieldsRaw = ($request['extrafields_raw'] == '1' ? true : false); // if true, extrafields won't be formatted for the display
		$whereConditions = Zend_Json::decode($request['conditions']);

		$pageLimit = intval($request['limit']);
		if ($pageLimit <= 0) $pageLimit = $touchInst->listPageLimit;

		$currentModule = $module;

		// pulisco request
		unset($request['sorder'], $request['sfield'], $request['extrafields']);

		$focus = CRMEntity::getInstance($module);
		$tabid = GetTabid($module);

			if ($module == 'Messages') {

				//config account
				$mail_accountid = vtlib_purify($request['mail_accountid']);
				if ($mail_accountid) $current_account = $mail_accountid;

				if (empty($current_account)) {
					$current_account = $focus->getMainUserAccount();
					$current_account = $current_account['id'];
				}
				$focus->setAccount($current_account);
				if ($current_account != 'all')
					$specialFolders = $focus->getSpecialFolders();

				// config folder
				$mail_folder = $request['mail_folder'];
				if ($mail_folder) $current_folder = $mail_folder;

				if (empty($current_folder)) {
					$current_folder = $specialFolders['INBOX'];
				}

			} elseif ($module == 'Events') {
				// for calendar, enable view of other people events
				if (!empty($request['show_users'])) {
					$show_cal_users = array_filter(explode(',', $request['show_users']));
					$available_shareds = array_keys($focus->getShownUserId($current_user->id));
					$show_cal_users = array_intersect($show_cal_users, $available_shareds);
				}
			}


			// inizializzo ordinamento
			$customView = new CustomView($currentModule);
			//$viewid = $customView->getViewId($currentModule);
			//$viewinfo = $customView->getCustomViewByCvid($viewid);
			list($focus->customview_order_by,$focus->customview_sort_order) = $customView->getOrderByFilterSQL($viewid);
			$sorder = $focus->getSortOrder();
			$order_by = $focus->getOrderBy();

			// richiesto ordinamento diverso
			if (!empty($req_sortby) && in_array($req_sorder, array('ASC', 'DESC'))) {
				$order_by = getFieldColumn($module, $req_sortby);
				$sorder = $req_sorder;
			}

			// campi per il nome
			$nameFields = vtws_getEntityNameFields($module);
			if (is_array($nameFields) && empty($sorder)) {
				// trovo il nome della colonna se non c'è ordinamento
				$order_by = getFieldColumn($module, $nameFields[0]);
			}

			// nomi delle colonne per campi extra
			$extraFields_col = array();
			if (is_array($extraFields))
				foreach ($extraFields as $nf) $extraFields_col[$nf] = getFieldColumn($module, $nf);

			$queryGenerator = QueryGenerator::getInstance($module, $current_user);
			if ($viewid > 0) {
				$queryGenerator->initForCustomViewById($viewid);
			} else {
				$queryGenerator->initForDefaultCustomView();
			}

			// aggiungo campi alla query così posso ordinare
			if (!empty($order_by)) {
				$fname = getFieldNameFromColumn($module, $order_by);
				$queryGenerator->addField($fname);
				$_SESSION[$module.'_ORDER_BY'] = $order_by;
				foreach ($nameFields as $nf)
					$queryGenerator->addField($nf);
			}
			if (is_array($extraFields))
				foreach ($extraFields as $nf) $queryGenerator->addField($nf);
			// per aggiungere join con altri moduli in caso di ordinamento per campi reference
			$queryGenerator->addField('crmid');

			if ($searchstr != '') {
				$searchRequest = array();
				$controller = ListViewController::getInstance($adb, $current_user, $queryGenerator);
				$searchFields = $nameFields;
				if (is_array($extraFields)) $searchFields = array_merge($searchFields, $extraFields);
				$searchRequest['search_fields'] = array_flip($searchFields);//$controller->getBasicSearchFieldInfoList();
				$searchRequest['search_text'] = $searchstr;
				$queryGenerator->addUserSearchConditions($searchRequest);
			}

			if ($module == 'Events') {
				$queryGenerator->addField('subject');
			}

			// add custom conditions to query
			if (!empty($whereConditions)) {
				foreach ($whereConditions as $wc) {
					if ($wc['type'] == 'group') {
						$groupglue = ($wc['glue'] ? $wc['glue'] : 'and');
						for ($i=0; $i<count($wc['conds']); ++$i) {
							$stat = $wc['conds'][$i];
							$queryGenerator->addCondition($stat['field'], $stat['value'], $stat['operator']);
							if ($i < count($wc['conds'])-1) $queryGenerator->addConditionGlue(' '.$groupglue.' ');
						}
					}

				}
			}

			$list_query = $queryGenerator->getQuery();

			// prendo solo i compiti
			if ($module == 'Calendar') {
				$list_query .= " AND {$table_prefix}_activity.activitytype = 'Task'";
			} elseif ($module == 'Events') {
				// solo i miei eventi (o quelli a cui sono invitato)
				// TODO: filtro per data
				$list_query .= " AND {$table_prefix}_activity.activitytype not in ('Task', 'Emails', 'Sms', 'Fax') ";
				if (count($show_cal_users) > 0) {
					$show_cal_users[] = $current_user->id;
					$show_cal_users = array_map('intval', $show_cal_users);
					$list_query .= "
						AND ( {$table_prefix}_crmentity.smownerid IN (".implode(',', $show_cal_users).")
					 		OR {$table_prefix}_activity.activityid IN (
								SELECT activityid
								FROM {$table_prefix}_invitees
								WHERE {$table_prefix}_activity.activityid > 0 AND inviteeid IN (".implode(',', $show_cal_users).")
							)
						)";
				} else {
					$list_query .= "
						AND ( {$table_prefix}_crmentity.smownerid = '{$current_user->id}'
							OR {$table_prefix}_activity.activityid IN (
								SELECT activityid
								FROM {$table_prefix}_invitees
								WHERE {$table_prefix}_activity.activityid > 0 AND inviteeid = '{$current_user->id}'
							)
						)";
				}
			}

			// conteggio
			$list_count = 0;
			$count_query = replaceSelectQuery($list_query,'count(*) as cnt');
			$res = $adb->query($count_query);
			if ($res){
				$list_count = $adb->query_result($res,0,'cnt');
			}

			// ordinamento
			if (!empty($order_by) && !empty($sorder)) {
				if (in_array($order_by, array('smownerid', 'smcreatorid')))
					$list_query .= ' ORDER BY user_name '.$sorder;
				else {
					$list_query .= $focus->getFixedOrderBy($currentModule,$order_by,$sorder); //crmv@25403
				}
			}

			// disabilito azioni per la lista
			global $PERFORMANCE_CONFIG;
			$PERFORMANCE_CONFIG['LISTVIEW_RECORD_CHANGE_INDICATOR'] = false;

			// imposto il massimo numero di elementi
			$list_max_entries_per_page = $pageLimit;
			// e l'inizio
			$page = $request['page'];
			if (empty($page)) $page = 1;
			$start = ($page-1)*$list_max_entries_per_page;
			$totpages = ceil($list_count / $list_max_entries_per_page);

			unset($request['page'], $request['limit'], $request['start']);

			if ($module == 'Messages') {
				$fetched = false;
				// if force, get new emails
				if ($request['force_fetch'] == '1') {
					$focus->fetch($current_account, $current_folder, true);
					$fetched = true;
				// get old emails if request last or last-1 page
				} elseif ($page >= $totpages-1) {
					$focus->fetch($current_account, $current_folder, false);
					$fetched = true;
				}
				if ($fetched) {
					// and count again
					$res = $adb->query($count_query);
					$list_count = $adb->query_result($res,0,'cnt');
				}
			}

			$result = $adb->limitQuery($list_query, $start,$list_max_entries_per_page);

			if ($module == 'Messages') {
				// if 0 results, it might be the first time, download them!
				if ($result && $adb->num_rows($result) == 0 && $request['force_fetch'] != '1') {
					$focus->fetch($current_account, $current_folder, true);
					$result = $adb->limitQuery($list_query, $start,$list_max_entries_per_page);
				}

			}

			$resultArray = array();
			if ($result && $adb->num_rows($result) > 0)	{
				while ($row = $adb->fetchByAssoc($result)) {
					$nrow = array();
					$nrow['tabid'] = $tabid;
					$nrow['module'] = $module;
					$nrow['crmid'] = $row[$focus->tab_name_index[$focus->table_name]];
					if ($module == 'Events') {
						$entname = $row['subject'];
					} elseif ($nrow['crmid'] > 0) {
						$entname = getEntityName($module, array($nrow['crmid']));
						$entname = $entname[$nrow['crmid']];
					} else {
						foreach ($nameFields as $nf)
							$entname .= $row[$nf]." ";
					}
					$nrow['entityname'] = html_entity_decode($entname, ENT_QUOTES, 'UTF-8');

					// aggiunta campi speciali
					if ($module == 'Messages') {

						if (is_array($specialFolders) && in_array($current_folder, array($specialFolders['Sent'], $specialFolders['Drafts']))) {
							$mto = $row['mto'];
							$mto_n = $row['mto_n'];
							$mto_f = $row['mto_f'];
						} else {
							$mto = $row['mfrom'];
							$mto_n = $row['mfrom_n'];
							$mto_f = $row['mfrom_f'];
						}
						$from_or_to = $focus->getAddressName($mto,$mto_n,$mto_f,false);
						$row['from_or_to'] = $from_or_to;
						$extraFields_col['from_or_to'] = 'from_or_to';

						$row['has_attachments'] = ($focus->haveAttachments($nrow['crmid']) ? '1' : '0');
						$extraFields_col['has_attachments'] = 'has_attachments';

						if (array_key_exists('mdate', $row)) {
							$row['mdate_friendly'] = $focus->getFriendlyDate($row['mdate']);
							$extraFields_col['mdate_friendly'] = 'mdate_friendly';
						}

						$row['has_relations'] = ($focus->haveRelations($nrow['crmid']) ? '1' : '0');
						$extraFields_col['has_relations'] = 'has_relations';

						$row['has_comments'] = ($focus->haveRelations($nrow['crmid'], 'ModComments') ? '1' : '0');
						$extraFields_col['has_comments'] = 'has_comments';
					}

					// campi aggiuntivi
					if (is_array($extraFields) && count($extraFields) > 0) {
						$efields = array();
						$emptyValue = ($extraFieldsRaw ? '' : '-');
						foreach ($extraFields as $fname) {
							$rawval = $row[$extraFields_col[$fname]];
							if (is_null($rawval) || $rawval === '') {
								$efields[$fname] = $emptyValue;
							} else {
								$procval = $touchInst->field2Touch($module, $fname, $rawval, !$extraFieldsRaw);
								if (is_null($procval) || $procval === '')
									$procval = $emptyValue;
								elseif (!$extraFieldsRaw && strlen($procval) > 60)
									$procval = substr($procval, 0, 57).'...';

								if ($extraFieldsRaw) {
									// re-encode
									$procval = html_entity_decode($procval, ENT_QUOTES, 'UTF-8');
								}
								$efields[$fname] = $procval;
							}
						}
						$nrow['extrafields'] = $efields;
					}

					$resultArray[] = $nrow;
				}
			}

		return array('entries' => $resultArray, 'total' => $list_count);

	}

}

?>