<?php
/*+**********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ************************************************************************************/

if (empty($_REQUEST['mode'])) {
	include_once("modules/$currentModule/ListView.php");
	exit;
}

require_once('Smarty_setup.php');
require_once('user_privileges/default_module_view.php');

global $mod_strings, $app_strings, $currentModule, $current_user, $theme, $singlepane_view, $current_account, $current_folder;
if (isset($_REQUEST['account']) && !empty($_REQUEST['account'])) {
	$current_account = $_REQUEST['account'];
}
if (isset($_REQUEST['folder']) && !empty($_REQUEST['folder'])) {
	$current_folder = $_REQUEST['folder'];
}

$focus = CRMEntity::getInstance($currentModule);

$tool_buttons = Button_Check($currentModule);
$smarty = new vtigerCRM_Smarty();

$record = $_REQUEST['record'];
$isduplicate = vtlib_purify($_REQUEST['isDuplicate']);
$tabid = getTabid($currentModule);
$category = getParentTab($currentModule);

if($record != '') {
	$focus->id = $record;
	$retrieve = $focus->retrieve_entity_info($record, $currentModule, false);
	if (in_array($retrieve,array('LBL_RECORD_DELETE','LBL_RECORD_NOT_FOUND','LBL_OWNER_MISSING'))) {
		exit;
	}
}
$folder = $focus->column_fields['folder'];
if($isduplicate == 'true') $focus->id = '';

//crmv@47243
if (empty($current_folder) && $focus->column_fields['mtype'] == 'Link' && ($current_user->id == $focus->column_fields['assigned_user_id'] || $focus->column_fields['mvisibility'] == 'Public')) { //crmv@45122
	$current_folder = 'Links';
}
//crmv@47243e

// Identify this module as custom module.
$smarty->assign('CUSTOM_MODULE', true);

$smarty->assign('APP', $app_strings);
$smarty->assign('MOD', $mod_strings);
$smarty->assign('MODULE', $currentModule);
// TODO: Update Single Module Instance name here.
$smarty->assign('SINGLE_MOD', 'SINGLE_'.$currentModule); 
$smarty->assign('CATEGORY', $category);
$smarty->assign('IMAGE_PATH', "themes/$theme/images/");
$smarty->assign('THEME', $theme);
$smarty->assign('ID', $focus->id);
$smarty->assign('MODE', $focus->mode);

$smarty->assign('EDIT_PERMISSION', isPermitted($currentModule, 'EditView', $record));
$smarty->assign('CHECK', $tool_buttons);

// Record Change Notification : do in separate ajax call
$focus->markAsViewed($current_user->id,$_REQUEST['skip_update_flag']);
// END

$blocks = getBlocks($currentModule,'detail_view','',$focus->column_fields);
$header_block = array();
if (isset($blocks[$mod_strings['LBL_MESSAGE_INFORMATION']])) {
	foreach($blocks[$mod_strings['LBL_MESSAGE_INFORMATION']] as $detail) {
		foreach($detail as $label => $data) {
			$header_block[$data['fldname']] = $data;
			$header_block[$data['fldname']]['label'] = $label;
		}
	}
}
if (isset($blocks[$mod_strings['LBL_DESCRIPTION_INFORMATION']])) {
	foreach($blocks[$mod_strings['LBL_DESCRIPTION_INFORMATION']] as $detail) {
		foreach($detail as $label => $data) {
			if ($label == getTranslatedString('Body',$currentModule)) {
				$attachments_info = $focus->getAttachmentsInfo();
				$message_data = array('other'=>$attachments_info);
				$magicHTML = $focus->magicHTML($data['value'], $focus->column_fields['xuid'], $message_data);
				$description = $magicHTML['html'];
				$content_ids = $magicHTML['content_ids'];
				break(2);
			}
		}
	}
}
$smarty->assign('HEADER_BLOCK', $header_block);
$smarty->assign('DESCRIPTION', $description);
include('modules/Messages/DetailViewButtons.php');

// Gather the custom link information to display
include_once('vtlib/Vtiger/Link.php');
$customlink_params = Array('MODULE'=>$currentModule, 'RECORD'=>$focus->id, 'ACTION'=>vtlib_purify($_REQUEST['action']));
$smarty->assign('CUSTOM_LINKS', Vtiger_Link::getAllByType(getTabid($currentModule), Array('DETAILVIEWWIDGET'), $customlink_params));
// END

$smarty->assign('DETAILVIEW_AJAX_EDIT', PerformancePrefs::getBoolean('DETAILVIEW_AJAX_EDIT', true));

//$specialFolders = $focus->getSpecialFolders();	// already calculated in DetailViewButtons.php
if (in_array($folder,array($specialFolders['Sent'],$specialFolders['Drafts']))) {
	$business_card = $focus->getBusinessCard('TO');
} else {
	$business_card = $focus->getBusinessCard('FROM');
	$business_card = $business_card[0];
}
$smarty->assign('FOCUS', $focus);
$smarty->assign('FOLDER', $folder);
$smarty->assign('SPECIAL_FOLDERS', $specialFolders);
$smarty->assign('BUSINESS_CARD', $business_card);
$attachments = $focus->getAttachments();
$smarty->assign('ATTACHMENTS', $attachments);
$attachments_other = array_diff_assoc($attachments_info,$attachments);
foreach ($attachments_other as $content_id => $attachment) {
	if (!in_array($content_id,$content_ids) && $attachment['parameters']['contentdisposition'] == 'inline') {
		$inline_attachments[$content_id] = $attachment;
	}
}
$smarty->assign('INLINE_ATTACHMENTS',$inline_attachments);

$_SESSION['autoload_message'] = $record;

$smarty->assign('MESSAGE_MODE',$_REQUEST['mode']);

if ($_REQUEST['mode'] == 'ListView') {
	$smarty->display('modules/Messages/DetailView.tpl');
//crmv@42801
} elseif ($_REQUEST['mode'] == 'Print') {
	$smarty->display('modules/Messages/Print.tpl');
} elseif ($_REQUEST['mode'] == 'Download') {
	$filename = getTranslatedString('SINGLE_Messages','Messages').'.html';
	header("Content-Type: application/octet-stream; name=\"$filename\"");
	header("Content-Disposition: attachment; filename=\"$filename\"");
	header("Content-Type: application/octet-stream; name=\"$filename\"");
	echo $description;
//crmv@42801e
//crmv@44775
} elseif ($_REQUEST['mode'] == 'Detach') {
	// Gather the custom link information to display
	$hdrcustomlink_params = Array('MODULE'=>$currentModule);
	$COMMONHDRLINKS = Vtiger_Link::getAllByType(Vtiger_Link::IGNORE_MODULE, Array('HEADERSCRIPT', 'HEADERCSS'), $hdrcustomlink_params);
	$smarty->assign('HEADERSCRIPTS', $COMMONHDRLINKS['HEADERSCRIPT']);
	$smarty->assign('HEADERCSS', $COMMONHDRLINKS['HEADERCSS']);
	// END
	$smarty->display('modules/Messages/Detach.tpl');
}
//crmv@44775e
?>