<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/
/* crmv@48159 */

require_once('modules/Messages/MessagesRelationManager.php');
require_once('modules/Messages/src/Squirrelmail.php');

class Messages extends MessagesRelationManager {

	private $folder;			// Selected folder
	private $saved_messages;
	protected $account;
	var $folderSeparator = '/';
	var $defaultSpecialFolders = array(
		'INBOX'=>'',
		'Drafts'=>'',
		'Sent'=>'',
		'Spam'=>'',
		//'Junk'=>'',
		'Trash'=>'',
	);
	var $fakeFolders = array('Shared','Flagged','Links','Outgoing');
	var $resetMailResource = false;
	var $other_contenttypes_attachment = array(
		'application/pgp-signature',
		'application/octet-stream',
		'application/pdf'
	);
	var $list_max_entries_per_page = 20;
	
	// IMAP Cron configuration
	var $user_by_schedule = 2;		// num of connections (if 0 do nothing)
	var $folder_by_schedule = 4;	// num of folder processed by user
	var $news_sync_limit = 20;		// num of messages saved by folder by schedule (cron Messages and MessagesInbox)
	var $check_inbox_ever = true;	// check inbox folder of all users every schedule in cron Messages
	var $cron_row_validity = 10;	// minutes
	
	function __construct() {
		parent::__construct();
//		$this->specialFolders = $this->defaultSpecialFolders;
//		$this->specialFolders = $this->getSpecialFolders();
		/*
		//Gmail
		$this->specialFolders['Sent'] = '[Gmail]/Posta inviata';
		$this->specialFolders['Trash'] = '[Gmail]/Cestino';
		$this->specialFolders['Drafts'] = '[Gmail]/Bozze';
		$this->specialFolders['Spam'] = '[Gmail]/Spam';
		//Yahoo
		$this->specialFolders['INBOX'] = 'Inbox';
		$this->specialFolders['Drafts'] = 'Draft';
		$this->specialFolders['Spam'] = 'Bulk Mail';
		//Exchange
		$this->specialFolders['Drafts'] = 'Bozze';
		$this->specialFolders['Sent'] = 'Posta inviata';
		$this->specialFolders['Spam'] = 'Posta indesiderata';
		$this->specialFolders['Trash'] = 'Posta eliminata';
		*/
	}

	function loadZendFramework() {
		global $root_directory;
		set_include_path(get_include_path() . PATH_SEPARATOR . $root_directory.'include');
		require_once 'Zend2/Loader/StandardAutoloader.php';
		$loader = new Zend\Loader\StandardAutoloader(array(
		    'autoregister_zf' => true,
		    'namespaces' => array(
		        'Mail' => 'Zend2/Mail',
		        'Mime' => 'Zend2/Mime',
		    ),
		    'fallback_autoloader' => false,
		));
		// Register with spl_autoload:
		$loader->register();
	}

	function getZendMailProtocolImap($userid='') {
		if (empty(self::$protocol)) {
			if (!empty($userid)) {
				$user = CRMEntity::getInstance('Users');
				$user->retrieve_entity_info($userid,'Users');
			} else {
				global $current_user;
				$user = $current_user;
			}
			$accountid = $this->getAccount();
			$account = $this->getUserAccounts($user->id,$accountid);
			$account = $account[0];
			$server = $account['server'];
			$port = (!empty($account['port']) ? $account['port'] : null);
			$ssl_tls = (!empty($account['ssl_tls']) ? $account['ssl_tls'] : false);
			if (empty($server)) {
				throw new Exception('ERR_IMAP_SERVER_EMPTY');
			}
			$username = $account['username'];
			$password = $account['password'];
			try {
				$protocol = new Zend\Mail\Protocol\Imap($server,$port,$ssl_tls);
			} catch (Exception $e) {
				throw new Exception('ERR_IMAP_CONNECTION_FAILED');
			}
			$login = $protocol->login($username,$password);
			if ($login === false) {
				if (empty($username) || empty($password)) {
					throw new Exception('ERR_IMAP_CREDENTIALS_EMPTY');
				} else {
					throw new Exception('ERR_IMAP_LOGIN_FAILED');
				}
			}
			self::$protocol = $protocol;
		}
		return self::$protocol; // crmv@38592
	}
	/* old mode to connect without class Protocol
	function getZendMailStorageImap() {
		$username = '';
		$password = '';
		$mailbox = '';
		$this->loadZendFramework();
		$mail = new Zend\Mail\Storage\Imap(
			array(	'host'     => $mailbox,
					'user'     => $username,
					'password' => $password
			)
		);
		self::$mail = $mail;
	}
	*/
	function getZendMailStorageImap($userid='') {
		global $current_user, $current_folder;
		if (empty(self::$mail)) {
			$this->loadZendFramework();
			try {
				$this->getZendMailProtocolImap($userid);
			} catch (Exception $e) {
				// if error in cron skip
				if (isset($_REQUEST['app_key']) && $_REQUEST['service'] == 'Messages') {
					throw new Exception('ERR_IMAP_CRON');
				}
				// show Shared folder even if no mail server configured
				if ($_REQUEST['action'] == 'DetailView' && !empty($_REQUEST['record']) && in_array($current_folder,$this->fakeFolders)) {
					return false;
				}
				$this->manageConnectionError($e,$userid);
			}
			$mail = new Zend\Mail\Storage\Imap(self::$protocol);
			self::$mail = $mail;
			return true;
		}
	}
	
	function manageConnectionError($e,$userid='') {
		if (!empty($userid)) {
			$user = CRMEntity::getInstance('Users');
			$user->retrieve_entity_info($userid,'Users');
		} else {
			global $current_user;
			$user = $current_user;
		}
		global $adb, $table_prefix, $theme;
		$title = getTranslatedString($e->getMessage(),'Messages');
		if ($title != $e->getMessage()) {
			$descr = getTranslatedString($e->getMessage().'_DESCR','Messages');
		}
		//if (in_array($e->getMessage(),array('ERR_IMAP_SERVER_EMPTY','ERR_IMAP_CONNECTION_FAILED'))) {}
		//if (in_array($e->getMessage(),array('ERR_IMAP_CREDENTIALS_EMPTY','ERR_IMAP_LOGIN_FAILED'))) {}
		$link = 'index.php?module=Messages&action=MessagesAjax&file=Settings/index&operation=Accounts';
		$accounts = $this->getUserAccounts();
		$account = $this->getAccount();
		if ($e->getMessage() == 'ERR_IMAP_SERVER_EMPTY' && empty($accounts)) {
			$link = 'index.php?module=Messages&action=MessagesAjax&file=Settings/index&operation=EditAccount';
		} elseif ($account !== '') {
			$link = 'index.php?module=Messages&action=MessagesAjax&file=Settings/index&operation=EditAccount&id='.$account;
		}
		$descr = sprintf($descr,'<a href="javascript:;" onClick="openPopup(\''.$link.'\',\'\',\'\',\'auto\',600,500);">'.getTranslatedString('LBL_HERE').'</a>');
		require_once('Smarty_setup.php');
		$smarty = new vtigerCRM_Smarty;
		$smarty->assign('THEME', $theme);
		$smarty->assign('TITLE', $title);
		$smarty->assign('DESCR', $descr);
		$smarty->display('Error.tpl');
		
		$adb->pquery("DELETE FROM {$table_prefix}_messages_cron WHERE userid = ? AND accountid = ?",array($user->id,$this->getAccount()));
		exit;
	}
	
	function getMailResource() {
		return self::$mail;
	}
	
	function resetMailResource() {
		if (!empty(self::$mail)) {
			self::$mail->__destruct();
			self::$mail = '';
		}
		if (!empty(self::$protocol)) {
			self::$protocol->__destruct();
			self::$protocol = '';
		}
		$this->__construct();
	}
	
	function setAccount($id) {
		if ($this->account !== $id) {
			$this->account = $id;
			$this->resetMailResource();
		}
	}
	
	function getAccount() {
		if (!is_numeric($this->account) && $this->account == '') {
			$this->account = $this->column_fields['account'];
		}
		if (!is_numeric($this->account) && $this->account == '') {
			$this->account = '-1';
		}
		return $this->account;
	}
	
	function setSpecialFolders($specialFolders,$accountid) {
		global $current_user, $adb, $table_prefix;
		$adb->pquery("delete from {$table_prefix}_messages_sfolders where userid = ? and accountid = ?",array($current_user->id,$accountid));
		foreach($specialFolders as $special => $folder) {
			$adb->pquery("insert into {$table_prefix}_messages_sfolders (userid, accountid, special, folder) values (?,?,?,?)",array($current_user->id,$accountid,$special,$folder));
		}
	}
	
	function getSpecialFolders($dieOnError=true) {
		global $current_user, $adb, $table_prefix;
		$specialFolders = $this->defaultSpecialFolders;
		$accountid = $this->getAccount();
		$result = $adb->pquery("select special, folder from {$table_prefix}_messages_sfolders where accountid = ?",array($accountid));
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$specialFolders[$row['special']] = $row['folder'];
			}
		}
		if ($dieOnError) {
			if (!in_array($_REQUEST['file'],array('Settings/index','MessagePopup'))
				&& (empty($specialFolders['INBOX']) || empty($specialFolders['Sent']) || empty($specialFolders['Drafts']) || empty($specialFolders['Trash']))
			) {
				$accounts = $this->getUserAccounts();	// check after set account
				if (!empty($accounts)) {
					// if error in cron skip
					if (isset($_REQUEST['app_key']) && $_REQUEST['service'] == 'Messages') {
						throw new Exception('ERR_IMAP_CRON');
					} else {
						global $theme;
						$link = 'index.php?module=Messages&action=MessagesAjax&file=Settings/index&operation=Folders';
						if ($accountid !== '') {
							$link = 'index.php?module=Messages&action=MessagesAjax&file=Settings/index&operation=Folders&account='.$accountid;
						}
						require_once('Smarty_setup.php');
						$smarty = new vtigerCRM_Smarty;
						$smarty->assign('THEME', $theme);
						$smarty->assign('TITLE', getTranslatedString('LBL_ERROR_SPECIALFOLDERS_TITLE','Messages'));
						$descr = getTranslatedString('LBL_ERROR_SPECIALFOLDERS_DESCR','Messages');
						$descr .= '<br />- '.getTranslatedString('LBL_Folder_INBOX','Messages');
						$descr .= '<br />- '.getTranslatedString('LBL_Folder_Drafts','Messages');
						$descr .= '<br />- '.getTranslatedString('LBL_Folder_Sent','Messages');
						$descr .= '<br />- '.getTranslatedString('LBL_Folder_Trash','Messages');
						$smarty->assign('DESCR', sprintf($descr,'<a href="javascript:;" onClick="openPopup(\''.$link.'\',\'\',\'\',\'auto\',600,500);">'.getTranslatedString('LBL_HERE').'</a>'));
						$smarty->display('Error.tpl');
						exit;
					}
				}
			}
		}
		return $specialFolders;
	}
	
	function getAllSpecialFolders($special='',$userid='') {
		global $adb, $table_prefix;
		if (empty($userid)) {
			global $current_user;
			$userid = $current_user->id;
		}
		$specialFolders = array();
		$query = "select accountid, special, folder from {$table_prefix}_messages_sfolders where userid = ?";
		$params = array($userid);
		if (!empty($special)) {
			$query .= " and special = ?";
			$params[] = $special;
		}
		$query .= " order by accountid";
		$result = $adb->pquery($query,$params);
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$specialFolders[$row['accountid']][$row['special']] = $row['folder'];
			}
		}
		return $specialFolders;
	}
	
	// sync server mail fodler with vte cache
	// $num_news if empty (null,false,0,'') download all $news_ids
	function syncFolder($folder, $num_news=0, $only_news=false) {
		global $current_user, $adb;

		$this->getZendMailStorageImap();
		$this->selectFolder($folder);
		
		$server_ids = array();	// populated in checkFlagsChanges
		$cache_ids = array();	// populated in checkFlagsChanges

		//Update flags of cached mail messages - start
		$flag_changed = $this->checkFlagsChanges($current_user->id,$server_ids,$cache_ids);
		//end

		// if no messages cached disable $only_news
		if (empty($cache_ids)) {
			$only_news = false;
		}
		
		//Save new mail messages and delete - start
		
		//TODO: scrivere id di messaggi non validi in una tabella (righe 1166, 1180) e poi caricarli in questo array cos non faccio la getMessage per niente
		//$ids_to_skip = array(5545,6378,6457);
		$ids_to_skip = array();
		if (!empty($ids_to_skip)) {
			$server_ids = array_diff($server_ids,$ids_to_skip);
		}

		$delete_ids = array_diff($cache_ids,$server_ids);
		$this->deleteCache($delete_ids);

		$new_ids = array_diff($server_ids,$cache_ids);
		$new_ids = array_reverse($new_ids,true);	//scarico dai pi recenti ai pi vecchi
		if ($only_news) {
			$tmp = array();
			$result = $adb->limitpQuery("SELECT xuid FROM {$this->table_name}
										INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
										WHERE deleted = 0 AND mtype = ? AND smownerid = ? AND account = ? AND folder = ?
										ORDER BY mdate DESC",0,1,
										array('Webmail',$current_user->id,$this->account,$folder));
			if ($result && $adb->num_rows($result) > 0) {
				$last_uid = $adb->query_result($result,0,'xuid');
				$last_messageid = array_search($last_uid,$server_ids);
				if (empty($last_messageid)) {
					$last_messageid = self::$mail->getNumberByUniqueId($last_uid);
				}
				foreach($new_ids as $messageid => $uid) {
					if ($messageid > $last_messageid) {
						$tmp[$messageid] = $uid;
					}
				}
			}
			$new_ids = $tmp;
		}
		if (!empty($num_news) && !empty($new_ids)) {
			$new_ids = array_slice($new_ids, 0, $num_news, true);
		}

		$this->saveCache($new_ids);
		//end

		return array(
			'delete_ids'=>$delete_ids,
			'new_ids'=>$new_ids,
			'flag_changed'=>$flag_changed
		);
	}
	
	function initializeCronQueue() {
		global $adb, $table_prefix, $current_user;
		$adb->query("delete from {$table_prefix}_messages_cron where status <> 2");
		$result = $adb->pquery("SELECT {$table_prefix}_users.id FROM {$table_prefix}_users WHERE {$table_prefix}_users.status = ?",array('Active'));
		if ($result && $adb->num_rows($result) > 0) {
			$user = false;
			while($row=$adb->fetchByAssoc($result)) {
				$user = $row['id'];
				$accounts = array();
				$tmp = $this->getUserAccounts($user);
				foreach($tmp as $t) {
					$accounts[] = $t['id'];
				}
				if (empty($accounts)) {
					continue;
				}
				foreach($accounts as $account) {
					try {
						$tmp_current_user_id = $current_user;
						$current_user->id = $user;
						
						$this->resetMailResource();
						$this->setAccount($account);
						$this->getZendMailStorageImap($user);
						$folders = $this->getFoldersList();
						
						$current_user->id = $tmp_current_user_id;
						
						foreach ($folders as $foldername => $info) {
							$foldername = html_entity_decode($foldername, ENT_COMPAT, 'UTF-8');	//crmv@47776
							$sequence = $adb->getUniqueID($table_prefix.'_messages_cron');
							if ($adb->isMysql()) {
								$adb->pquery("insert ignore into {$table_prefix}_messages_cron (sequence,userid,accountid,folder,status,ctime) values (?,?,?,?,?,?)",array($sequence,$user,$account,$foldername,0,date('Y-m-d H:i:s')));
							} else {
								//TODO
							}
						}
					} catch (Exception $e) {
						echo "ERROR {$e->getMessage()} user:$user account:$account\n";
						continue;
					}
				}
			}
		}
	}
	
	function getCronQueue() {
		global $adb, $table_prefix;
		$queue = array();
		$sql = "SELECT * FROM {$table_prefix}_messages_cron WHERE status = ? OR (status = ? and ctime < ?) ORDER BY sequence";
		$ctime = date('Y-m-d H:i:s',strtotime('-'.$this->cron_row_validity.' minutes'));
		$result = $adb->pquery($sql,array(0,2,$ctime));
		if ($result && $adb->num_rows($result) > 0) {
			if ($this->user_by_schedule > 0) {
				$userid = false;
				$accountid = false;
				$folder = false;
				$u = 0;
				while($row=$adb->fetchByAssoc($result,-1,false)) {	//crmv@47776
					if ($row['userid'] != $userid) {
						$u++;
						if ($u > $this->user_by_schedule) {
							break;
						}
						$userid = $row['userid'];
						$f = 0;
					}
					$f++;
					if ($f > $this->folder_by_schedule) {
						continue;
					}
					$folder = $row['folder'];
					$accountid = $row['accountid'];
					$queue[$userid][$accountid][] = $folder;
				}
				if ($this->check_inbox_ever) {
					$users = array();
					$result = $adb->pquery("SELECT {$table_prefix}_users.id FROM {$table_prefix}_users WHERE {$table_prefix}_users.status = ?",array('Active'));
					if ($result && $adb->num_rows($result) > 0) {
						while($row=$adb->fetchByAssoc($result)) {
							$users[] = $row['id'];
						}
					}
					foreach ($users as $user) {
						$folders = $this->getAllSpecialFolders('INBOX',$user);
						foreach($folders as $account => $folder) {
							$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = ? WHERE status <> ? AND userid = ? AND accountid = ? AND folder = ?",array(0,2,$user,$account,$folder['INBOX']));
							$result1 = $adb->pquery("SELECT * FROM {$table_prefix}_messages_cron WHERE (status = ? OR (status = ? and ctime < ?)) AND userid = ? AND accountid = ? AND folder = ?",array(0,2,$ctime,$user,$account,$folder['INBOX']));
							while($row=$adb->fetchByAssoc($result1)) {
								$accountid = $row['accountid'];
								if (empty($queue[$user])) {
									$queue[$user][$accountid][] = $row['folder'];
								} elseif (!in_array($row['folder'],$queue[$user])) {
									$queue[$user][$accountid][] = $row['folder'];
								}
							}
						}
					}
				}
			}
		}
		return $queue;
	}
	
	function cronSync() {

		// first of all propagate to server pending changes
		$this->propagateToImap();

		// recalculate folders list
		$this->syncFolders();

		global $adb, $table_prefix;
		$queue = $this->getCronQueue();
		if (empty($queue)) {
			$this->initializeCronQueue();
			$queue = $this->getCronQueue();
		}
		return $this->syncQueue($queue);
	}
	
	function cronInboxNews() {
		
		// first of all propagate to server pending changes
		$this->propagateToImap('fast');
		
		global $adb, $table_prefix;
		$ctime = date('Y-m-d H:i:s',strtotime('-'.$this->cron_row_validity.' minutes'));
		$users = array();
		$result = $adb->pquery("SELECT {$table_prefix}_users.id FROM {$table_prefix}_users WHERE {$table_prefix}_users.status = ?",array('Active'));
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$users[] = $row['id'];
			}
		}
		$queue = array();
		foreach ($users as $user) {
			$folders = $this->getAllSpecialFolders('INBOX',$user);
			foreach($folders as $account => $folder) {
				$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = ? WHERE status <> ? AND userid = ? AND accountid = ? AND folder = ?",array(0,2,$user,$account,$folder['INBOX']));
				$result1 = $adb->pquery("SELECT * FROM {$table_prefix}_messages_cron WHERE (status = ? OR (status = ? and ctime < ?)) AND userid = ? AND accountid = ? AND folder = ?",array(0,2,$ctime,$user,$account,$folder['INBOX']));
				while($row=$adb->fetchByAssoc($result1)) {
					$queue[$user][$account][] = $row['folder'];
				}
			}
		}
		return $this->syncQueue($queue, true);
	}
	
	function syncQueue($queue, $only_news=false) {
		if (empty($queue)) {
			return;
		}
		global $adb, $table_prefix, $current_user;
		foreach($queue as $userid => $accounts) {
			$current_user->id = $userid;
			foreach ($accounts as $account => $folders) {
				$this->resetMailResource();
				$this->setAccount($account);
				try {
					$this->getZendMailStorageImap($userid);
				} catch (Exception $e) {
					continue;
				}
				foreach($folders as $folder) {
					//@file_put_contents('cron/modules/Messages/Errors.txt',"$userid $account $folder ... ",FILE_APPEND);
					$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = ?, ctime = ? WHERE userid = ? AND accountid = ? AND folder = ?",array(2,date('Y-m-d H:i:s'),$userid,$account,$folder));
					try {
						$sync_result = $this->syncFolder($folder, $this->news_sync_limit, $only_news);

						// read last messageid saved
						$result = $adb->limitpQuery("SELECT xuid FROM {$this->table_name}
													INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
													WHERE deleted = 0 AND mtype = ? AND smownerid = ? AND account = ? AND folder = ?
													ORDER BY mdate DESC",0,1,
													array('Webmail',$current_user->id,$this->account,$folder));
						if ($result && $adb->num_rows($result) > 0) {
							$last_uid = $adb->query_result($result,0,'xuid');
							$last_messageid = self::$mail->getNumberByUniqueId($last_uid);
						}

						// if import news write in _messages_cron_news
						$new_ids = $sync_result['new_ids'];
						if (!empty($new_ids)) {
							$tmp = array();
							foreach($new_ids as $messageid => $uid) {
								if ($messageid > $last_messageid) {
									$tmp[$messageid] = $uid;
									break;
								}
							}
							if (!empty($tmp)) {
								if ($adb->isMysql()) {
									$adb->pquery("insert ignore into {$table_prefix}_messages_cron_news (userid,accountid,folder) values (?,?,?)",array($userid,$account,$folder));
								} else {
									$result = $adb->pquery("SELECT * FROM {$table_prefix}_messages_cron_news
															WHERE {$table_prefix}_messages_cron_news.userid = ? AND {$table_prefix}_messages_cron_news.accountid = ? AND {$table_prefix}_messages_cron_news.folder = ?",
															array($userid,$account,$folder));
									if (!$result || $adb->num_rows($result) == 0) {
										$adb->pquery("insert into {$table_prefix}_messages_cron_news (userid,accountid,folder) values (?,?,?)",array($userid,$account,$folder));
									}
								}
							}
						}
						//@file_put_contents('cron/modules/Messages/Errors.txt',"DONE\n",FILE_APPEND);
					} catch (Exception $e) {
						//echo "ERROR:{$e->getMessage()} user:$userid, account:$account, folder:$folder\n";
						//@file_put_contents('cron/modules/Messages/Errors.txt',"FAILED\n",FILE_APPEND);
					}
					//crmv@44482
					$adb = new PearDatabase();
					$adb->connect();
					//crmv@44482e
					$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = ?, ctime = ? WHERE userid = ? AND accountid = ? AND folder = ?",array(1,date('Y-m-d H:i:s'),$userid,$account,$folder));
				}
			}
		}
		//@file_put_contents('cron/modules/Messages/Errors.txt',"--------------------------------------\n",FILE_APPEND);
	}
	
	function addToPropagationCron($operation, $params, $max_attempts=3) {
		global $adb, $table_prefix;
		if (is_array($params)) {
			$params = Zend_Json::encode($params);
		}
		$adb->pquery("insert into {$table_prefix}_messages_prop2imap (sequence,operation,params,status,attempts,max_attempts) values (?,?,?,?,?,?)",array(
			$adb->getUniqueID($table_prefix.'_messages_prop2imap'), $operation, $params, 0, 0, $max_attempts
		));
	}
	
	function propagateToImap($mode='full') {
		global $adb, $table_prefix;
		// skip running propagations and attempts exceeded
		$query = "select * from {$table_prefix}_messages_prop2imap where status <> ? and attempts < max_attempts";
		$params = array(2);
		if ($mode == 'fast') {	// skip slow operations
			$query .= " and operation <> ?";
			$params[] = 'empty';
		}
		$query .= " order by sequence";
		$result = $adb->pquery($query,$params);
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result,-1,false)) {
				$adb->pquery("update {$table_prefix}_messages_prop2imap set status = ?, attempts = ? where sequence = ?",array(2,$row['attempts']+1,$row['sequence']));
				try {
					$params = Zend_Json::decode($row['params']);
					switch ($row['operation']) {
						case 'flag':
							$this->propagateSetFlag($params['id'],$params['flag'],$params['value']);
							break;
						case 'flag_folder':
							$this->propagateFlagFolder($params['userid'],$params['account'],$params['folder'],$params['flag'],$params['value']);
							break;
						case 'move':
							$this->propagateMoveMessage($params['userid'],$params['account'],$params['folder'],$params['uid'],$params['new_folder'],$params['skip_fetch']);
							break;
						case 'move_mass':
							$this->propagateMassMoveMessage($params['userid'],$params['account'],$params['folder'],$params['uid'],$params['new_folder']);
							break;
						case 'trash':
							$this->propagateTrash($params['userid'],$params['account'],$params['folder'],$params['uid'],$params['fetch']);
							break;
						case 'empty':
							$this->propagateEmpty($params['userid'],$params['account'],$params['folder']);
							break;
					}
					$adb->pquery("delete from {$table_prefix}_messages_prop2imap where sequence = ?",array($row['sequence']));
				} catch (Exception $e) {
					$adb->pquery("update {$table_prefix}_messages_prop2imap set status = ?, error = ? where sequence = ?",array(1,$e->getMessage(),$row['sequence']));
				}
			}
		}
	}
	
	function syncFolders($userid='', $account='') {
		global $adb, $table_prefix;
		$query = "select userid, id from {$table_prefix}_messages_account";
		$params = array();
		if (!empty($userid) && !empty($account)) {
			$query .= " where userid = ? and id = ?";
			$params[] = $userid;
			$params[] = $account;
		}
		$query .= " order by userid, id";
		$res = $adb->pquery($query,$params);
		if ($res && $adb->num_rows($res) > 0) {
			while($r=$adb->fetchByAssoc($res)) {
				
				$account = $r['id'];
				$userid = $r['userid'];

				$this->setAccount($account);
				try {
					$this->getZendMailStorageImap($userid);
				} catch (Exception $e) {
					continue;
				}
		
				$specialFolders = $this->getSpecialFolders();
				$special_folders_list = array_keys($specialFolders);
		
				//Order folder list with $special_folders_list
				$tmp1 = array();
				$tmp2 = array();
				$depths = array();
				$folders = self::$mail->getFolders();
				foreach ($folders as $folder) {
					$foldername = $folder->getGlobalName();
					$in_array = array_search(preg_replace('#'.$this->folderSeparator.'.*#','',$foldername),$special_folders_list);
					if ($in_array !== false) {
						$tmp1[$in_array.$foldername] = $folder;
					} else {
						$tmp2[$foldername] = $folder;
					}
					if (strpos($foldername,$this->folderSeparator) !== false) {
						$depths[$foldername] = substr_count($foldername,$this->folderSeparator);
					}
				}
				ksort($tmp1);
				$folders = array_merge($tmp1, $tmp2);
				$folder_root = new Zend\Mail\Storage\Folder('/','/',false,$folders);
				//end
		
				$folders_it = new RecursiveIteratorIterator($folder_root,RecursiveIteratorIterator::SELF_FIRST);
				$folders = array();
				
				$folders[] = array(
					'localname'=>$folder_root->getLocalName(),
					'globalname'=>$folder_root->getGlobalName(),
					'depth'=>0,
					'selectable'=>0,
					'count'=>0,
				);
		
				// folder of Shared mail
				$related_ids = $this->getRelatedModComments(false,$userid);
				$folders[] = array(
					'localname'=>'Shared',
					'globalname'=>'Shared',
					'depth'=>0,
					'selectable'=>1,
					'count'=>count($related_ids),
				);
				// end
		
				// folder of Links
				$count = 0;
				$result = $adb->pquery("SELECT count(*) AS count FROM {$this->table_name}
										INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
										WHERE deleted = 0 AND smownerid = ? and {$this->table_name}.account = ? and {$this->table_name}.mtype = ?",
										array($userid,$account,'Link'));
				if ($result && $adb->num_rows($result) > 0) {
					$count = $adb->query_result($result,0,'count');
				}
				$folders[] = array(
					'localname'=>'Links',
					'globalname'=>'Links',
					'depth'=>0,
					'selectable'=>1,
					'count'=>$count,
				);
				// end
		
				// folder of Flagged mail
				$count = 0;
				$result = $adb->pquery("SELECT count(*) AS count FROM {$this->table_name}
										INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
										WHERE deleted = 0 AND smownerid = ? AND {$this->table_name}.account = ? AND {$this->table_name}.flagged = ? and {$this->table_name}.mtype = ?",
										array($userid,$account,1,'Webmail'));
				if ($result && $adb->num_rows($result) > 0) {
					$count = $adb->query_result($result,0,'count');
				}
				$folders[] = array(
					'localname'=>'Flagged',
					'globalname'=>'Flagged',
					'depth'=>0,
					'selectable'=>1,
					'count'=>$count,
				);
				// end
				
				$folder_counts = array();
				$result = $adb->pquery("SELECT folder, count(*) AS count FROM {$this->table_name}
										INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
										WHERE deleted = 0 AND smownerid = ? AND {$this->table_name}.account = ? AND {$this->table_name}.seen = ? and {$this->table_name}.mtype = ?
										GROUP BY folder",array($userid,$account,0,'Webmail'));
				if ($result && $adb->num_rows($result) > 0) {
					while($row=$adb->fetchByAssoc($result)) {
						$folder_counts[$row['folder']] = $row['count'];
					}
				}
					
				foreach ($folders_it as $folder) {
					$localName = $folder->getLocalName();
					$globalName = $folder->getGlobalName();
		
					$depth1 = $depths[$globalName];
					$depth2 = $folders_it->getDepth();
					$depth = max($depth1,$depth2);
					if (empty($depth)) $depth = 0;
					
					$folders[] = array(
						'localname'=>$localName,
						'globalname'=>$globalName,
						'depth'=>$depth,
						'selectable'=>$folder->isSelectable(),
						'count'=>$folder_counts[$localName],
					);
				}
				
				$adb->pquery("delete from {$table_prefix}_messages_folders where userid = ? and accountid = ?",array($userid,$account));

				$sequence = 0;
				foreach($folders as $folder) {
					(empty($folder['selectable'])) ? $selectable = 0 : $selectable = 1;
					$adb->pquery("insert into {$table_prefix}_messages_folders (userid,accountid,globalname,localname,depth,selectable,count,sequence) values (?,?,?,?,?,?,?,?)",array(
						$userid,$account,$folder['globalname'],$folder['localname'],$folder['depth'],$selectable,$folder['count'],$sequence
					));
					$sequence++;
				}
			}
		}
	}
	
	function reloadCacheFolderCount($userid,$accountid,$folder) {
		global $adb, $table_prefix;
		$query = "SELECT count(*) AS count FROM {$this->table_name}
				INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
				WHERE deleted = 0 AND smownerid = ? AND {$this->table_name}.account = ? and {$this->table_name}.mtype = ?";
		$params = array($userid,$accountid,'Webmail');
		if ($folder == 'Flagged') {
			$query .= " AND {$this->table_name}.flagged <> ?";
			$params[] = 0;
		} else {
			$query .= " AND {$this->table_name}.seen = ? and {$this->table_name}.folder = ?";
			$params[] = 0;
			$params[] = $folder;
		}
		$result = $adb->pquery($query,$params);
		if ($result && $adb->num_rows($result) > 0) {
			$count = $adb->query_result($result,0,'count');
			$adb->pquery("update {$table_prefix}_messages_folders set count = ? where userid = ? and accountid = ? and globalname = ?",array($count,$userid,$accountid,$folder));
		}
	}
	
	// fetch new Messages from folder, if $num empty -> fetch only the most recent
	function fetchNews($folder, $num=1) {
		global $current_user;
		$this->selectFolder($folder);
		$cache_ids = $this->getSavedUids($current_user->id);
		$server_ids = $this->getServerUids();
		$new_ids = array_diff($server_ids,$cache_ids);
		$new_ids = array_slice(array_reverse($new_ids,true),0,$num,true);
		$this->saveCache($new_ids);
	}
	
	function fetch($account, $folder, $only_news = false) {
		
		global $current_user, $adb, $table_prefix;

		//crmv@48471
		if (empty($folder) || $account == '' || $account == 'all' || in_array($folder,$this->fakeFolders)) {
			return '';
		}
		$specialFolders = $this->getAllSpecialFolders('INBOX');
		if (empty($specialFolders[$account]) || $folder == $specialFolders[$account]['INBOX']) {
			return '';
		}
		
		// first of all propagate to server pending changes
		$this->propagateToImap();	//TODO parameterize by user
		
		//crmv@48471e

		$reload = false;

		// check if cron have already download news
		if ($only_news) {
			$where = " WHERE {$table_prefix}_messages_cron_news.userid = ?";
			$params = array($current_user->id);
			if ($account == 'all') {
				$specialFolders = $this->getAllSpecialFolders('INBOX');
				if (empty($specialFolders)) {
					return '';
				}
				$tmp = array();
				foreach($specialFolders as $a => $fldrs) {
					$tmp[] = "({$table_prefix}_messages_cron_news.folder = ? AND {$table_prefix}_messages_cron_news.accountid = ?)";
					$params[] = array($fldrs['INBOX'],$a);
				}
				$where .= " AND (".implode(' OR ',$tmp).")";
			} else {
				$where .= " AND {$table_prefix}_messages_cron_news.folder = ? AND {$table_prefix}_messages_cron_news.accountid = ?";
				$params[] = array($folder,$account);
			}
			$result = $adb->pquery("SELECT * FROM {$table_prefix}_messages_cron_news".$where,$params);
			if ($result && $adb->num_rows($result) > 0) {
				$adb->pquery("DELETE FROM {$table_prefix}_messages_cron_news".$where,$params);
				return 'RELOAD_AND_FETCH';
			}
		}

		if ($account == 'all') {
			$accounts = array();
			$tmp = $this->getUserAccounts();
			foreach($tmp as $t) {
				$accounts[] = $t['id'];
			}
		} else {
			$accounts = array($account);
		}

		foreach ($accounts as $account) {
			$has_sleep = false;
			$i = 0;
			while(true) {
				if ($i >= 20) {
					// prevent infinite circles
					return 'RELOAD';
				}
				$result = $adb->pquery("SELECT status, ctime FROM {$table_prefix}_messages_cron WHERE userid = ? AND accountid = ? AND folder = ?",array($current_user->id,$account,$folder));
				if ($result && $adb->num_rows($result) > 0) {
					$cron = true;
					$status = $adb->query_result($result,0,'status');
					$time = $adb->query_result($result,0,'ctime');
					$diff = time()-strtotime($time);	// diff in sec between now and last update of ctime
					if ($status == '2' && $diff < ($focus->cron_row_validity * 60)) {
						$has_sleep = true;	// se ho atteso significa che stava scaricando qualcosa quindi ricarico la lista
						$i++;
						sleep(1);
					} else {
						$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = ?, ctime = ? WHERE userid = ? AND accountid = ? AND folder = ?",array(2,date('Y-m-d H:i:s'),$current_user->id,$account,$folder));
						break;
					}
				} else {	// cron is not configured
					$cron = false;
					break;
				}
			}
			if ($has_sleep) {
				$reload = true;
			}
			$this->setAccount($account);
			$sync_result = $this->syncFolder($folder, $this->list_max_entries_per_page, $only_news);
			$delete_ids = $sync_result['delete_ids'];
			$new_ids = $sync_result['new_ids'];
			$flag_changed = $sync_result['flag_changed'];
			if (!empty($delete_ids) || !empty($new_ids) || $flag_changed) {
				$reload = true;
			}
			if ($cron) {
				$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = ?, ctime = ? WHERE userid = ? AND accountid = ? AND folder = ?",array(1,date('Y-m-d H:i:s'),$current_user->id,$account,$folder));
			}
		}
		if ($reload) return 'RELOAD';
		return '';
	}
	
	function selectFolder($folder) {
		$this->folder = $folder;
		self::$mail->selectFolder($folder);
	}
	
	function getServerUids() {
		return self::$mail->getUniqueId();
	}
	
	function getSavedUids($userid) {
		if (empty($this->folder) || $this->account === '') {
			return false;
		}
		global $adb, $table_prefix;
		$external_codes = array();
		$result = $adb->pquery("SELECT crmid, xuid FROM {$this->table_name}
								INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
								WHERE {$this->entity_table}.deleted = 0 AND {$this->table_name}.mtype = ? AND {$this->entity_table}.smownerid = ? AND {$this->table_name}.account = ? AND {$this->table_name}.folder = ?",array('Webmail',$userid,$this->account,$this->folder));
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$external_codes[$row['crmid']] = $row['xuid'];
			}
		}
		return $external_codes;
	}
	
	function checkFlagsChanges($userid,&$server_ids,&$cache_ids) {
		if (empty($this->folder) || $this->account === '') {
			return;
		}

		$server_ids = $this->getServerUids();

		$found_changes = false;
		global $adb, $table_prefix;
		$result = $adb->pquery("SELECT xuid, seen, answered, flagged, forwarded, crmid FROM {$this->table_name}
								INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
								WHERE {$this->entity_table}.deleted = 0 AND {$this->table_name}.mtype = ? AND {$this->entity_table}.smownerid = ? AND {$this->table_name}.account = ? AND {$this->table_name}.folder = ?",array('Webmail',$userid,$this->account,$this->folder));
		if (!$result || $adb->num_rows($result)== 0) {
			return;
		} else {
			$cache_flags = array();
			while($row=$adb->fetchByAssoc($result)) {
				$tmp = array();
				if ($row['seen'] == '1') {
					$tmp[] = Zend\Mail\Storage::FLAG_SEEN;
				}
				if ($row['answered'] == '1') {
					$tmp[] = Zend\Mail\Storage::FLAG_ANSWERED;
				}
				if ($row['flagged'] == '1') {
					$tmp[] = Zend\Mail\Storage::FLAG_FLAGGED;
				}
				if ($row['forwarded'] == '1') {
					//$tmp[] = '$Forwarded';
					$tmp[] = 'Forwarded';
				}
				$cache_flags[$row['xuid']] = $tmp;
				$cache_ids[$row['crmid']] = $row['xuid'];
			}
		}
	
		$cache_uids = array_keys($cache_flags);
		$server_message_ids = array_flip($server_ids);
		$cache_list = array_intersect($server_ids,$cache_uids);
		$cache_list = array_slice($cache_list,-1000,1000,true);	//crmv@42701
		
		$managed_flags = array(Zend\Mail\Storage::FLAG_SEEN,Zend\Mail\Storage::FLAG_ANSWERED,Zend\Mail\Storage::FLAG_FLAGGED,'$Forwarded','Forwarded');
		$server_flags = array();

		//$server_flags_tmp = self::$protocol->fetch(array('UID','FLAGS'),1,INF);					// read all messages
		$server_flags_tmp = self::$protocol->fetch(array('UID','FLAGS'),array_keys($cache_list));	// read only messages already cached

		foreach ($server_flags_tmp as $i => $info) {
			$uid = $info['UID'];
			$server_flags[$uid] = array_intersect($info['FLAGS'],$managed_flags);
			if (in_array('Forwarded',$server_flags[$uid]) && in_array('$Forwarded',$server_flags[$uid])) {
				$server_flags[$uid] = array_diff($server_flags[$uid],array('$Forwarded'));
			}
			if (empty($server_flags[$uid])) $server_flags[$uid] = array();
			if (empty($cache_flags[$uid])) $cache_flags[$uid] = array();
			$inter = array_intersect($server_flags[$uid],$cache_flags[$uid]);
			if (count($inter) != count($server_flags[$uid]) || count($inter) != count($cache_flags[$uid])) {
				//$inters[$uid] = array('server'=>$server_flags[$uid],'cache'=>$cache_flags[$uid],'inter'=>$inter);
				$this->updateCacheFlags($userid,$uid,$server_flags[$uid]);	//crmv@42701
				$found_changes = true;
			}
		}
		return $found_changes;
	}
	
	function updateCacheFlags($userid,$uid,$flags) {	//crmv@42701
		global $adb, $table_prefix;
		
		$sql_update = array(
			'seen = ?' => 0,
			'answered = ?' => 0,
			'flagged = ?' => 0,
			'forwarded = ?' => 0,
		);
		foreach($flags as $flag) {
			switch ($flag) {
				case Zend\Mail\Storage::FLAG_SEEN :
					$sql_update['seen = ?'] = 1;
					break;
				case Zend\Mail\Storage::FLAG_ANSWERED :
					$sql_update['answered = ?'] = 1;
					break;
				case Zend\Mail\Storage::FLAG_FLAGGED :
					$sql_update['flagged = ?'] = 1;
					break;
				case 'Forwarded':
				case '$Forwarded':
					$sql_update['forwarded = ?'] = 1;
					break;
			}
		}
		//crmv@42701
		$query = "UPDATE {$this->table_name}
		INNER JOIN {$table_prefix}_crmentity ON {$table_prefix}_crmentity.crmid = {$this->table_name}.messagesid
		SET ".implode(',',array_keys($sql_update))."
		WHERE xuid = ? AND deleted = 0 AND smownerid = ? AND account = ? AND folder = ?";
		$adb->pquery($query,array($sql_update,$uid,$userid,$this->account,$this->folder));
		//crmv@42701e
	}
	
	function getCacheFlags() {
		global $adb, $table_prefix;
		$result = $adb->pquery("SELECT seen, answered, flagged, forwarded FROM {$this->table_name} WHERE {$this->table_name}.messagesid = ?",array($this->id));
		$flags = array();
		if ($result && $adb->num_rows($result) > 0) {
			if ($adb->query_result($result,0,'seen') == '1') {
				$flags[Zend\Mail\Storage::FLAG_SEEN] = Zend\Mail\Storage::FLAG_SEEN;
			}
			if ($adb->query_result($result,0,'answered') == '1') {
				$flags[Zend\Mail\Storage::FLAG_ANSWERED] = Zend\Mail\Storage::FLAG_ANSWERED;
			}
			if ($adb->query_result($result,0,'flagged') == '1') {
				$flags[Zend\Mail\Storage::FLAG_FLAGGED] = Zend\Mail\Storage::FLAG_FLAGGED;
			}
			if ($adb->query_result($result,0,'forwarded') == '1') {
				$flags['$Forwarded'] = '$Forwarded';
				$flags['Forwarded'] = 'Forwarded';
			}
		}
		return $flags;
	}

	function getAddressListString($header_obj,$param) {
		if (get_class($header_obj) != 'ArrayIterator') {
			$header_obj = array($header_obj);
		}
		if ($param == 'full') {
			$return = array();
			foreach ($header_obj as $i) {
				$return[] = $i->toString();
			}
			return implode(', ',$return);
		} else {
			$return = array();
			foreach ($header_obj as $i) {
				$addresslist = $i->getAddressList();
				foreach($addresslist as $address_obj) {
					if ($param == 'email') {
						$return[] = $address_obj->getEmail();
					} elseif ($param == 'name') {
						$return[] = $address_obj->getName();
					}
				}
			}
			if ($param == 'email') {
				//return last element of array -> fix this cases '"Lastname, firstname.lastname@domain.com' -> 'firstname.lastname@domain.com'
				return $return[sizeof($return)-1];
			} else {
				return implode(', ',array_filter($return));
			}
		}
	}

	function getMessageHeader($message) {
		$headerkeys_addr_type = array('From','To','ReplyTo','Cc','Bcc');
		$headerkeys = array('From','To','ReplyTo','Cc','Bcc','Date','Subject','Sender','Messageid','Xmailer','In-Reply-To','References','Thread-Index');
		$return = array();
		$squirrelmail = new Squirrelmail($this,true);
		foreach($headerkeys as $headerkey) {
			if (isset($message->{strtolower($headerkey)})) {
				if (in_array($headerkey,$headerkeys_addr_type)) {
					
					$headerobj = $message->getHeader($headerkey);
					
					$full = str_replace("$headerkey: ",'',$this->getAddressListString($headerobj,'full'));
					if ($headerkey == 'ReplyTo') {
						$full = str_replace('Reply-To: ','',$full);
					}
					$full = $squirrelmail->decodeHeader($full,true,false);
					
					$name = $this->getAddressListString($headerobj,'name');
					$name = $squirrelmail->decodeHeader($name,true,false);
					
					$email = $this->getAddressListString($headerobj,'email');
					
					$return[$headerkey] = array(
						'email'=>strval($email),
						'name'=>strval($name),
						'full'=>strval($full),
					);
				} else {
					$return[$headerkey] = strval($squirrelmail->decodeHeader($message->{strtolower($headerkey)},true,false));
				}
			}
		}
		return $return;
	}

	function getMessageContentParts($message,$id) {
		global $default_charset;
		$data = array();
		$data['header'] = $this->getMessageHeader($message);
		$data['flags'] = $this->getMessageFlags($message);
		$isMultipart = false;
		try {
			if ($message->isMultipart()) {
				$isMultipart = true;
			}
		} catch (Exception $e) {}
		if (!$isMultipart) {		
			try {
				$contentobj = $message->getHeader('Content-Type');
			} catch (Exception $e) {}
			if (get_class($contentobj) == 'Zend\Mail\Header\ContentType') {
				$contenttype = strtolower($contentobj->getType());
			} elseif (get_class($contentobj) == 'ArrayIterator') {
				foreach ($contentobj as $contenttmp) {
					$contenttype = strtolower($contenttmp->getType());
					break;
				}
			} else {
				$contenttype = 'text/plain';
			}
			try {
				$charset = $message->getHeaderField('Content-Type', 'charset');
			} catch (Exception $e) {
				$charset = '';
			}
			$encoding = '';
			if (isset($message->contentTransferEncoding)) {
				$encoding = $message->contentTransferEncoding;
			}
			$content = $message->__toString($message->getContent());
			$content = $this->decodePart($content,$encoding,$charset);
			$data[$contenttype][] = $content;
		} else {
			try {
				foreach (new RecursiveIteratorIterator($message) as $part) {
					/*
					echo $id.'<br /><pre>';
					print_r($part);
					echo '</pre><br /><br />';
					*/
					try {
						$contentobj = $part->getHeader('Content-Type');
					} catch (Exception $e) {}
					if (get_class($contentobj) == 'Zend\Mail\Header\ContentType') {
						$contenttype = strtolower($contentobj->getType());
						$parameters = $contentobj->getParameters();
					} elseif (get_class($contentobj) == 'ArrayIterator') {
						foreach ($contentobj as $contenttmp) {
							$contenttype = strtolower($contenttmp->getType());
							$parameters = $contenttmp->getParameters();
							break;
						}
					} else {
						$contenttype = 'text/plain';
						$parameters = '';
					}
					try {
						$charset = $part->getHeaderField('Content-Type', 'charset');
					} catch (Exception $e) {
						$charset = '';
					}
					$encoding = '';
					if (isset($part->contentTransferEncoding)) {
						$encoding = $part->contentTransferEncoding;
					}
					$content = $part->__toString($part->getContent());
					
					// text/html content
					$txtContent = $this->decodePart($content,$encoding,$charset);
					
					// attachment content
					$otherContent = array('content'=>$content);
					$otherContent['parameters'] = $parameters;
					$otherContent['parameters']['contenttype'] = $contenttype;
					if (isset($part->contentdisposition)) {
						$otherContent['parameters']['contentdisposition'] = $part->getHeaderField('contentdisposition');
					}
					if (!empty($charset)) {
						$otherContent['parameters']['charset'] = $charset;
					}
					if (!empty($encoding)) {
						$otherContent['parameters']['encoding'] = $encoding;
					}
					try {
						$contentid = $part->getHeader('Content-ID');
						$contentid = $contentid->getFieldValue();
						$contentid = ltrim($contentid,'<');
						$contentid = rtrim($contentid,'>');
						$otherContent['parameters']['content_id'] = $contentid;
					} catch (Exception $e) {}
					
					// check if is text/html part or attachment
					$isText = false;
					if (in_array($contenttype,array('text/plain','text/html'))) {
						$isText = true;
					}
					//crmv@46629
					if (in_array($contenttype,array('text/plain','text/html')) && $otherContent['parameters']['contentdisposition'] == 'inline') {
						$isText = true;
					//crmv@46629e
					} elseif (!in_array($contenttype,array('text/plain','text/html')) || !empty($otherContent['parameters']['name']) || !empty($otherContent['parameters']['contentdisposition'])) {
						$isText = false;
						//crmv@45179	//crmv@43245
						if (empty($otherContent['parameters']['name'])) {
							$filename = 'Unknown';
							try {
								$filename_tmp = $part->getHeader('Content-Disposition')->getFieldValue();
								$pos = strpos($filename_tmp,'filename=');
								if (!empty($filename_tmp) && $pos !== false) {
									$r = preg_match('/filename="([^"]+)"/', $filename_tmp, $matches);
									if (!empty($matches[1])) $filename = $matches[1];
								}
							} catch (Exception $e) {}
							$otherContent['parameters']['name'] = $filename;
						}
						//crmv@45179e	//crmv@43245e
					}
					if ($isText) {
						$data[$contenttype][] = $txtContent;
					} else {
						$data['other'][] = $otherContent;
					}
				}
			} catch (Exception $e) {
				if ($e->getMessage() == 'Not a valid Mime Message: End Missing') {
					return false;
				}
			}
		}
		if (empty($data['flags']['seen'])) {
			$this->restoreSeenFlag($message,$id);
		}
		if (!empty($data['text/plain'])) {
			$data['text/plain'] = implode("\n\n",$data['text/plain']);
		}
		if (!empty($data['text/html'])) {
			$data['text/html'] = implode('<br><br>',$data['text/html']);
		}
		return $data;
	}
	
	function getMessageFlags($message) {
		$flags = array(
			'seen' => '',
			'answered' => '',
			'flagged' => '',
			'forwarded' => ''
		);
		if ($message->hasFlag(Zend\Mail\Storage::FLAG_SEEN)) {
			$flags['seen'] = 'on';
		}
		if ($message->hasFlag(Zend\Mail\Storage::FLAG_ANSWERED)) {
			$flags['answered'] = 'on';
		}
		if ($message->hasFlag(Zend\Mail\Storage::FLAG_FLAGGED)) {
			$flags['flagged'] = 'on';
		}
		if ($message->hasFlag('Forwarded') || $message->hasFlag('$Forwarded')) {
			$flags['forwarded'] = 'on';
		}
		return $flags;
	}
	
	function restoreSeenFlag($message,$id) {
		$flags = $message->getFlags();
		unset($flags[Zend\Mail\Storage::FLAG_SEEN]);
		unset($flags[Zend\Mail\Storage::FLAG_RECENT]);	// error to set recent flag
		try {
			self::$mail->setFlags($id, $flags);
		} catch (Zend\Mail\Storage\Exception\RuntimeException $e) {}
	}
	
	function decodePart($content,$encoding='',$charset='') {
		global $default_charset;
		if (isset($encoding)) {
			switch (strtolower($encoding)) {	//crmv@46629
				case 'base64':
					$content = base64_decode($content);
					break;
				case 'quoted-printable':
					$content = quoted_printable_decode($content);
					break;
			}
		}
		//crmv@46629
		$content = correctEncoding($content, $default_charset, $charset);
		//crmv@46629e
		return $content;
	}
	
	function decodeAttachment($content,$encoding='',$charset='') {
		global $default_charset;
		if (isset($encoding)) {
			switch (strtolower($encoding)) {	//crmv@46629
				case 'base64':
					$content = base64_decode($content);
					break;
				case 'quoted-printable':
					$content = quoted_printable_decode($content);
					break;
			}
		}
		return $content;
	}
	
	function propagateEmpty($userid,$account,$folder) {
		global $adb, $table_prefix, $current_user;
		$tmp_current_user_id = $current_user;
		$current_user->id = $userid;
						
		$focus = CRMEntity::getInstance('Messages');
		$focus->setAccount($account);
		$focus->getZendMailStorageImap($userid);
		
		$focus->emptyFolder($folder);
		$focus->syncFolder($folder);
		$focus->reloadCacheFolderCount($userid,$account,$folder);
		
		$current_user->id = $tmp_current_user_id;
	}
	
	function emptyFolder($folder) {
		// delete messages in folder
		self::$mail->selectFolder($folder);
		$uids = $this->getServerUids();
		if (!empty($uids)) {
			foreach($uids as $messageId => $uid) {
				//$messageId = self::$mail->getNumberByUniqueId($uid);
				try {
					self::$mail->removeMessage($messageId);
				} catch (Zend\Mail\Storage\Exception\RuntimeException $e) {}
			}
		}
		// delete messages in subfolders
		try {
			$folders = self::$mail->getFolders($folder);
			if ($folders->getGlobalName() == $this->folderSeparator) {	// check to have the correct tree
				$folders_it = new RecursiveIteratorIterator($folders,RecursiveIteratorIterator::CHILD_FIRST);
				foreach ($folders_it as $tmp_folders) {
					if ($tmp_folders->getGlobalName() == $folder) {
						$folders = $tmp_folders;
						break;
					}
				}
			}
			$specialFolders = $this->getSpecialFolders();
			$folders_it = new RecursiveIteratorIterator($folders,RecursiveIteratorIterator::CHILD_FIRST);
			foreach ($folders_it as $localName => $leave_folder) {
				if ($leave_folder == $folder || in_array($leave_folder,$specialFolders)) {	// check to not delete Trash folder or other special folders
					continue;
				}
				$leave_folder = htmlspecialchars($leave_folder);
				self::$mail->selectFolder($leave_folder);
				$uids = $this->getServerUids();
				if (!empty($uids)) {
					foreach($uids as $messageId => $uid) {
						//$messageId = self::$mail->getNumberByUniqueId($uid);
						self::$mail->removeMessage($messageId);
					}
				}
				self::$mail->removeFolder($leave_folder);
			}
		} catch (Zend\Mail\Exception\InvalidArgumentException $e) {}
	}
	
	function flagFolder($account,$folder,$flag) {
		global $adb, $table_prefix, $current_user;
		
		if ($flag == 'seen') {
			$field = 'seen';
			$value = 1;
		} elseif ($flag == 'unseen') {
			$field = 'seen';
			$value = 0;
		}
		
		$this->addToPropagationCron('flag_folder', array('userid'=>$current_user->id,'account'=>$account,'folder'=>$folder,'flag'=>$field,'value'=>$value));
		
		$adb->pquery("UPDATE {$this->table_name}
					INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
					SET $field = ?
					WHERE {$this->entity_table}.deleted = 0 AND {$this->table_name}.mtype = ? AND {$this->entity_table}.smownerid = ? AND {$this->table_name}.folder = ?",array($value,'Webmail',$current_user->id,$folder));
	}
	
	function propagateFlagFolder($userid,$account,$folder,$flag,$value) {
		$focus = CRMEntity::getInstance('Messages');

		$focus->setAccount($account);
		$focus->getZendMailStorageImap($userid);
		self::$mail->selectFolder($folder);

		$managed_flags = array(Zend\Mail\Storage::FLAG_SEEN,Zend\Mail\Storage::FLAG_ANSWERED,Zend\Mail\Storage::FLAG_FLAGGED,'$Forwarded','Forwarded');
		$server_flags = array();
		$server_flags_tmp = self::$protocol->fetch(array('UID','FLAGS'),1,INF);
		foreach ($server_flags_tmp as $i => $info) {
			$uid = array_shift($info);
			$oldflags = $flags = array_intersect($info['FLAGS'],$managed_flags);
			if ($flag == 'seen') {
				if ($value == 0) {
					unset($flags[array_search(Zend\Mail\Storage::FLAG_SEEN,$flags)]);
				} elseif ($value == 1 && !in_array(Zend\Mail\Storage::FLAG_SEEN,$flags)) {
					$flags[] = Zend\Mail\Storage::FLAG_SEEN;
				}
			}
			$server_flags[$uid] = $flags;
			try {
				self::$mail->setFlags($i, $flags);
			} catch (Zend\Mail\Storage\Exception\RuntimeException $e) {}
		}
	}
	
	function folderMove($account,$folder,$move_in) {
		$this->setAccount($account);
		$specialFolders = $this->getSpecialFolders();
		if (in_array($folder,$specialFolders)) {
			return false;
		}
		$this->getZendMailStorageImap();
		$folder_tree = explode($this->folderSeparator,$folder);
		$move_in .= $this->folderSeparator.$folder_tree[count($folder_tree)-1];	//crmv@47411
		try {
			self::$mail->renameFolder($folder,$move_in);
			return true;
		} catch (Exception $e) {
			/*
			try {
				// new folder already exixsts
				$folder = self::$mail->getFolders();
				foreach($folder_tree as $f) {
					$folder = $folder->__get($f);
				}
			} catch (Exception $e) {
				// old folder do not exists
			}
			*/
			return false;
		}
	}
	
	function folderCreate($account,$folder,$current_folder) {
		$this->setAccount($account);
		$this->getZendMailStorageImap();
		try {
			self::$mail->createFolder($folder,$current_folder,$this->folderSeparator);	//crmv@47411
		} catch (Exception $e) {
			return false;
		}
	}

	function getFoldersList($mode='list',$current_folder='',$move_mode='') {
		global $adb, $table_prefix, $current_user;
		
		$folders = array();
		$query = "select * from {$table_prefix}_messages_folders where userid = ? and accountid = ?";
		$params = array($current_user->id,$this->getAccount());
		if ($mode != 'list') {
			$query .= " and localname not in (?,?,?)";
			$params[] = 'Shared';
			$params[] = 'Links';
			$params[] = 'Flagged';
		}
		if ($move_mode != 'folders') {
			$query .= " and localname <> ?";
			$params[] = '/';
		}
		$query .= " order by sequence";
		$result = $adb->pquery($query,$params);
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$localName = $row['localname'];
				$globalName = $row['globalname'];
				switch ($localName) {
					case '/':
						$folders[htmlspecialchars($globalname)] = array(
							'label'=>'<span style="padding-right:10px;color:#464646">'.htmlspecialchars($localName).'</span>'.getTranslatedString('LBL_ROOT','Messages'),
							'selectable'=>true,
							'depth'=>0
						);
						break;
					case 'Shared':
					case 'Flagged':
					case 'Links':
						if ($row['count'] > 0) {
							$arr = array(
								'label'=>getTranslatedString('LBL_Folder_'.$localName,'Messages'),
								'selectable'=>$row['selectable'],
								'depth'=>$row['depth'],
								'count'=>$row['count']
							);
							if ($localName == 'Links') {
								$arr['img'] = 'modules/Messages/src/img/folder.png';
							} else {
								$arr['img'] = 'modules/Messages/src/img/folder_'.strtolower($localName).'.png';
							}
							$folders[$globalName] = $arr;
						}
						break;
					default:
						$specialFolders = $this->getSpecialFolders();
						$aliasSpecialFolder = array_search($globalName,$specialFolders);
						if (!empty($aliasSpecialFolder)) {
							$label = $aliasSpecialFolder;
						} else {
							$label = htmlspecialchars($localName);
						}
						$label_trans = getTranslatedString('LBL_Folder_'.$label,'Messages');
						if ($label_trans != 'LBL_Folder_'.$label) {
							$label = $label_trans;
						}
						if (!empty($aliasSpecialFolder)) {
							$img_str = strtolower($aliasSpecialFolder);
						} else {
							$img_str = strtolower($localName);
						}
						$img = 'modules/Messages/src/img/folder.png';	//default image
						if (file_exists('modules/Messages/src/img/folder_'.$img_str.'.png')) {
							$img = 'modules/Messages/src/img/folder_'.$img_str.'.png';
						}
						$arr = array(
							'label'=>$label,
							'img'=>$img,
							'selectable'=>$row['selectable'],
							'depth'=>$row['depth'],
							'count'=>$row['count'],
							'bg_notification_color'=>'#2c80c8'
						);
						if ($mode == 'move' && !empty($current_folder) && $globalName == $current_folder) {
							$arr['selectable'] = false;
						}
						$folders[$globalName] = $arr;
						break;
				}
			}
		/*
		} else {
			// force sync
			$this->syncFolders($current_user->id,$this->getAccount());
			$folders = $this->getFoldersList($mode,$current_folder,$move_mode);
		*/
		}
		return $folders;
	}
	
	function getStrUnreadMessageCount($folder='') {
		$string = '';
		$count = $this->getUnreadMessageCount($folder);
		if (intval($count) > 0) {
			$string = ' ('.$count.')';
		}
		return $string;
	}
	
	function getUnreadMessageCount($folder='') {
		if (empty($folder)) {
			global $current_folder;
			$folder = $current_folder;
		}
		$account = $this->getAccount();
		if (!empty($folder)) {
			global $adb, $table_prefix, $current_user;
			$query = "SELECT count(*) AS count FROM {$this->table_name}
					INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
					WHERE deleted = 0 AND smownerid = ? AND {$this->table_name}.seen = ? and {$this->table_name}.mtype = ?";
			$params = array($current_user->id,0,'Webmail');
			if ($account == 'all') {
				$folders = $this->getAllSpecialFolders('INBOX');
				$tmp = array();
				foreach($folders as $account => $folder) {
					$tmp[] = "({$this->table_name}.account = ? AND {$this->table_name}.folder = ?)";
					$params[] = array($account,$folder['INBOX']);
				}
				$query .= ' AND ('.implode(' OR ',$tmp).')';
			} else {
				$query .= " and account = ? and folder = ?";
				$params[] = array($account,$folder);
			}
			$result = $adb->pquery($query,$params);
			if ($result && $adb->num_rows($result) > 0) {
				return $adb->query_result($result,0,'count');
			}
		} else {
			return false;
		}
	}
	
	function getRelatedModComments($return_query=false,$userid='') {
		
		if (empty($userid)) {
			global $current_user;
			$user = $current_user;
		} else {
			$user = CRMEntity::getInstance('Users');
			$user->retrieveCurrentUserInfoFromFile($userid);
		}
		
		static $ids_msg_with_comments = array();
		static $ids_msg_with_comments_presence = array();
		if (empty($ids_msg_with_comments_presence[$user->id])) $ids_msg_with_comments_presence[$user->id] = false;
		if (!$return_query && $ids_msg_with_comments_presence[$user->id]) {
			return $ids_msg_with_comments[$user->id];
		}
		
		global $adb, $table_prefix;
		$query = "SELECT DISTINCT {$table_prefix}_modcomments.related_to AS \"id\" FROM {$table_prefix}_modcomments
				INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$table_prefix}_modcomments.modcommentsid
				INNER JOIN {$this->entity_table} relatedEntity ON relatedEntity.crmid = {$table_prefix}_modcomments.related_to
				INNER JOIN {$table_prefix}_messages ON {$table_prefix}_messages.messagesid = relatedEntity.crmid
				LEFT JOIN {$table_prefix}_modcomments_users ON {$table_prefix}_modcomments_users.id = {$table_prefix}_modcomments.modcommentsid
				WHERE {$this->entity_table}.deleted = 0 AND relatedEntity.deleted = 0 AND relatedEntity.setype = ?
				AND (";
		if ($user->column_fields['receive_public_talks'] == '1') {
			$query .= "(visibility_comm = ? AND {$this->entity_table}.smownerid <> ?) OR";
		}
		$query .= "(visibility_comm = ? AND COALESCE({$table_prefix}_modcomments_users.user,0) = ?))";
		$params = array('Messages','All',$user->id,'Users',$user->id);
		if ($return_query) {
			return $adb->convert2Sql($query,$adb->flatten_array($params));
		}
		$result = $adb->pquery($query,$params);
		$tmp = array();
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$tmp[] = $row['id'];
			}
		}
		
		$ids_msg_with_comments[$user->id] = $tmp;
		$ids_msg_with_comments_presence[$user->id] = true;
		
		return $tmp;
	}

	function magicHTML($body, $uid, $data='') {
		$squirrelmail = new Squirrelmail($this,true);
		$html = $squirrelmail->magicHTML($body, $uid, $data, $this->folder, false);	//TODO ultimo parametro per convertire i mailto:... in link interni
		$content_ids = $squirrelmail->getContentIds();
		return array('html'=>$html,'content_ids'=>$content_ids);
	}
	
	function getRecipientEmails($field='') {
		if (empty($field)) {
			$fields = array('mto','mcc','mbcc');
		} else {
			$fields = array($field);
		}
		$recipients = array();
		foreach ($fields as $field) {
			$email = $this->column_fields[$field];
			$full = $this->column_fields[$field.'_f'];
			if (substr_count($full,',') > substr_count($email,',')) {
				$email = trim($full);
			}
			if (strpos($email,',') !== false) {
				$emails = explode(',',$email);
			} else {
				$emails = array($email);
			}
			if (!empty($emails)) {
				foreach($emails as $email) {
					$recipients[$field][] = $this->cleanEmail($email);
				}
			}	
		}
		return $recipients;
	}

	function getAddressName($email,$name,$full,$textlength_check=false) {
		global $default_charset;
		$name = html_entity_decode($name, ENT_QUOTES, $default_charset);
		$name = trim(trim($name),'"');
		if (empty($name)) {
			$name = trim($email);
		}
		if (substr_count($full,',') > substr_count($email,',')) {
			$name = trim($full);
		}
		if ($textlength_check) {
			global $listview_max_textlength;
			$listview_max_textlength_tmp = $listview_max_textlength;
			$listview_max_textlength = 30;
			$name = textlength_check($name);
			$listview_max_textlength = $listview_max_textlength_tmp;
		}
		return $name;
	}

	function getAddressImage($mode,$email,$business_card) {
		if (strpos($email,', ') !== false) {
			$avatar = 'modules/Messages/src/img/avatar_multiple.png';
			$img = "<img src='$avatar' border='0'>";
			return $img;
		}
		$module = $business_card['module'];
		$id = $business_card['id'];
		$name = $business_card['name'];
		$type = getSingleModuleName($module);
		switch ($module) {
			case 'Users':
				$avatar = getUserAvatar($id);
				$img = "<img title='$type' alt='$name' src='$avatar' border='0'>";
				break;
			case 'Contacts':
				$avatar = 'modules/Messages/src/img/avatar_contact.png';
				$img = "<img title='$type' alt='$name' src='$avatar' border='0'>";
				break;
			case 'Accounts':
				$avatar = 'modules/Messages/src/img/avatar_account.png';
				$img = "<img title='$type' alt='$name' src='$avatar' border='0'>";
				break;
			case 'Leads':
				$avatar = 'modules/Messages/src/img/avatar_lead.png';
				$img = "<img title='$type' alt='$name' src='$avatar' border='0'>";
				break;
			case 'Vendors':
				$avatar = 'modules/Messages/src/img/avatar_vendor.png';
				$img = "<img title='$type' alt='$name' src='$avatar' border='0'>";
				break;
			default:
				$avatar = 'modules/Messages/src/img/avatar_new.png';
				if ($mode == 'addsender') {
					$title = getTranslatedString('Add sender','Messages');
				} elseif ($mode == 'addrecipient') {
					$title = getTranslatedString('Add recipient','Messages');
				}
				$img = "<a href='javascript:;' onClick='openMessagesPopup(\"{$this->id}\",\"{$mode}\");'><img title='$title' alt='$title' src='$avatar' border='0'></a>";
				break;
		}
		return $img;
	}

	function saveCache($ids) {
		
		if (empty($ids)) return;
		
		global $adb, $table_prefix;
		global $current_user, $default_charset;

		$filtered = array();	// apply filters
		$crmid = array();
		foreach ($ids as $messageId => $uid) {
			/*
			$uid = self::$mail->getUniqueId($messageId);
			$uid = 17130;
			$messageId = self::$mail->getNumberByUniqueId($uid);
			*/
			try {
				$message = self::$mail->getMessage($messageId);
			} catch (Zend\Mail\Exception\RuntimeException $e) {
				// ignore parse errors and continue
				//echo "$messageId($uid),";
				continue;
			}
			/*
			if ($uid == 5545) {
				echo '<pre>';
				print_r($message);
				echo '</pre>';
				die;
			}
			*/
			$data = $this->getMessageContentParts($message,$messageId);
			if (empty($data)) {
				//echo "$messageId($uid),";
				continue;
			}
			
			// check if exists
			$existingCrmid = 0;
			$res = $adb->pquery("select messagesid, xuid from {$this->table_name} inner join {$this->entity_table} on {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index} where {$this->entity_table}.deleted = 0 and mtype = ? and messageid = ? and smownerid = ? and account = ? and folder = ?", array('Webmail',$data['header']['Messageid'],$current_user->id,$this->account,$this->folder));
			if ($res && $adb->num_rows($res) > 0) {
				$existingCrmid = $adb->query_result_no_html($res, 0, 'messagesid');
				$existingUid = $adb->query_result_no_html($res, 0, 'xuid');
				// if lower uid, skip
				if ($existingUid > $uid) {
					continue;
				}
			}
			
			$date = date('Y-m-d H:i:s',strtotime($data['header']['Date']));
			
			$body = '';
			if (isset($data['text/html'])) {
				$body = $data['text/html'];
				$body = str_replace('&lt;','&amp;lt;',$body);
				$body = str_replace('&gt;','&amp;gt;',$body);
			} elseif (isset($data['text/plain'])) {
				$body = nl2br(htmlentities($data['text/plain'], ENT_COMPAT, $default_charset));
			}
			
			$focus = CRMentity::getInstance('Messages');
			$focus->column_fields = array(
				'subject'=>$data['header']['Subject'],
				'description'=>$body,
				'mdate'=>$date,

				'mfrom'=>$data['header']['From']['email'],
				'mfrom_n'=>$data['header']['From']['name'],
				'mfrom_f'=>$data['header']['From']['full'],

				'mto'=>$data['header']['To']['email'],
				'mto_n'=>$data['header']['To']['name'],
				'mto_f'=>$data['header']['To']['full'],

				'mcc'=>$data['header']['Cc']['email'],
				'mcc_n'=>$data['header']['Cc']['name'],
				'mcc_f'=>$data['header']['Cc']['full'],

				'mbcc'=>$data['header']['Bcc']['email'],
				'mbcc_n'=>$data['header']['Bcc']['name'],
				'mbcc_f'=>$data['header']['Bcc']['full'],

				'mreplyto'=>$data['header']['ReplyTo']['email'],
				'mreplyto_n'=>$data['header']['ReplyTo']['name'],
				'mreplyto_f'=>$data['header']['ReplyTo']['full'],

				'messageid'=>$data['header']['Messageid'],
				'in_reply_to'=>$data['header']['In-Reply-To'],
				'mreferences'=>$data['header']['References'],
				'thread_index'=>$data['header']['Thread-Index'],
				'xmailer'=>$data['header']['Xmailer'],
				'xuid'=>$uid,
				'account'=>$this->account,
				'folder'=>self::$mail->getCurrentFolder(),
				'seen'=>$data['flags']['seen'],
				'answered'=>$data['flags']['answered'],
				'flagged'=>$data['flags']['flagged'],
				'forwarded'=>$data['flags']['forwarded'],
			
				'assigned_user_id'=>$current_user->id,
				'mtype'=>'Webmail',
			
				'other'=>$data['other'],
			);
			
			// apply filters
			$filtered_status = $focus->applyFilters($messageId,$filtered);
			if ($filtered_status) {
				continue;
			}
			
			try {	//crmv@44482
				if ($existingCrmid > 0) {
					$focus->id = $existingCrmid;
					$focus->mode = 'edit';
					$focus->save('Messages', $existingCrmid);
				} else {
					$focus->save('Messages');
				}
				$crmid[] = $focus->id;
			} catch (Exception $e) {
				//ERR_SAVING_IN_DB
			}
		}
		$this->setSavedMessages($crmid);
		$this->fetchFiltered($filtered);	// apply filters
	}
	
	function setSavedMessages($crmid) {
		$this->saved_messages = $crmid;
	}
	
	function getSavedMessages() {
		return $this->saved_messages;
	}
	
	function saveModComment($crmid,$messageid) {
		global $current_user;
		$focus = CRMEntity::getInstance('Messages');
		$focus->retrieve_entity_info_no_html($crmid,'Messages');
		if ($messageid == $focus->column_fields['messageid']) {
			if (isPermitted('ModComments', 'EditView', '') == 'yes') {
				$modObj = CRMEntity::getInstance('ModComments');
				$modObj->column_fields['commentcontent'] = vtlib_purify(strip_tags($_REQUEST['comment']));
				$modObj->column_fields['related_to'] = $crmid;
				$modObj->column_fields['visibility_comm'] = vtlib_purify($_REQUEST['ModCommentsMethod']);
				$modObj->column_fields['users_comm'] = vtlib_purify($_REQUEST['users_comm']);
				$modObj->column_fields['assigned_user_id'] = $current_user->id;
				$modObj->save('ModComments');
			}
		}
	}
	
	function saveCacheLink($column_fields) {
		global $current_user;
		require_once('modules/Emails/class.phpmailer.php');
		$mailer = new PHPMailer();
		$uniq_id = md5(uniqid(time()));
		$messageid = sprintf('<%s@%s>', $uniq_id, $mailer->ServerHostname()); // in this way, we won't duplicate messages
		
		$xuid = '';
		$mfrom = (!empty($column_fields['mfrom']) ? $column_fields['mfrom'] : '');
		$mto = (!empty($column_fields['mto']) ? $column_fields['mto'] : '');
		$mcc = (!empty($column_fields['mcc']) ? $column_fields['mcc'] : '');
		$mbcc = (!empty($column_fields['mbcc']) ? $column_fields['mbcc'] : '');
		$mreplyto = (!empty($column_fields['mreplyto']) ? $column_fields['mreplyto'] : '');
		
		if ($column_fields['mtype'] != 'Link'){
			$account = '';
			if ($column_fields['account'] !== '') {
				$account = $column_fields['account'];
			} elseif (!empty($mfrom)) {
				$focusEmails = CRMentity::getInstance('Emails');
				$account = $focusEmails->getFromEmailAccount($mfrom);
			}
			if ($account === '') {
				$main_account = $this->getMainUserAccount();
				$account = $main_account['id'];
			}
			$this->setAccount($account);
			$specialFolders = $this->getSpecialFolders($column_fields);
		}
		else{
			$specialFolders = Array('INBOX'=>'','Sent'=>'','Drafts'=>'','Trash'=>'');
		}
		
		$focus = CRMentity::getInstance('Messages');
		$focus->column_fields = array(
			'subject'=>(!empty($column_fields['subject']) ? $column_fields['subject'] : ''),
			'description'=>(!empty($column_fields['description']) ? $column_fields['description'] : ''),
			'mdate'=>(!empty($column_fields['mdate']) ? $column_fields['mdate'] : date('Y-m-d H:i:s')),
			'mfrom'=>$mfrom,
			'mfrom_n'=>(!empty($column_fields['mfrom_n']) ? $column_fields['mfrom_n'] : ''),
			'mfrom_f'=>(!empty($column_fields['mfrom_f']) ? $column_fields['mfrom_f'] : $mfrom),
			'mto'=>$mto,
			'mto_n'=>(!empty($column_fields['mto_n']) ? $column_fields['mto_n'] : ''),
			'mto_f'=>(!empty($column_fields['mto_f']) ? $column_fields['mto_f'] : $mto),
			'mcc'=>$mcc,
			'mcc_n'=>(!empty($column_fields['mcc_n']) ? $column_fields['mcc_n'] : ''),
			'mcc_f'=>(!empty($column_fields['mcc_f']) ? $column_fields['mcc_f'] : $mcc),
			'mbcc'=>$mbcc,
			'mbcc_n'=>(!empty($column_fields['mbcc_n']) ? $column_fields['mbcc_n'] : ''),
			'mbcc_f'=>(!empty($column_fields['mbcc_f']) ? $column_fields['mbcc_f'] : $mbcc),
			'mreplyto'=>$mreplyto,
			'mreplyto_n'=>(!empty($column_fields['mreplyto_n']) ? $column_fields['mreplyto_n'] : ''),
			'mreplyto_f'=>$mreplyto,
			'in_reply_to'=>(!empty($column_fields['in_reply_to']) ? $column_fields['in_reply_to'] : ''),
			'mreferences'=>(!empty($column_fields['mreferences']) ? $column_fields['mreferences'] : ''),
			'thread_index'=>(!empty($column_fields['thread_index']) ? $column_fields['thread_index'] : ''),
			'xmailer'=>(!empty($column_fields['xmailer']) ? $column_fields['xmailer'] : 'VTECRM-WEBMAIL'),
			'xuid'=>(!empty($column_fields['xuid']) ? $column_fields['xuid'] : $xuid),
			'messageid'=>$messageid,
			'seen'=>(!empty($column_fields['seen']) ? $column_fields['seen'] : '1'),
			'answered'=>(!empty($column_fields['answered']) ? $column_fields['answered'] : '0'),
			'flagged'=>(!empty($column_fields['flagged']) ? $column_fields['flagged'] : '0'),
			'forwarded'=>(!empty($column_fields['forwarded']) ? $column_fields['forwarded'] : '0'),
			'folder'=>(!empty($column_fields['folder']) ? $column_fields['folder'] : $specialFolders['Sent']),
			'assigned_user_id'=>(!empty($column_fields['assigned_user_id']) ? $column_fields['assigned_user_id'] : $current_user->id),
			'mtype'=>(!empty($column_fields['mtype']) ? $column_fields['mtype'] : 'Link'),
			'mvisibility'=>(!empty($column_fields['mvisibility']) ? $column_fields['mvisibility'] : ''),
			'send_mode'=>(!empty($column_fields['send_mode']) ? $column_fields['send_mode'] : ''),
			'other'=>(!empty($column_fields['other']) ? $column_fields['other'] : ''),
			'parent_id'=>(!empty($column_fields['parent_id']) ? $column_fields['parent_id'] : ''),
			'recipients'=>(!empty($column_fields['recipients']) ? $column_fields['recipients'] : ''),
			'account'=>$account,
		);
		$focus->save('Messages');
		return $focus->id;
	}

	function deleteCache($ids) {
		if (empty($ids)) return;
		foreach ($ids as $crmid => $uid) {
			if ($this->haveRelations($crmid,'','-')) {
				global $adb, $table_prefix;
				$adb->pquery("update {$this->table_name} set mtype = ? where {$this->table_index} = ?",array('Link',$crmid));
				$this->beforeTrashFunctions($crmid);
			} else {
				parent::trash('Messages', $crmid);
			}
		}
		$this->cleanDraftCache(array_keys($ids));
	}
	
	function trash($module, $id) {	// move to Trash
		if (empty($this->column_fields['folder']) || empty($this->column_fields['xuid']) || empty($this->column_fields['account'])) {
			$this->retrieve_entity_info($id,$module);
		}
		if ($this->column_fields['mtype'] == 'Webmail') {
			$this->cleanDraftCache($id);
			$specialFolders = $this->getSpecialFolders();
			if ($this->column_fields['folder'] == $specialFolders['Trash'] && $this->haveRelations($id,'','-')) {
				global $adb, $table_prefix;
				$adb->pquery("update {$this->table_name} set mtype = ? where {$this->table_index} = ?",array('Link',$id));
				$this->beforeTrashFunctions($id);
				
				$this->addToPropagationCron('trash', array(
					'userid'=>$this->column_fields['assigned_user_id'],
					'account'=>$this->column_fields['account'],
					'folder'=>$this->column_fields['folder'],
					'uid'=>$this->column_fields['xuid'],
					'fetch'=>false
				));
			} else {
				parent::trash($module, $id);
				$this->addToPropagationCron('trash', array(
					'userid'=>$this->column_fields['assigned_user_id'],
					'account'=>$this->column_fields['account'],
					'folder'=>$this->column_fields['folder'],
					'uid'=>$this->column_fields['xuid'],
					'fetch'=>true
				));
			}
		} else {
			parent::trash($module, $id);
		}
	}

	function propagateTrash($userid,$account,$folder,$uid,$fetch=false) {
		$focus = CRMEntity::getInstance('Messages');

		$focus->setAccount($account);
		$focus->getZendMailStorageImap($userid);
		$focus->selectFolder($folder);
		$messageId = self::$mail->getNumberByUniqueId($uid);
		
		$specialFolders = $focus->getSpecialFolders();
		if ($folder == $specialFolders['Trash']) {
			self::$mail->removeMessage($messageId);
		} else {
			self::$mail->moveMessage($messageId,$specialFolders['Trash']);
		}
		
		//fetch new messages from Trash folder
		if ($fetch) {
			global $current_user;
			$tmp = $current_user->id;
			$current_user->id = $userid;
			
			$focus->fetchNews($specialFolders['Trash']);
			
			$current_user->id = $tmp;
		}
	}
	
	function emptyCache($user='') {
		global $adb, $table_prefix, $current_user;
		
		$query = "SELECT DISTINCT messagesid as \"id\"
					FROM {$table_prefix}_messagesrel
					 INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$table_prefix}_messagesrel.crmid
					 INNER JOIN {$this->table_name} ON {$this->table_name}.messagehash = {$table_prefix}_messagesrel.messagehash
					 INNER JOIN {$this->entity_table} crmentityMessage ON crmentityMessage.crmid = {$this->table_name}.messagesid
					WHERE {$this->entity_table}.deleted = 0 AND crmentityMessage.deleted = 0";
		if (!empty($user)) {
			$query .= " AND crmentityMessage.smownerid = ?";
			$params[] = $user;
		}
		$tableName = 'vt_tmp_ef_'.$current_user->id;
		if ($adb->isMysql()) {
			$query = "create table IF NOT EXISTS $tableName(id int(11) primary key) ignore ".$query;
			$result = $adb->pquery($query,$params);
		} else {
			if (!$adb->table_exist($tableName,true)){
				Vtiger_Utils::CreateTable($tableName,"id I(11) NOTNULL PRIMARY",true);
			}
			$tableName = $adb->datadict->changeTableName($tableName);
			$query = "insert into $tableName $query where not exists (select * from $tableName where $tableName.id = un_table.id)";
			$result = $adb->pquery($query,$params);
		}

		$adb->pquery("UPDATE {$this->table_name} SET mtype = ? WHERE messagesid IN (SELECT id FROM $tableName)",array('Link'));

		$query = "UPDATE {$this->entity_table} SET deleted = ? WHERE setype = ?";
		$params = array(1,'Messages');
		if (!empty($user)) {
			$query .= " AND smownerid = ?";
			$params[] = $user;
		}
		$query .= " AND crmid NOT IN (SELECT id FROM $tableName)";
		$adb->pquery($query,$params);

		//TODO: vte_messages_drafts, vte_messages_th, vte_messages_attach
		
		$adb->query("DROP TABLE $tableName");
	}
	
	function cleanDraftCache($ids) {
		global $adb, $table_prefix, $current_user;
		if (!is_array($ids)) {
			$ids = array($ids);
		}
		$draftids = array();
		$result = $adb->pquery("SELECT messagehash FROM {$table_prefix}_messages
								WHERE {$table_prefix}_messages.messagesid IN (".generateQuestionMarks($ids).")",$ids);
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$draftids[] = $row['messagehash'];
			}
			$adb->pquery("DELETE FROM {$table_prefix}_messages_drafts WHERE userid = ? AND messagehash IN (".generateQuestionMarks($draftids).")",array($current_user->id,$draftids));
		}
	}

	function markAsViewed($userid,$skip_update_flag='no') {
		parent::markAsViewed($userid);
		if ($skip_update_flag != 'yes') {
			$this->setFlag('seen',1);
		}
	}
	
	//crmv@44179
	function massSetFlag($flag,$value,$ids) {
		global $adb, $current_user, $current_account, $current_folder;
		if (!empty($ids) && is_array($ids)) {
			foreach ($ids as $id) {
				$this->addToPropagationCron('flag', array('id'=>$id,'flag'=>$flag,'value'=>$value));
			}
			if (!empty($ids)) {
				$adb->pquery("update {$this->table_name} set {$flag} = ? where messagesid in (".implode(',',$ids).") and {$flag} <> ?",array($value,$value));
			}
			if ($flag == 'seen') {
				$this->reloadCacheFolderCount($current_user->id,$current_account,$current_folder);
			} elseif ($flag == 'flagged') {
				$this->reloadCacheFolderCount($current_user->id,$current_account,'Flagged');
			}
		}
	}

	function setFlag($flag,$value) {
		global $adb, $current_user;
		$status = false;
		if ($this->column_fields[$flag] != $value																					// if flag change
			&& !empty($this->column_fields['assigned_user_id']) && $current_user->id == $this->column_fields['assigned_user_id']) {	// if message is assigned to me (not in folder Shared)
			$this->addToPropagationCron('flag', array('id'=>$this->id,'flag'=>$flag,'value'=>$value));
			$adb->pquery("update {$this->table_name} set {$flag} = ? where messagesid = ?",array($value,$this->id));
			$this->column_fields[$flag] = $value;
			if ($flag == 'seen') {
				$this->reloadCacheFolderCount($this->column_fields['assigned_user_id'],$this->column_fields['account'],$this->column_fields['folder']);				
			} elseif ($flag == 'flagged') {
				$this->reloadCacheFolderCount($this->column_fields['assigned_user_id'],$this->column_fields['account'],'Flagged');				
			}
			$status = true;
		}
		return $status;
	}
	//crmv@44179e

	function propagateSetFlag($messagesid,$flag,$value) {
		global $adb, $table_prefix;
		
		$focus = CRMEntity::getInstance('Messages');
		$error = $focus->retrieve_entity_info($messagesid,'Messages',false);
		if (!empty($error)) {
			throw new Exception($error);
		}
		$focus->id = $messagesid;
		
		$focus->resetMailResource();
		$focus->getZendMailStorageImap($focus->column_fields['assigned_user_id']);
		$focus->selectFolder($focus->column_fields['folder']);
		$messageId = self::$mail->getNumberByUniqueId($focus->column_fields['xuid']);

		//Get current flags with server call
		$message = self::$mail->getMessage($messageId);
		$current_flags = $flags = $message->getFlags();
		//Get current flags using cached flags
		//$current_flags = $flags = $focus->getCacheFlags();	//need $focus->id

		switch ($flag) {
			case 'seen':
				if ($value == '1') {
					$flags = array_merge($flags,array(Zend\Mail\Storage::FLAG_SEEN));
				} elseif ($value == '0') {
					unset($flags[Zend\Mail\Storage::FLAG_SEEN]);
				}
				break;
			case 'flagged':
				if ($value == '1') {
					$flags = array_merge($flags,array(Zend\Mail\Storage::FLAG_FLAGGED));
				} elseif ($value == '0') {
					unset($flags[Zend\Mail\Storage::FLAG_FLAGGED]);
				}
				break;
			case 'answered':
				if ($value == '1') {
					$flags = array_merge($flags,array(Zend\Mail\Storage::FLAG_ANSWERED));
				}
				break;
			case 'forwarded':
				if ($value == '1') {
					$flags = array_merge($flags,array('$Forwarded','Forwarded'));
				}
				break;
		}
		if ($current_flags != $flags) {
			try {
				self::$mail->setFlags($messageId, $flags);
				return true;
			} catch (Zend\Mail\Storage\Exception\RuntimeException $e) {
				throw new Exception($e->getMessage());
			}
		}
	}
	
	function getPreviewBody($rawValue) {
		global $default_charset, $listview_max_textlength, $current_user;
		$listview_max_textlength_tmp = $listview_max_textlength;
		$listview_max_textlength = 120;
		
		$temp_val = preg_replace("/(<\/?)(\w+)([^>]*>)/i","",$rawValue);
		$temp_val = str_replace('&nbsp;',' ',$temp_val);
		$temp_val = html_entity_decode($temp_val, ENT_QUOTES, $default_charset);
		
		$search = array(
			'@<title[^>]*?>.*?</title>@si',		// Strip out title tag
			'@<script[^>]*?>.*?</script>@si',	// Strip out javascript
			'@<style[^>]*?>.*?</style>@siU',	// Strip style tags properly
		); 
		$temp_val = preg_replace($search, "\n", $temp_val);
		
		$temp_val = preg_replace('/\s+/',' ',strip_tags($temp_val));
		$value = textlength_check($temp_val);
		$listview_max_textlength = $listview_max_textlength_tmp;

		return $value;
	}

	function getEntityPreview($id) {
		global $adb, $table_prefix;
		$module = getSalesEntityType($id);
		$name = array_values(getEntityName($module,$id));
		$name = $name[0];
		$preview = array(
			'id'=>$id,
			'module'=>$module,
			'name'=>$name,
		);
		$details = array();
		$focus = CRMEntity::getInstance($module);
		if(!isRecordExists($id)) return '';
		$focus->id = $id;
		if ($focus->retrieve_entity_info($id,$module, false)) return ''; // crmv@38592
		$qcreate_array = QuickCreate($module);
		$query = "select fieldname from {$table_prefix}_entityname where modulename = ?";
		$result = $adb->pquery($query, array($module));
		if ($result && $adb->num_rows($result) > 0) {
			if(strpos($adb->query_result($result,0,'fieldname'),',') !== false) {
				$fieldlists = explode(',',$adb->query_result($result,0,'fieldname'));
			} else {
				$fieldlists = array($adb->query_result($result,0,'fieldname'));
			}
			foreach($fieldlists as $field) {
				unset($qcreate_array['data'][$field]);
			}
		}
		$fieldnames = array_keys($qcreate_array['data']);
		if (!empty($fieldnames)) {
			$result = $adb->pquery('select * from '.$table_prefix.'_field where tabid = ? and fieldname in ('.generateQuestionMarks($fieldnames).') order by quickcreatesequence',array(getTabid($module),$fieldnames));
			if ($result && $adb->num_rows($result) > 0) {
				while($row=$adb->fetchByAssoc($result)) {
					$info = getDetailViewOutputHtml($row['uitype'],$row['fieldname'],$row['fieldlabel'],$focus->column_fields,$row['generatedtype'],$row['tabid'],$module);
					if ($info[1] != '') {
						if ($row['uitype'] == 19) {	//TODO: controllo pi accurato
							$details[$row['fieldname']] = array('label'=>$info[0],'value'=>$info[1]);
						} else {
							$details[$row['fieldname']] = array('label'=>$info[0],'value'=>strip_tags($info[1]));
						}
					}
				}
			}
		}
		$preview['details'] = $details;
		return $preview;
	}
	
	function cleanEmail($email) {
		if (strpos($email,'<') !== false) {
			$email = substr($email,strpos($email,'<')+1);
		}
		if (strpos($email,'>') !== false) {
			$email = substr($email,0,strpos($email,'>'));
		}
		return trim($email);
	}

	function getBusinessCard($type) {
		if ($type == 'TO') {
			$email = $this->column_fields['mto'];
			$full = $this->column_fields['mto_f'];
		} elseif ($type == 'FROM') {
			$email = $this->column_fields['mfrom'];
			$full = $this->column_fields['mfrom_f'];
		}
		if (substr_count($full,',') > substr_count($email,',')) {
			$email = trim($full);
		}
		if (strpos($email,',') !== false) {
			$emails = explode(',',$email);
		} else {
			$emails = array($email);
		}
		$entitiesInfo = array();
		if (!empty($emails)) {
			foreach($emails as $email) {
				$email = $this->cleanEmail($email);
				$entityid = '';
				$entity = $this->getEntitiesFromEmail($email,false,false,array('Users','Contacts','Accounts','Leads','Vendors'),true);
				if (!empty($entity)) {
					$entityid = $entity['crmid'];
					$entitytype = $entity['module'];
				}
				$entityInfo = array();
				if (!empty($entityid)) {
					$entityFocus = CRMEntity::getInstance($entitytype);
					$entityFocus->id = $entityid;
					$entityFocus->retrieve_entity_info($entityid,$entitytype);
					$entityName = array_values(getEntityName($entitytype,$entityid));
					$entityName = $entityName[0];
					if ($entitytype == 'Users') {
						$entityInfo = array(
							'module'=>$entitytype,
							'id'=>$entityid,
							'name'=>getUserFullName($entityid),
							'title'=>implode(' - ',array_filter(array($entityFocus->column_fields['title'],$entityFocus->column_fields['department']))),
							'phone'=>implode(' - ',array_filter(array(
								'phone_mobile'=>$entityFocus->column_fields['phone_mobile'],
								'phone_work'=>$entityFocus->column_fields['phone_work'],
								'phone_home'=>$entityFocus->column_fields['phone_home'],
								'phone_other'=>$entityFocus->column_fields['phone_other'],
							))),
						);
					} elseif ($entitytype == 'Contacts') {
						$accName = '';
						if (!empty($entityFocus->column_fields['account_id'])) {
							$accName = array_values(getEntityName('Accounts',$entityFocus->column_fields['account_id']));
							$accName = $accName[0];
						}
						if ($entityFocus->column_fields['salutationtype'] != '--None--') {
							$salutationtype = getTranslatedString($entityFocus->column_fields['salutationtype'],$entitytype);
						}
						$entityInfo = array(
							'module'=>$entitytype,
							'id'=>$entityid,
							'name'=>implode(' ',array_filter(array($salutationtype,$entityName))),
							'accountid'=>$entityFocus->column_fields['account_id'],
							'accountname'=>$accName,
						);
						$phone = array(
							'phone_mobile'=>array('label'=>getTranslatedString('Mobile',$entitytype),'value'=>$entityFocus->column_fields['phone_mobile']),
							'phone_work'=>array('label'=>getTranslatedString('Office Phone',$entitytype),'value'=>$entityFocus->column_fields['phone_work']),
							'phone_home'=>array('label'=>getTranslatedString('Home Phone',$entitytype),'value'=>$entityFocus->column_fields['phone_home']),
							'phone_other'=>array('label'=>getTranslatedString('Other Phone',$entitytype),'value'=>$entityFocus->column_fields['phone_other']),
						);
					} elseif ($entitytype == 'Accounts') {
						$entityInfo = array(
							'module'=>$entitytype,
							'id'=>$entityid,
							'name'=>$entityName,
							'bill_city'=>$entityFocus->column_fields['bill_city'],
						);
						$phone = array(
							'phone'=>array('label'=>getTranslatedString('Phone',$entitytype),'value'=>$entityFocus->column_fields['phone']),
							'otherphone'=>array('label'=>getTranslatedString('Other Phone',$entitytype),'value'=>$entityFocus->column_fields['otherphone']),
						);						
					} elseif ($entitytype == 'Leads') {
						$entityInfo = array(
							'module'=>$entitytype,
							'id'=>$entityid,
							'name'=>$entityName,
							'company'=>$entityFocus->column_fields['company'],
							'leadsource'=>$entityFocus->column_fields['leadsource'],
						);
						$phone = array(
							'mobile'=>array('label'=>getTranslatedString('Mobile',$entitytype),'value'=>$entityFocus->column_fields['mobile']),
							'phone'=>array('label'=>getTranslatedString('Office Phone',$entitytype),'value'=>$entityFocus->column_fields['phone']),
							'homephone'=>array('label'=>getTranslatedString('Home Phone',$entitytype),'value'=>$entityFocus->column_fields['homephone']),
							'otherphone'=>array('label'=>getTranslatedString('Other Phone',$entitytype),'value'=>$entityFocus->column_fields['otherphone']),
						);						
					} elseif ($entitytype == 'Vendors') {
						$entityInfo = array(
							'module'=>$entitytype,
							'id'=>$entityid,
							'name'=>$entityName,
							'website'=>$entityFocus->column_fields['website'],
						);
						$phone = array(
							'phone'=>array('label'=>getTranslatedString('Phone',$entitytype),'value'=>$entityFocus->column_fields['phone']),
						);						
					}
					$entityInfo['phone'] = $phone;
					$entityInfo['module_permitted'] = (isPermitted($entitytype, 'DetailView', $entityid) == 'yes');
				}
				$entityInfo['email'] = $email;
				$entitiesInfo[] = $entityInfo;
			}
		}
		return $entitiesInfo;
	}
	
	function getFriendlyDate($date) {
		
		$date = strtotime($date);
		
		//calculating diff (today - date) in days
		$diff = (strtotime(date('Y-m-d')) - strtotime(date('Y-m-d',$date))) / 3600 / 24;
		
		$friendlydate = '';
		if ($diff == 0) {
			$friendlydate = date('H:i',$date);
		} elseif($diff == 1) {
			$friendlydate = getTranslatedString('Yesterday','CustomView').' '.date('H:i',$date);
		} elseif($diff <= 6) {
			$friendlydate = getTranslatedString('LBL_DAY'.date('w', $date), 'Calendar')." ".date('H:i',$date);
		} else {
			$friendlydate = getDisplayDate(date('Y-m-d H:i',$date));
		}
		
		return $friendlydate;
	}
	
	function getFullDate($date) {
		return getTranslatedString('LBL_DAY'.date('w',strtotime($date)),'Calendar').' '.getDisplayDate($date);
	}
	
	function getLuckyMessage($account,$folder,$record='') {
		global $adb, $table_prefix, $current_user;
		$id = '';
		$query = "SELECT {$this->table_name}.messagesid FROM {$this->table_name}
				INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.messagesid
				WHERE deleted = 0 AND smownerid = ? AND folder = ? AND seen = ?";
		$params = array($current_user->id,$folder,1);
		if ($account == 'all') {
			$folders = $this->getAllSpecialFolders($folder);
			$tmp = array();
			foreach($folders as $account => $folder) {
				$tmp[] = "({$this->table_name}.account = ? AND {$this->table_name}.folder = ?)";
				$params[] = array($account,$folder['INBOX']);
			}
			$query .= ' AND ('.implode(' OR ',$tmp).')';
		} else {
			$query .= " AND account = ?";
			$params[] = $account;
		}
		if (!empty($record)) {
			if (!is_array($record)) {
				$record = array($record);
			}
			$result = $adb->pquery("SELECT messagesid, mdate FROM {$table_prefix}_messages WHERE messagesid IN (".generateQuestionMarks($record).")",$record);
			if ($result && $adb->num_rows($result) > 0) {
				while($row=$adb->fetchByAssoc($result)) {
					if (!empty($row['mdate'])) {
						$query .= "	AND (messagesid <> ? AND mdate <= ?)";
						$params[] = $row['messagesid'];
						$params[] = $row['mdate'];
					}
				}
			}
		}
		$query .= "	ORDER BY mdate DESC";
		$result = $adb->limitPquery($query,0,1,$params);
		if ($result && $adb->num_rows($result) > 0) {
			$id = $adb->query_result($result,0,'messagesid');
		}
		return $id;
	}
	
	function haveAttachments($id) {
		global $adb,$table_prefix;
		$result = $adb->pquery("select * from {$this->table_name}_attach where {$this->table_index} = ?
								and (
										(contentdisposition is not null and contentdisposition <> ?)
										or contenttype in (".generateQuestionMarks($this->other_contenttypes_attachment).")
									)
								",array($id,'inline',$this->other_contenttypes_attachment));
		if ($result && $adb->num_rows($result) > 0) {
			return true;
		}
		return false;
	}
	
	function getAttachments() {
		global $adb,$table_prefix;
		$attachments = array();
		$result = $adb->pquery("select * from {$this->table_name}_attach where {$this->table_index} = ?
								and (
										(contentdisposition is not null and contentdisposition <> ?)
										or contenttype in (".generateQuestionMarks($this->other_contenttypes_attachment).")
									)
								",array($this->id,'inline',$this->other_contenttypes_attachment));
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$target = '';
				if (stripos($row['contenttype'],'image') !== false) {
					$target = '_blank';
				}
				$document = '';
				if (!empty($row['document'])) {
					$result1 = $adb->pquery("SELECT crmid FROM {$this->entity_table} WHERE crmid = ? AND deleted = 0",array($row['document']));
					if ($result1 && $adb->num_rows($result1) > 0) {
						$document = $row['document'];
					}
				}
				if ($row['contentid'] < 0) {
					$attachmentid = $adb->query_result($adb->pquery("select * from ".$table_prefix."_seattachmentsrel where crmid = ?", array($document)),0,'attachmentsid');
					$link = "index.php?module=uploads&action=downloadfile&fileid=$attachmentid&entityid=$document";
				} else {
					$link = "index.php?module=Messages&action=MessagesAjax&file=Download&record={$this->id}&contentid={$row['contentid']}";
				}
				$action_download = true;
				$action_save = true;
				$action_link = true;
				$attachments[] = array(
					'action_download'=>$action_download,
					'action_save'=>$action_save,
					'action_link'=>$action_link,
					'contentid'=>$row['contentid'],
					'name'=>$row['contentname'],
					'link'=>$link,
					'img'=>'modules/Messages/src/img/attach.gif',
					'target'=>$target,
					'document'=>$document,
				);
			}
		}
		return $attachments;
	}
	
	function getAttachmentsInfo() {
		global $adb,$table_prefix;
		$attachments = array();
		$result = $adb->pquery("select * from {$this->table_name}_attach where {$this->table_index} = ?",array($this->id));
		if ($result && $adb->num_rows($result) > 0) {
			while($row=$adb->fetchByAssoc($result)) {
				$attachments[$row['contentid']]['parameters'] = array(
					'content_id'=>$row['content_id'],
					'name'=>$row['contentname'],
					'contenttype'=>$row['contenttype'],
					'contentdisposition'=>$row['contentdisposition'],
					'charset'=>$row['contentcharset'],
					'encoding'=>$row['contentencoding'],
				);
			}
		}
		return $attachments;
	}

	function save_module($module) {
		global $adb, $table_prefix;

		//crmv@44482 : check if saving in _crmentity has been successfully completed
		$result = $adb->pquery("SELECT crmid FROM {$table_prefix}_crmentity WHERE crmid = ?",array($this->id));
		if ($adb->num_rows($result) == 0) {
			throw new Exception('ERR_SAVING_IN_DB');
		}
		
		if (empty($this->column_fields['messageid'])) {
			require_once('modules/Emails/class.phpmailer.php');
			$mailer = new PHPMailer();
			$uniq_id = md5(uniqid(time()));
			$messageid = sprintf('<%s@%s>', $uniq_id, $mailer->ServerHostname());
			
			$adb->pquery("update {$this->table_name} set messageid = ? where {$this->table_name}.{$this->table_index} = ?", array($messageid, $this->id));
			$this->column_fields['messageid'] = $messageid;
		}

		//crmv@37004
		// save the hash when saving the record
		$hash = $this->getMessageHash();
		if ($hash && $this->id) {
			$adb->pquery("update {$this->table_name} set messagehash = ? where {$this->table_name}.{$this->table_index} = ?", array($hash, $this->id));
			$this->column_fields['messagehash'] = $hash;
		}
		//crmv@37004e

		// recover ModComments relations
		$result = $adb->pquery("SELECT {$this->relation_table_otherid} FROM {$this->relation_table} WHERE {$this->relation_table_id} = ? AND {$this->relation_table_othermodule} = ?",array($hash,'ModComments'));
		if ($result && $adb->num_rows($result) > 0) {
			$modcommentsid = $adb->query_result($result,0,$this->relation_table_otherid);
			$adb->pquery("update {$table_prefix}_modcomments set related_to = ? where modcommentsid = ?",array($this->id,$modcommentsid));
		}
		
		// thread
		if (empty($this->column_fields['mreferences']) && !empty($this->column_fields['in_reply_to'])) {
			$adb->pquery("update {$this->table_name} set mreferences = ? where {$this->table_name}.{$this->table_index} = ?", array($this->column_fields['in_reply_to'], $this->id));
			$this->column_fields['mreferences'] = $this->column_fields['in_reply_to'];
		}
		if ($this->column_fields['mtype'] == 'Webmail') {
			//$this->updateThreadCount($hash);
			$this->updateThreadCount();
		}

		// save attachments information
		if (!empty($this->column_fields['other'])) {
			if ($this->mode == 'edit') {
				$adb->pquery("delete from {$this->table_name}_attach where {$this->table_index} = ?",array($this->id));
			}
			foreach ($this->column_fields['other'] as $id => $content) {
				$adb->pquery("insert into {$this->table_name}_attach ({$this->table_index},contentid,content_id,contentname,contenttype,contentdisposition,contentcharset,contentencoding) values (?,?,?,?,?,?,?,?)",
					array($this->id,$id,$content['parameters']['content_id'],$content['parameters']['name'],$content['parameters']['contenttype'],$content['parameters']['contentdisposition'],$content['parameters']['charset'],$content['parameters']['encoding']));
			}
		}

		//crmv@46760
		if (isset($_FILES) && !empty($_FILES) && isset($_REQUEST['element'])){
			$elements = @Zend_Json::decode($_REQUEST['element']);
			if (isset($elements) && $elements['hasattachments'] == 'True' && $elements['external_plugin'] == 'true'){
				$files_arr = $_FILES;
				$contentid = 0;
				foreach($files_arr as $fileindex => $files){
					if($files['name'] != '' && $files['size'] > 0){
						$_FILES = Array();
						$_FILES['filename'] = $files;
						//TODO:check if other plugins than outlook put unique id before real name...
						if (strpos($files['name'],"_")!== false){
							$files['name'] = explode("_",$files['name'],2);
							$files['name'] = $files['name'][1];
						}
						// Create document record
						$document = CRMEntity::getInstance('Documents');
						$document->column_fields['notes_title']      = $files['name'];
						$document->column_fields['filelocationtype'] = 'I';
						$document->column_fields['folderid']         = 1; // Default Folder
						$document->column_fields['filestatus']         = 1; // Active
						$document->column_fields['assigned_user_id'] = $this->column_fields['assigned_user_id'];
						$document->parentid = $this->id;
						$document->save('Documents');
						$documentid = $document->id;
						if ($documentid != ''){
							$params = Array(
							$this->table_index=>$id,
								'messagesid'=>$this->id,
								'contentid'=>$contentid,
								'contentname'=>$files['name'],
								'contenttype'=>$files['type'],
								'contentdisposition'=>'external attachment',
								'document'=>$documentid
							);
							$sql = "insert into {$this->table_name}_attach (".implode(",",array_keys($params)).") values (".generateQuestionMarks($params).")";
							$adb->pquery($sql,$params);
						}
						$contentid++;
					}
				}
			}
		}
		//crmv@46760e

		// set recipients
		if (!empty($this->column_fields['recipients'])) {
			$adb->pquery("delete from {$table_prefix}_messages_recipients where messagesid = ?",array($this->id));
			$this->setRecipients($this->id,$this->column_fields['recipients']);
		}

		// set/update relations
		if (!empty($this->column_fields['parent_id'])) {
			$ids = array_filter(explode('|', $this->column_fields['parent_id']));
			foreach ($ids as $relid) {
				list($elid, $fieldid) = explode('@', $relid, 2);
				if (strpos($elid,'x') !== false) {
					$elid = explode('x',$elid);
					$elid = $elid[1];
				}
				$mod = getSalesEntityType($elid);
				if ($mod) {
					$this->save_related_module_small($messageid, $mod, $elid);
				}
			}
		}
	}
	
	function getParentMessage($id,$folder) {
		global $adb, $table_prefix;
		
		$focus = CRMEntity::getInstance('Messages');
		$focus->retrieve_entity_info_no_html($id,'Messages');
		
		if (!empty($focus->column_fields['mreferences'])) {
			if (preg_match_all('/<[^<>]+>/',$focus->column_fields['mreferences'],$matches) && !empty($matches[0])) {
				$references = $matches[0];
				foreach($references as $reference) {
					$hash = $this->getMessageHash($reference);
					$result = $adb->pquery("SELECT {$this->table_name}.{$this->table_index} FROM {$this->table_name}
											INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
											WHERE deleted = 0 AND smownerid = ? AND {$this->table_name}.folder = ? AND {$this->table_name}.messagehash = ?",
											array($focus->column_fields['assigned_user_id'],$folder,$hash));
					if ($result && $adb->num_rows($result)>0) {
						return $this->getParentMessage($adb->query_result($result,0,$this->table_index),$folder);
					}
				}
			}
		}
		return $id;
	}
	
	function updateThreadCount() {
		$folder = $this->column_fields['folder'];
		$father = $this->getParentMessage($this->id,$folder);
		$this->insertIntoTh($folder,$father,$this->id);
		$adopt_result = $this->adoptChildren($folder,$father);
		if (!$adopt_result && !empty($this->column_fields['mreferences'])) {
			$this->referenceChildren($folder,$this->column_fields['mreferences']);
			//TODO: $this->adoptReferenceChildren($folder,$this->column_fields['mreferences']);
		}
		$this->updateLastSon($folder);
	}
	
	function insertIntoTh($folder,$father,$son) {
		global $adb, $table_prefix;
		$adb->pquery("delete from {$table_prefix}_messages_th where folder = ? and father = ? and son = ?",array($folder,$son,$son));	//prevent duplicate rows (only 1 row for son)
		if ($adb->isMysql()) {
			$adb->pquery("insert ignore into {$table_prefix}_messages_th (folder,father,son) values (?,?,?)",array($folder,$father,$son));
		} else {
			$result = $adb->pquery("SELECT * FROM {$table_prefix}_messages_th
									WHERE {$table_prefix}_messages_th.folder = ? AND {$table_prefix}_messages_th.father = ? AND {$table_prefix}_messages_th.son = ?",
									array($folder,$father,$son));
			if (!$result || $adb->num_rows($result) == 0) {
				$adb->pquery("insert into {$table_prefix}_messages_th (folder,father,son) values (?,?,?)",array($folder,$father,$son));
			}
		}
	}

	function adoptChildren($folder,$id) {

		global $adb, $table_prefix;
		$messageid = '';
		$result = $adb->pquery("SELECT {$this->table_name}.messageid FROM {$this->table_name}
								INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
								WHERE deleted = 0 AND {$this->table_name}.{$this->table_index} = ?",array($id));
		if ($result && $adb->num_rows($result)>0) {
			$messageid = $adb->query_result($result,0,'messageid');
		}
		if (!empty($messageid)) {
			$result = $adb->pquery("SELECT messagesid FROM {$this->table_name}
									INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
									WHERE deleted = 0 AND smownerid = ? AND folder = ? AND mreferences LIKE ?",
									array($this->column_fields['assigned_user_id'],$folder,"%{$messageid}%"));
			if ($result && $adb->num_rows($result)>0) {
				while($row=$adb->fetchByAssoc($result)) {
					$adb->pquery("update {$table_prefix}_messages_th set father = ? where father = ?",array($id,$row['messagesid']));
				}
				return true;
			}
		}
		return false;
	}
	
	function updateLastSon($folder,$father='') {
		global $adb, $table_prefix;
		if (empty($father)) {
			$father = $this->getFather($this->id, $folder);
		}
		$children = $this->getChildren($father,$folder);
		if (!empty($children)) {
			global $adb, $table_prefix;
			$lastson = $children[0];
			if (!empty($lastson)) {
				$adb->pquery("update {$table_prefix}_messages set lastson = ? where messagesid = ?",array($lastson,$father));
			}
			$children = array_diff($children,array($father));
			if (!empty($children)) {
				$adb->pquery("update {$table_prefix}_messages set lastson = null where messagesid IN (".generateQuestionMarks($children).")",array($children));
			}
		}
	}
	
	function referenceChildren($folder,$mreferences) {
		// se trovo un Messaggio pi vecchio con reference simile al mio diventa mio padre
		global $adb, $table_prefix;
		$result = $adb->limitpQuery("SELECT {$this->table_index} FROM {$this->table_name}
									INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
									WHERE deleted = 0 AND smownerid = ? AND folder = ? AND mreferences LIKE ? AND {$this->table_name}.{$this->table_index} <> ? AND mdate < ?
									ORDER BY mdate DESC",0,1,
									array($this->column_fields['assigned_user_id'],$folder,"%{$mreferences}%",$this->id,$this->column_fields['mdate']));
		if ($result && $adb->num_rows($result)>0) {
			$messagesid = $adb->query_result($result,0,$this->table_index);
			$father = $this->getFather($messagesid, $folder);
			if (!empty($messagesid) && !empty($father)) {
				$this->insertIntoTh($folder,$father,$this->id);
			}
			return true;
		}
		return false;
	}
	/* TODO
	function adoptReferenceChildren($folder,$mreferences) {
		// se trovo Messaggi pi recenti con reference simile al mio diventano miei figli
		global $adb, $table_prefix;
		$result = $adb->pquery("SELECT {$this->table_index} FROM {$this->table_name}
								INNER JOIN {$this->entity_table} ON {$this->entity_table}.crmid = {$this->table_name}.{$this->table_index}
								WHERE deleted = 0 AND smownerid = ? AND folder = ? AND mreferences LIKE ? AND {$this->table_name}.{$this->table_index} <> ? AND mdate >= ?",
								array($this->column_fields['assigned_user_id'],$folder,"%{$mreferences}%",$this->id,$this->column_fields['mdate']));
		if ($result && $adb->num_rows($result)>0) {
			while ($row=$adb->fetchByAssoc($result)) {
				$messagesid = $row[$this->table_index];
				$father = $this->getFather($messagesid, $folder);
				if (!empty($messagesid) && !empty($father) && ($messagesid == $father)) {
					//delete vecchie righe...
					$this->insertIntoTh($folder,$this->id,$messagesid);
				}
			}
			return true;
		}
		return false;
	}
	*/	
	function getFather($record,$folder='') {
		global $adb, $table_prefix, $current_folder;
		if (empty($folder)) {
			$folder = $current_folder;
		}
		$query = "SELECT messageFather.messagesid
				FROM {$table_prefix}_messages_th
				INNER JOIN {$table_prefix}_messages messageSon ON messageSon.messagesid = {$table_prefix}_messages_th.son
				INNER JOIN {$this->entity_table} entitySon ON entitySon.crmid = messageSon.messagesid
				INNER JOIN {$table_prefix}_messages messageFather ON messageFather.messagesid = {$table_prefix}_messages_th.father
				INNER JOIN {$this->entity_table} entityFather ON entityFather.crmid = messageFather.messagesid
				WHERE entityFather.deleted = 0 AND entitySon.deleted = 0
				AND {$table_prefix}_messages_th.folder = ? AND messageSon.messagesid = ?";
		$result = $adb->pquery($query,array($folder,$record));
		if ($result && $adb->num_rows($result) > 0) {
			$father = $adb->query_result($result,0,'messagesid');
			return $father;
		}
		return false;
	}
	
	function getChildren($father,$folder='',$return_count=false,$select='') {
		global $adb, $table_prefix, $current_folder;
		if (empty($folder)) {
			$folder = $current_folder;
		}
		if (empty($select)) {
			$select = 'DISTINCT messageSon.messagesid';
		}
		$query = "SELECT $select as \"messagesid\"
				FROM {$table_prefix}_messages_th
				INNER JOIN {$table_prefix}_messages messageFather ON messageFather.messagesid = {$table_prefix}_messages_th.father
				INNER JOIN {$this->entity_table} entityFather ON entityFather.crmid = messageFather.messagesid
				INNER JOIN {$table_prefix}_messages messageSon ON messageSon.messagesid = {$table_prefix}_messages_th.son
				INNER JOIN {$this->entity_table} entitySon ON entitySon.crmid = messageSon.messagesid
				WHERE entityFather.deleted = 0 AND entitySon.deleted = 0
				AND {$table_prefix}_messages_th.folder = ? AND messageFather.messagesid = ?
				ORDER BY messageSon.mdate DESC";
		$result = $adb->pquery($query,array($folder,$father));
		$count = $adb->num_rows($result);
		if ($result && $count > 0) {
			if ($return_count) {
				return $count;
			} else {
				$children = array();
				while($row=$adb->fetchByAssoc($result)) {
					$children[] = $row['messagesid'];
				}
				return $children;
			}
		}
	}
	
	function getParents($record,$folder='') {
		$father = $this->getFather($record,$folder);
		if ($father) {
			$children = $this->getChildren($father,$folder);
			if (!empty($children)) {
				$children = array_diff($children,array($record));
				return $children;
			}
		}
		return false;
	}
	
	function appendMessage($sendmail, $account, $folder, $parentids='') {
		$this->setAccount($account);
		$specialFolders = $this->getSpecialFolders();
		$folder = $specialFolders[$folder];
		if (empty($folder)) {
			return false;
		}
		$this->getZendMailStorageImap();
		
		//crmv@34888
		$sendmail->error_count = 0; // reset errors
        $sendmail->SetMessageType();
        //crmv@34888e
		$sendmail->Mailer = 'sendmail';
		$header = str_replace("\n","\r\n",$sendmail->CreateHeader($sendmail->message_id));
		$body = str_replace("\n","\r\n",$sendmail->CreateBody());
				
		if (empty($body)) {
			$body = $sendmail->AltBody;
		}
		$message = "$header\r\n"."$body\r\n";
		$flags = array(Zend\Mail\Storage::FLAG_SEEN);
		
		try {
			self::$mail->appendMessage($message, $folder, $flags);
			// set/update relations
			if (!empty($parentids)) {
				$ids = array_filter(explode('|', $parentids));
				foreach ($ids as $relid) {
					list($elid, $fieldid) = explode('@', $relid, 2);
					if (strpos($elid,'x') !== false) {
						$elid = explode('x',$elid);
						$elid = $elid[1];
					}
					$mod = getSalesEntityType($elid);
					if ($mod) {
						$this->save_related_module_small($sendmail->message_id, $mod, $elid);
					}
				}
			}
			return true;
		} catch (Zend\Mail\Exception\RuntimeException $e) {
			return false;
		}
	}
	
	function moveMessage($folder,$skip_fetch=false) {
		parent::trash('Messages', $this->id);
		$this->addToPropagationCron('move', array(
			'userid'=>$this->column_fields['assigned_user_id'],
			'account'=>$this->column_fields['account'],
			'folder'=>$this->column_fields['folder'],
			'uid'=>$this->column_fields['xuid'],
			'new_folder'=>$folder,
			'skip_fetch'=>$skip_fetch
		));
	}
	
	function propagateMoveMessage($userid,$account,$folder,$uid,$new_folder,$skip_fetch=false) {
		$focus = CRMEntity::getInstance('Messages');
				
		$focus->setAccount($account);
		$focus->getZendMailStorageImap($userid);
		$focus->selectFolder($folder);
		self::$mail->moveMessage(self::$mail->getNumberByUniqueId($uid),$new_folder);

		//fetch new message from destination folder
		if (!$skip_fetch) {
			global $current_user;
			$tmp = $current_user->id;
			$current_user->id = $userid;
			
			$focus->fetchNews($new_folder);
			
			$current_user->id = $tmp;
		}
	}

	function massMoveMessage($account,$old_folder,$folder) {
		global $adb, $table_prefix, $currentModule, $current_user;
		$ids = getListViewCheck($currentModule);

		if (!empty($ids) && is_array($ids)) {
			$idstring = implode(',',$ids);
			$result = $adb->query("SELECT messagesid, xuid FROM {$this->table_name} WHERE messagesid in ({$idstring})");
			if ($result && $adb->num_rows($result) > 0) {
				while($row=$adb->fetchByAssoc($result)) {
					parent::trash('Messages', $row['messagesid']);
					$uids[] = $row['xuid'];
				}
				$this->addToPropagationCron('move_mass', array(
					'userid'=>$current_user->id,
					'account'=>$account,
					'folder'=>$old_folder,
					'uid'=>$uids,
					'new_folder'=>$folder,
				));
			}
		}
	}
	
	function propagateMassMoveMessage($userid,$account,$folder,$uids,$new_folder) {
		$focus = CRMEntity::getInstance('Messages');

		$focus->setAccount($account);
		$focus->getZendMailStorageImap($userid);
		$focus->selectFolder($folder);
		foreach($uids as $uid) {
			self::$mail->moveMessage(self::$mail->getNumberByUniqueId($uid),$new_folder);
		}
		
		global $current_user;
		$tmp = $current_user->id;
		$current_user->id = $userid;
		
		$focus->fetchNews($new_folder,count($uids));
		
		$current_user->id = $tmp;
	}
	
	function beforeTrashFunctions($record) {
		$focus = CRMEntity::getInstance('Messages');
		$focus->id = $record;
		$focus->retrieve_entity_info($record,'Messages');
		
		// functions
		$focus->removeFromThread();
	}
	
	function removeFromThread() {
		global $adb, $table_prefix;
		$record = $this->id;
		$folder = $this->column_fields['folder'];
		$father = $this->getFather($record,$folder);
		if (empty($father)) {
			$father = $record;
		}
		if ($record == $father) {
			$children = $this->getChildren($record,$folder);
			if (!empty($children)) {
				// delete _messages_th
				$adb->pquery("delete from {$table_prefix}_messages_th where father = ? and folder = ? and son = ?",array($record,$folder,$record));
				// if it has children, set new father and reload lastson
				if (count($children) > 1) {
					$newfather = $children[count($children)-2];
					$adb->pquery("update {$table_prefix}_messages_th set father = ? where folder = ? and father = ?",array($newfather,$folder,$record));
					$this->updateLastSon($folder,$newfather);
				}
			}
		} else {
			// if it is son, delete from _messages_th and reload lastson
			$adb->pquery("delete from {$table_prefix}_messages_th where father = ? and folder = ? and son = ?",array($father,$folder,$record));
			$this->updateLastSon($folder,$father);
		}
	}
	
	function getNonAdminAccessControlQuery($module,$user,$scope='',$join_cond=''){
		return '';
	}
	
	//crmv@47243
	function getNonAdminUserAccessQuery($user,$parentRole,$userGroups){
		global $table_prefix;
		$query = "select id from (SELECT id from ".$table_prefix."_users where id = '$user->id'";
		return $query;
	}
	//crmv@47243e
	
	function getQueryExtraJoin() {
		global $adb, $current_folder, $current_user;
		$sql = $query = '';
		if ($current_folder == 'Shared') {
			$query = $this->getRelatedModComments(true);
		}
		if (!empty($query)) {
			$tableName = 'vt_tmp_s_'.$current_user->id;
			if ($adb->isMysql()) {
				$query = "create temporary table IF NOT EXISTS $tableName(id int(11) primary key) ignore ".$query;
				$result = $adb->query($query);
			} else {
				if (!$adb->table_exist($tableName,true)){
					Vtiger_Utils::CreateTable($tableName,"id I(11) NOTNULL PRIMARY",true,true);
				}
				$tableName = $adb->datadict->changeTableName($tableName);
				$query = "insert into $tableName $query where not exists (select * from $tableName where $tableName.id = un_table.id)";
				$result = $adb->query($query);
			}
			$sql = " INNER JOIN $tableName ON $tableName.id = {$this->table_name}.{$this->table_index}";
		}
		return $sql;
	}
	
	function getQueryExtraWhere() {
		global $current_account, $current_folder, $current_user, $thread;
		$sql = '';
		if ($current_folder == 'Links') {
			$sql .= " and {$this->table_name}.mtype = 'Link'";
			$sql .= " and {$this->entity_table}.smownerid = {$current_user->id}";
		} elseif ($current_folder == 'Shared') {
			// do nothing, checks done in getQueryExtraJoin
		} elseif (!empty($current_folder)) {
			$account_condition = " and {$this->table_name}.account = '{$current_account}'";
			if ($current_folder == 'Flagged') {
				$sql .= " and {$this->table_name}.flagged = 1";
			} else {
				if ($current_account == 'all') {
					$folders = $this->getAllSpecialFolders('INBOX');
					$tmp = array();
					foreach($folders as $account => $folder) {
						$tmp[] = "({$this->table_name}.account = '{$account}' AND {$this->table_name}.folder = '{$folder['INBOX']}')";
					}
					$account_condition = ' AND ('.implode(' OR ',$tmp).')';
				} else {
					$sql .= " and {$this->table_name}.folder = '$current_folder'";
				}
			}
			$sql .= " and {$this->entity_table}.smownerid = {$current_user->id}";
			$sql .= " and {$this->table_name}.mtype = 'Webmail'";
		}
		$sql .= $account_condition;
		if (!empty($thread)) {
			$children = $this->getChildren($thread);
			if (!empty($children)) {
				$sql .= " and {$this->table_name}.messagesid in (".implode(',',$children).")";
			} else {
				$sql .= " and {$this->table_name}.messagesid in (0)";	//force empty list
			}
		}
		return trim($sql);
	}
	
	//crmv@47243
	function getAdvancedPermissionFunction($is_admin,$module,$actionname,$record_id='') {
		if (in_array($actionname,array('Import','Export','Merge','DuplicatesHandling'))) {
			return 'no';
		} elseif (in_array($actionname,array('PopupDetailForm'))) {	// real check done in the file
			return 'yes';
		}
		if (!$is_admin && !empty($record_id)) {	//crmv@44747: give to admin all permissions for workflow
			global $current_user, $adb, $table_prefix;
			
			$mtype = getSingleFieldValue($table_prefix.'_messages', 'mvisibility', 'messagesid', $record_id);
			if ($mtype == 'Public') {
				//echo 'public';
				return 'yes';
			}
			
			$account = getSingleFieldValue($table_prefix.'_messages', 'account', 'messagesid', $record_id);
			$this->setAccount($account);
			if (in_array($record_id,$this->getRelatedModComments())) {
				//echo 'conversazione';
				return 'yes';
			}
			
			$tabid = getTabid($module);
			
			// check owner
			$tableName = 'vt_tmp_u'.$current_user->id;
			$sharingRuleInfoVariable = $module.'_share_read_permission';
			$sharingRuleInfo = $$sharingRuleInfoVariable;
			if(!empty($sharingRuleInfo) && (count($sharingRuleInfo['ROLE']) > 0 ||
					count($sharingRuleInfo['GROUP']) > 0
					 || count($sharingRuleInfo['USR']) > 0)) {
				$tableName = $tableName.'_t'.$tabid;
			}elseif(!empty($scope)) {
				$tableName .= '_t'.$tabid;
			}
			$this->setupTemporaryTable($tableName, $tabid, $current_user, '', '');
			$result = $adb->pquery("select id from $tableName where id = ?",array(getSingleFieldValue($table_prefix.'_crmentity', 'smownerid', 'crmid', $record_id)));
			if ($result && $adb->num_rows($result) > 0) {
				//echo 'owner '.getSingleFieldValue($table_prefix.'_crmentity', 'smownerid', 'crmid', $record_id);
				return 'yes';
			}
			
			$defOrgSharingPermission = getAllDefaultSharingAction();
			if ($defOrgSharingPermission[$tabid] != 3) {
				$rm = RelationManager::getInstance();
				$relIds = $rm->getRelatedIds($module,$record_id);
				foreach($relIds as $id) {
					$m = getSalesEntityType($id);
					if (isPermitted($m, 'DetailView', $id) == 'yes') {
						//echo 'ereditato '.$defOrgSharingPermission[$tabid];
						return 'yes';
					}
				}
			}
			
			return 'no';
		}
	}
	//crmv@47243e
	
	/*
	 * $params : array width column_fields of message
	 * ex. $params = array('subject'=>'Test','description'=>'test message','mto'=>'to@domain.com','mfrom'=>'from@domain.org',...);
	 * NB. you can also relate message to records by $params['parent_id'] (permitted formats: 12, 3x12, 3x12|3x14, 12@200|14@202)
	 * 
	 * TODO : gestire l'invio di allegati passando in send_mail_attachment una stringa o un array di percorsi di file da inviare
	 */
	function send($params,$append=true) {
		$mail_tmp = (!empty($params['mail_tmp']) ? $params['mail_tmp'] : '');
		$mail_status = send_mail(
			'Emails',
			$params['mto'],
			(!empty($params['mfrom_n']) ? $params['mfrom_n'] : $params['mfrom']),
			$params['mfrom'],
			$params['subject'],
			$params['description'],
			$params['mcc'],
			$params['mbcc'],
			(!empty($params['send_mail_attachment']) ? $params['send_mail_attachment'] : 'all'),
			(!empty($params['send_mail_emailid']) ? $params['send_mail_emailid'] : 0),
			(!empty($params['send_mail_logo']) ? $params['send_mail_logo'] : ''),
			(!empty($params['send_mail_newsletter_params']) ? $params['send_mail_newsletter_params'] : ''),
			$mail_tmp,
			(!empty($params['send_mail_messageid']) ? $params['send_mail_messageid'] : ''),
			(!empty($params['send_mail_message_mode']) ? $params['send_mail_message_mode'] : '')
		);
		if ($append) {
			$append_status = false;
	
			$mainAccount = $this->getMainUserAccount();
			$account = (!empty($params['account']) ? $params['account'] : $mainAccount['id']);
			
			if ($mail_status == 1 && !empty($account)) {
				try {
					$append_status = append_mail(
						$mail_tmp,
						$account,
						$params['parent_id'],
						$params['mto'],
						(!empty($params['mfrom_n']) ? $params['mfrom_n'] : $params['mfrom']),
						$params['mfrom'],
						$params['subject'],
						$params['description'],
						$params['mcc'],
						$params['mbcc']
					);
				} catch (Exception $e) {
					//echo $e->getMessage()."\n";
				}
			}
			if ($append_status === false) {
				$focus = CRMentity::getInstance('Messages');
				$focus->saveCacheLink($params);
			}
		}
	}
	
	function setRecipients($messagesid,$recipientids) {
		global $adb, $table_prefix;
		if (!is_array($recipientids)) {
			$recipientids = explode('|',$recipientids);
		}
		$recipientids = array_filter($recipientids);
		if (!empty($recipientids)) {
			foreach ($recipientids as $relid) {
				list($elid, $fieldid) = explode('@', $relid, 2);
				// check existence
				$r = $adb->pquery("select messagesid from {$table_prefix}_messages_recipients where messagesid = ? and id = ? and fieldid = ?",array($messagesid,$elid,$fieldid));
				if ($r && $adb->num_rows($r) == 0) {
					$adb->pquery("insert into {$table_prefix}_messages_recipients (messagesid,id,fieldid) values (?,?,?)",array($messagesid,$elid,$fieldid));
				}
			}
		}
	}
	
	function getRecipients($format='array') {
		global $adb, $table_prefix;
		$recipientids = array();
		$result = $adb->pquery("select id, fieldid from {$table_prefix}_messages_recipients where messagesid = ?",array($this->id));
		if($result && $adb->num_rows($result)) {
			while($row=$adb->fetchByAssoc($result)) {
				$recipientids[] = $row['id'].'@'.$row['fieldid'];
			}
		}
		if ($format == 'string') {
			return implode('|',$recipientids);
		} else {
			return $recipientids;
		}
	}
	
	function setSendMode($messagesid,$send_mode) {
		global $adb, $table_prefix;
		$adb->pquery("update {$table_prefix}_messages set send_mode = ? where messagesid = ?",array($send_mode,$messagesid));
	}
	
	function setVisibility($messagesid,$visibility) {
		global $adb, $table_prefix;
		$adb->pquery("update {$table_prefix}_messages set mvisibility = ? where messagesid = ?",array($visibility,$messagesid));
	}
	
	function checkThreadFlag($flag,$id,$thread) {
		//TODO do a unique query and cache values
		global $current_account, $current_folder, $current_user, $adb, $table_prefix;
		if ($flag == 'unseen') {
			$condition = 'AND seen = 0';
		} elseif ($flag == 'flagged') {
			$condition = 'AND flagged = 1';
		}
		$query = "select messagesid
				from {$table_prefix}_messages
				inner join {$table_prefix}_crmentity ON {$table_prefix}_crmentity.crmid = {$table_prefix}_messages.messagesid
				where deleted = 0 ".$condition;
		$children = $this->getChildren($thread,'',false,'distinct messageSon.messagehash');
		$query .= " and {$this->relation_table_id} in (".generateQuestionMarks($children).")";
		$params = array($children);
		if ($current_account != 'all') {
			$query .= " and account = ?";
			$params[] = $current_account;
		}
		$query .= " and folder = ? and smownerid = ?";
		$params[] = array($current_folder,$current_user->id);
		$result = $adb->pquery($query,$params);
		if ($result && $adb->num_rows($result) > 0) {
			return true;
		}
		return false;
	}
	
	//crmv@48693
	function getAdvancedSearchOptionString($old_mode=false,&$controller,&$queryGenerator) {
		$module = $queryGenerator->getModule();
		$meta = $queryGenerator->getMeta($module);
		$moduleFields = $meta->getModuleFields();
		$i =0;
		foreach ($moduleFields as $fieldName=>$field) {
			if(!in_array($field->getPresence(), array('0','2'))){
				continue;
			}
			if(!in_array($fieldName, array('subject','description','mdate','seen'))){
				continue;
			}
			if($field->getFieldDataType() == 'reference' || $field->getFieldDataType() == 'owner') {
				$typeOfData = 'V';
			} else if($field->getFieldDataType() == 'boolean') {
				$typeOfData = 'C';
			} else {
				$typeOfData = $field->getTypeOfData();
				$typeOfData = explode("~",$typeOfData);
				$typeOfData = $typeOfData[0];
			}
			$label = getTranslatedString($field->getFieldLabelKey(), $module);
			if(empty($label)) {
				$label = $field->getFieldLabelKey();
			}
			$selected = '';
			if($i++ == 0) {
				$selected = "selected";
			}
			// place option in array for sorting later
			if ($old_mode){
				$tableName = $field->getTableName();
				$columnName = $field->getColumnName();
				$OPTION_SET[$fieldName] = "<option value=\'$tableName.$columnName::::$typeOfData\' $selected>$label</option>";
			}
			else
				$OPTION_SET[$fieldName] = "<option value=\'$fieldName::::$typeOfData\' $selected>$label</option>";
		}
		if (!is_array($OPTION_SET)) return '';
		
		$options = array(
			"<option value=\'senders::::V\'>".getTranslatedString('Senders','Messages')."</option>",
			"<option value=\'recipients::::V\'>".getTranslatedString('Recipients','Messages')."</option>",
			$OPTION_SET['subject'],
			$OPTION_SET['description'],
			$OPTION_SET['mdate'],
			$OPTION_SET['seen'],
			// TODO	"<option value=\'links::::C\'>".getTranslatedString('LBL_FLAG_LINK','Messages')."</option>",
		);
		return implode('',$options);
	}
	
	function addUserSearchConditions($input,&$queryGenerator) {
		global $log,$default_charset;
		if($input['searchtype']=='advance') {
			if(empty($input['search_cnt'])) {
				return ;
			}
			$noOfConditions = vtlib_purify($input['search_cnt']);
			if($input['matchtype'] == 'all') {
				$matchType = $queryGenerator::$AND;
			} else {
				$matchType = $queryGenerator::$OR;
			}
			if($queryGenerator->getconditionInstanceCount() > 0) {
				$queryGenerator->startGroup($queryGenerator::$AND);
			} else {
				$queryGenerator->startGroup('');
			}
			for($i=0; $i<$noOfConditions; $i++) {
				$fieldInfo = 'Fields'.$i;
				$condition = 'Condition'.$i;
				$value = 'Srch_value'.$i;

				list($fieldName,$typeOfData) = explode("::::",str_replace('\'','',
						stripslashes($input[$fieldInfo])));
				$moduleFields = $queryGenerator->getModuleFields();
				$field = $moduleFields[$fieldName];
				
				if (in_array($fieldName,array('senders','recipients'))) {
					$whereFields = $queryGenerator->getWhereFields();
					if(($i-1) >= 0 && !empty($whereFields)) {
						$queryGenerator->addConditionGlue($matchType);
					}
					$operator = str_replace('\'','',stripslashes($input[$condition]));
					$searchValue = $input[$value];
					$searchValue = function_exists(iconv) ? @iconv("UTF-8",$default_charset,
							$searchValue) : $searchValue;
					if (in_array($operator,array('n','k'))) {
						$intertnalGlue = $queryGenerator::$AND;
					} elseif (in_array($operator,array('e','s','ew','c'))) {
						$intertnalGlue = $queryGenerator::$OR;
					}
					$queryGenerator->startGroup('');
					if ($fieldName == 'senders') {
						$queryGenerator->addCondition('mfrom', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mfrom_n', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mfrom_f', $searchValue, $operator);
					} elseif ($fieldName == 'recipients') {
						$queryGenerator->addCondition('mto', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mto_n', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mto_f', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mcc', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mcc_n', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mcc_f', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mbcc', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mbcc_n', $searchValue, $operator);
						$queryGenerator->addConditionGlue($intertnalGlue);
						$queryGenerator->addCondition('mbcc_f', $searchValue, $operator);
					}
					$queryGenerator->endGroup();
				/* TODO
				} elseif ($fieldName == 'links') {
					$operator = str_replace('\'','',stripslashes($input[$condition]));
					$searchValue = $input[$value];
					$searchValue = function_exists(iconv) ? @iconv("UTF-8",$default_charset,
							$searchValue) : $searchValue;
					$subselectCondition = '';
					if (($operator == 'e' && $searchValue == 'Yes') || ($operator == 'n' && $searchValue == 'No')) {
						$subselectCondition = 'in';
					} elseif (($operator == 'n' && $searchValue == 'Yes') || ($operator == 'e' && $searchValue == 'No')) {
						$subselectCondition = 'not in';
					}
					if (!empty($subselectCondition)) {
						$whereFields = $queryGenerator->getWhereFields();
						if(($i-1) >= 0 && !empty($whereFields)) {
							$queryGenerator->addConditionGlue($matchType);
						}
						global $table_prefix;
						$sql = "{$table_prefix}_messages.messagehash $subselectCondition (select messagehash from {$table_prefix}_messagesrel)";
						$queryGenerator->appendToWhereClause($sql);
					}
				*/
				} elseif ($fieldName == 'mdate') {
					if (!$field)
						continue;
					$type = $field->getFieldDataType();
					$whereFields = $queryGenerator->getWhereFields();
					if(($i-1) >= 0 && !empty($whereFields)) {
						$queryGenerator->addConditionGlue($matchType);
					}
					$operator = str_replace('\'','',stripslashes($input[$condition]));
					if (in_array($operator,array('custom','yesterday','today','lastweek','thisweek','lastmonth','thismonth','last60days','last90days'))) {
						$searchValue = $input[$value];
						$searchValue = function_exists(iconv) ? @iconv("UTF-8",$default_charset,
							$searchValue) : $searchValue;
						list($start,$end) = explode('|##|',$searchValue);
						if (strlen($start) == 10) $start .= ' 00:00:00';
						if (strlen($end) == 10) $end .= ' 23:59:59';
						$queryGenerator->startGroup('');
						$queryGenerator->addCondition('mdate', $start, 'h');
						$queryGenerator->addConditionGlue($queryGenerator::$AND);
						$queryGenerator->addCondition('mdate', $end, 'm');
						$queryGenerator->endGroup();
					} else {
						$searchValue = $input[$value];
						$searchValue = function_exists(iconv) ? @iconv("UTF-8",$default_charset,
								$searchValue) : $searchValue;
						$queryGenerator->addCondition($fieldName, $searchValue, $operator);
					}
				} else {
					if (!$field)
						continue;
					$type = $field->getFieldDataType();
					$whereFields = $queryGenerator->getWhereFields();
					if(($i-1) >= 0 && !empty($whereFields)) {
						$queryGenerator->addConditionGlue($matchType);
					}
					$operator = str_replace('\'','',stripslashes($input[$condition]));
					$searchValue = $input[$value];
					$searchValue = function_exists(iconv) ? @iconv("UTF-8",$default_charset,
							$searchValue) : $searchValue;
					$queryGenerator->addCondition($fieldName, $searchValue, $operator);
				}
			}
			$queryGenerator->endGroup();
		} else {
			return 'continue';
		}
	}
	
	function getAdvCriteriaJS() {
		
		$today = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d"), date("Y")));
		$tomorrow  = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+1, date("Y")));
		$yesterday  = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-1, date("Y")));

		$currentmonth0 = date("Y-m-d",mktime(0, 0, 0, date("m"), "01",   date("Y")));
		$currentmonth1 = date("Y-m-t");
		$lastmonth0 = date("Y-m-d",mktime(0, 0, 0, date("m")-1, "01",   date("Y")));
		$lastmonth1 = date("Y-m-t", strtotime("-1 Month"));
		$nextmonth0 = date("Y-m-d",mktime(0, 0, 0, date("m")+1, "01",   date("Y")));
		$nextmonth1 = date("Y-m-t", strtotime("+1 Month"));

		$lastweek0 = date("Y-m-d",strtotime("-2 week Sunday"));
		$lastweek1 = date("Y-m-d",strtotime("-1 week Saturday"));

		$thisweek0 = date("Y-m-d",strtotime("-1 week Sunday"));
		$thisweek1 = date("Y-m-d",strtotime("this Saturday"));

		$nextweek0 = date("Y-m-d",strtotime("this Sunday"));
		$nextweek1 = date("Y-m-d",strtotime("+1 week Saturday"));

		$next7days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+6, date("Y")));
		$next30days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+29, date("Y")));
		$next60days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+59, date("Y")));
		$next90days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+89, date("Y")));
		$next120days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+119, date("Y")));

		$last7days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-6, date("Y")));
		$last30days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-29, date("Y")));
		$last60days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-59, date("Y")));
		$last90days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-89, date("Y")));
		$last120days = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-119, date("Y")));

		$currentFY0 = date("Y-m-d",mktime(0, 0, 0, "01", "01",   date("Y")));
		$currentFY1 = date("Y-m-t",mktime(0, 0, 0, "12", date("d"),   date("Y")));
		$lastFY0 = date("Y-m-d",mktime(0, 0, 0, "01", "01",   date("Y")-1));
		$lastFY1 = date("Y-m-t", mktime(0, 0, 0, "12", date("d"), date("Y")-1));

		$nextFY0 = date("Y-m-d",mktime(0, 0, 0, "01", "01",   date("Y")+1));
		$nextFY1 = date("Y-m-t", mktime(0, 0, 0, "12", date("d"), date("Y")+1));

		if(date("m") <= 3)
		{
			$cFq = date("Y-m-d",mktime(0, 0, 0, "01","01",date("Y")));
			$cFq1 = date("Y-m-d",mktime(0, 0, 0, "03","31",date("Y")));
			$nFq = date("Y-m-d",mktime(0, 0, 0, "04","01",date("Y")));
			$nFq1 = date("Y-m-d",mktime(0, 0, 0, "06","30",date("Y")));
			$pFq = date("Y-m-d",mktime(0, 0, 0, "10","01",date("Y")-1));
			$pFq1 = date("Y-m-d",mktime(0, 0, 0, "12","31",date("Y")-1));
		}
		else if(date("m") > 3 and date("m") <= 6)
		{
			$pFq = date("Y-m-d",mktime(0, 0, 0, "01","01",date("Y")));
			$pFq1 = date("Y-m-d",mktime(0, 0, 0, "03","31",date("Y")));
			$cFq = date("Y-m-d",mktime(0, 0, 0, "04","01",date("Y")));
			$cFq1 = date("Y-m-d",mktime(0, 0, 0, "06","30",date("Y")));
			$nFq = date("Y-m-d",mktime(0, 0, 0, "07","01",date("Y")));
			$nFq1 = date("Y-m-d",mktime(0, 0, 0, "09","30",date("Y")));
		}
		else if(date("m") > 6 and date("m") <= 9)
		{
			$nFq = date("Y-m-d",mktime(0, 0, 0, "10","01",date("Y")));
			$nFq1 = date("Y-m-d",mktime(0, 0, 0, "12","31",date("Y")));
			$pFq = date("Y-m-d",mktime(0, 0, 0, "04","01",date("Y")));
			$pFq1 = date("Y-m-d",mktime(0, 0, 0, "06","30",date("Y")));
			$cFq = date("Y-m-d",mktime(0, 0, 0, "07","01",date("Y")));
			$cFq1 = date("Y-m-d",mktime(0, 0, 0, "09","30",date("Y")));
		}
		else if(date("m") > 9 and date("m") <= 12)
		{
			$nFq = date("Y-m-d",mktime(0, 0, 0, "01","01",date("Y")+1));
			$nFq1 = date("Y-m-d",mktime(0, 0, 0, "03","31",date("Y")+1));
			$pFq = date("Y-m-d",mktime(0, 0, 0, "07","01",date("Y")));
			$pFq1 = date("Y-m-d",mktime(0, 0, 0, "09","30",date("Y")));
			$cFq = date("Y-m-d",mktime(0, 0, 0, "10","01",date("Y")));
			$cFq1 = date("Y-m-d",mktime(0, 0, 0, "12","31",date("Y")));
		}
		$date_format = parse_calendardate($app_strings['NTC_DATE_FORMAT']);
		$sjsStr = '<script language="JavaScript" type="text/javaScript">
			var js_date_format = "'.$date_format.'";
			function showADvSearchDateRange(index, type)
			{
				if (type!="custom")
				{
					document.advSearch.elements["startdate"+index].readOnly=true;
					document.advSearch.elements["enddate"+index].readOnly=true;
					getObj("jscal_trigger_date_start"+index).style.visibility="hidden";
					getObj("jscal_trigger_date_end"+index).style.visibility="hidden";
				}
				else
				{
					document.advSearch.elements["startdate"+index].readOnly=false;
					document.advSearch.elements["enddate"+index].readOnly=false;
					getObj("jscal_trigger_date_start"+index).style.visibility="visible";
					getObj("jscal_trigger_date_end"+index).style.visibility="visible";
				}
				if( type == "today" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($today).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($today).'";
				}
				else if( type == "yesterday" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($yesterday).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($yesterday).'";
				}
				else if( type == "tomorrow" )
				{

					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($tomorrow).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($tomorrow).'";
				}
				else if( type == "thisweek" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($thisweek0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($thisweek1).'";
				}
				else if( type == "lastweek" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($lastweek0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($lastweek1).'";
				}
				else if( type == "nextweek" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($nextweek0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($nextweek1).'";
				}
				else if( type == "thismonth" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($currentmonth0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($currentmonth1).'";
				}
				else if( type == "lastmonth" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($lastmonth0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($lastmonth1).'";
				}
				else if( type == "nextmonth" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($nextmonth0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($nextmonth1).'";
				}
				else if( type == "next7days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($today).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($next7days).'";
				}
				else if( type == "next30days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($today).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($next30days).'";
				}
				else if( type == "next60days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($today).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($next60days).'";
				}
				else if( type == "next90days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($today).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($next90days).'";
				}
				else if( type == "next120days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($today).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($next120days).'";
				}
				else if( type == "last7days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($last7days).'";
					document.advSearch.elements["enddate"+index].value =  "'.getDisplayDate($today).'";
				}
				else if( type == "last30days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($last30days).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($today).'";
				}
				else if( type == "last60days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($last60days).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($today).'";
				}
				else if( type == "last90days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($last90days).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($today).'";
				}
				else if( type == "last120days" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($last120days).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($today).'";
				}
				else if( type == "thisfy" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($currentFY0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($currentFY1).'";
				}
				else if( type == "prevfy" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($lastFY0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($lastFY1).'";
				}
				else if( type == "nextfy" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($nextFY0).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($nextFY1).'";
				}
				else if( type == "nextfq" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($nFq).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($nFq1).'";
				}
				else if( type == "prevfq" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($pFq).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($pFq1).'";
				}
				else if( type == "thisfq" )
				{
					document.advSearch.elements["startdate"+index].value = "'.getDisplayDate($cFq).'";
					document.advSearch.elements["enddate"+index].value = "'.getDisplayDate($cFq1).'";
				}
				else
				{
					document.advSearch.elements["startdate"+index].value = "";
					document.advSearch.elements["enddate"+index].value = "";
				}
				setAdvSearchIntervalDateValue(index);
			}
		</script>';
		return $sjsStr;
	}
	//crmv@48693e
}
?>