<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/

global $currentModule, $current_user, $root_directory, $adb, $table_prefix;
$record = vtlib_purify($_REQUEST['record']);	// message record
$contentid = vtlib_purify($_REQUEST['contentid']);	// attachment id
$linkto = vtlib_purify($_REQUEST['linkto']);
$linkto_module = vtlib_purify($_REQUEST['linkto_module']);

$focus = CRMEntity::getInstance($currentModule);

// If contentid has been already converted in Document we use the existing Document
$documentid = '';
$result = $adb->pquery("SELECT {$table_prefix}_messages_attach.document FROM {$table_prefix}_messages_attach
						INNER JOIN {$table_prefix}_crmentity ON {$table_prefix}_crmentity.crmid = {$table_prefix}_messages_attach.document
						WHERE deleted = 0 AND {$table_prefix}_messages_attach.messagesid = ? AND {$table_prefix}_messages_attach.contentid = ?",
						array($record,$contentid));
if ($result && $adb->num_rows($result) > 0) {
	$documentid = $adb->query_result($result,0,'document');
}
if (empty($documentid)) {
	$focus->retrieve_entity_info($record,$currentModule);
	$uid = $focus->column_fields['xuid'];
	$folder = $focus->column_fields['folder'];

	$focus->getZendMailStorageImap();
	$focus->selectFolder($folder);

	$messageId = $focus->getMailResource()->getNumberByUniqueId($uid);
	$message = $focus->getMailResource()->getMessage($messageId);
	$parts = $focus->getMessageContentParts($message,$id);
	if (!empty($parts['other'][$contentid])) {
		$content = $parts['other'][$contentid];
		$parameters = $content['parameters'];

		$str = $content['content'];
		$str = $focus->decodeAttachment($str,$parameters['encoding'],$parameters['charset']);

		$filename = $parameters['name'];
		$current_id = $adb->getUniqueID($table_prefix."_crmentity");
		$date_var = date('Y-m-d H:i:s');
		$upload_file_path = decideFilePath();
		$fp = fopen($root_directory.$upload_file_path.$current_id."_".$filename, 'wb');
		fwrite($fp,$str,strlen($str));
		fclose ($fp);

		$sql1 = "insert into ".$table_prefix."_crmentity (crmid,smcreatorid,smownerid,setype,createdtime,modifiedtime) values(?,?,?,?,?,?)";
		$params1 = array($current_id, $current_user->id, $current_user->id, "Documents Attachment", $adb->formatDate($date_var, true), $adb->formatDate($date_var, true));
		$adb->pquery($sql1, $params1);

		$sql2="insert into ".$table_prefix."_attachments(attachmentsid, name, type, path) values(?,?,?,?)";
		$params2 = array($current_id, $filename, $parameters['contenttype'], $upload_file_path);
		$adb->pquery($sql2, $params2);

		// Create document record
		$document = CRMEntity::getInstance('Documents');
		$document->column_fields['notes_title']      = $filename;
		$document->column_fields['filename']         = $filename;
		$document->column_fields['filestatus']       = 1;
		$document->column_fields['filelocationtype'] = 'I';
		$document->column_fields['folderid']         = 1; // Default Folder
		$document->column_fields['assigned_user_id'] = $current_user->id;
		$document->column_fields['filesize'] = 0;
		$document->save('Documents');
		$documentid = $document->id;

		// Link file attached to document
		$adb->pquery("INSERT INTO ".$table_prefix."_seattachmentsrel(crmid, attachmentsid) VALUES(?,?)",Array($documentid, $current_id));

		// Link documentid to the real attachment for faster next relations
		$adb->pquery("update {$table_prefix}_messages_attach set document = ? where messagesid = ? and contentid = ?",array($documentid, $record, $contentid));
	}
}
// crmv@42752

if (!empty($linkto)) {
	// Link document to linkto
	$focus2 = CRMEntity::getInstance($linkto_module);
	$focus2->save_related_module($linkto_module, $linkto, 'Documents', $documentid);
}
// Link document to message in any case
$focus->save_related_module($currentModule, $record, 'Documents', $documentid);
// crmv@42752e

die('SUCCESS');
?>