<?php
/*+*******************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ********************************************************************************/

/** Load the configuration file common to cron tasks. */
require_once('cron/config.cron.php');
global $VTIGER_CRON_CONFIGURATION;

/** 
 * To make sure we can work with command line and direct browser invocation.
 */
if($argv) {
	if(!isset($_REQUEST)) $_REQUEST = Array();

	for($index = 0; $index < count($argv); ++$index) {
		$value = $argv[$index];
		if(strpos($value, '=') === false) continue;

		$keyval = explode('=', $value);
		if(!isset($_REQUEST[$keyval[0]])) {
			$_REQUEST[$keyval[0]] = $keyval[1];
		}
	}
	
	/* If app_key is not set, pick the value from cron configuration */
	if(empty($_REQUEST['app_key'])) $_REQUEST['app_key'] = $VTIGER_CRON_CONFIGURATION['app_key'];
}

/** All service invocation needs have valid app_key parameter sent */
require_once('config.inc.php');

/** Verify the script call is from trusted place. */
global $application_unique_key;
if($_REQUEST['app_key'] != $application_unique_key) {
	echo "Access denied!";
	exit;
}

/** Include the service file */
//crmv@39086
require_once('include/utils/utils.php');
$service = vtlib_purify($_REQUEST['service']);
$service_file = '';
switch ($service) {
	case 'MailScanner':
		$service_file = 'cron/MailScanner.service';
		break;
	case 'RecurringInvoice':
		$service_file = 'cron/modules/SalesOrder/RecurringInvoice.service';
		break;
	/*
	case 'SendReminder':
		$service_file = 'cron/modules/Calendar/SendReminder.service';
		break;
	*/
	case 'ScheduledImport':
		$service_file = 'cron/modules/Import/ScheduledImport.service.php';
		break;
	case 'com_vtiger_workflow':
	//case 'VtigerBackup':
		$service_file = "cron/modules/$service/$service.service";
		break;
	case 'Pop3':
	case 'Inbox':
	case 'PropagateToImap':
	case 'SendMessages':
		$service_file = "cron/modules/Messages/$service.service.php";
		break;
	default:
		if (file_exists("cron/modules/$service/$service.service.php")) {
			$service_file = "cron/modules/$service/$service.service.php";
		}
		break;
}
if (!empty($service_file)) {
	include_once($service_file);
} else {
	echo "Missing service file!";
	exit;
}
//crmv@39086e
?>